/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/

#ifndef RADAR_IC_H
#define RADAR_IC_H 

/* I N C L U D E S ***********************************************************/
#include <project.h>
    
    
/* C O N S T A N T S *********************************************************/ 
    
#define LNA_GAIN_MASK           0x8000  // Enable Low Noise Amplifier Gain Reduction
#define POWR_AMP_DISABLE_MASK   0x1000  // Disable Power Amplifier
#define HI_LOSC_BUFFER_MASK     0x0010  // High Local Oscillator buffer output power - should be low    
#define HI_TX_BUF_MASK          0x0008  // High Transmit buffer output power - default to low   
    
#define ANA_VOUT_TX             0x0000  // Analog Output is Vout,TX
#define ANA_VREF_TX             0x0080  // Analog Output is Vref,TX
#define ANA_VOUT_LO             0x0100  // Analog Output is Vout,LO
#define ANA_VREF_LO             0x0180  // Analog Output is Vref,LO
#define ANA_TEMP                0x2000  // Enable Analog Mux Controller Bit 2
#define TX_ENABLE               0x0000  // Enable the transmitter 
#define TX_DISABLE              0x1000  // Disable the transmitter
#define TX_POWER_MAX            0x0000  // Maximum transmit power (no reduction)
#define TX_POWER_MID            0x0003  // Half transmit power (half reduction)
#define TX_POWER_MIN            0x0007  // Minimum transmit power (full reduction)
#define DIV64_DISABLE_MASK      0x0040  // Disable Divide by 16 
    
// Intial radar settings with TX Enable, max power, analog temperature out    
#define TX_ON           (ANA_VOUT_TX | TX_ENABLE | TX_POWER_MAX )
#define TX_OFF          (ANA_VOUT_TX | TX_DISABLE | TX_POWER_MAX )
#define REF_POWER_OUT   (ANA_VREF_TX | TX_ENABLE | TX_POWER_MAX )
#define TX_POWER_OUT    TX_ON

    
/* F U N C T I O N  P R O T O T Y P E S **************************************/
unsigned char BGT_Init(uint8);  
unsigned char BGT_WriteReg(uint16, uint8);
double GetTxPower(uint8);
    
#endif

/* [] END OF FILE */
