/*******************************************************************************
* File Name: ClockIn.h  
* Version 2.20
*
* Description:
*  This file contains Pin function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_ClockIn_H) /* Pins ClockIn_H */
#define CY_PINS_ClockIn_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "ClockIn_aliases.h"

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 ClockIn__PORT == 15 && ((ClockIn__MASK & 0xC0) != 0))


/***************************************
*        Function Prototypes             
***************************************/    

/**
* \addtogroup group_general
* @{
*/
void    ClockIn_Write(uint8 value);
void    ClockIn_SetDriveMode(uint8 mode);
uint8   ClockIn_ReadDataReg(void);
uint8   ClockIn_Read(void);
void    ClockIn_SetInterruptMode(uint16 position, uint16 mode);
uint8   ClockIn_ClearInterrupt(void);
/** @} general */

/***************************************
*           API Constants        
***************************************/
/**
* \addtogroup group_constants
* @{
*/
    /** \addtogroup driveMode Drive mode constants
     * \brief Constants to be passed as "mode" parameter in the ClockIn_SetDriveMode() function.
     *  @{
     */
        #define ClockIn_DM_ALG_HIZ         PIN_DM_ALG_HIZ
        #define ClockIn_DM_DIG_HIZ         PIN_DM_DIG_HIZ
        #define ClockIn_DM_RES_UP          PIN_DM_RES_UP
        #define ClockIn_DM_RES_DWN         PIN_DM_RES_DWN
        #define ClockIn_DM_OD_LO           PIN_DM_OD_LO
        #define ClockIn_DM_OD_HI           PIN_DM_OD_HI
        #define ClockIn_DM_STRONG          PIN_DM_STRONG
        #define ClockIn_DM_RES_UPDWN       PIN_DM_RES_UPDWN
    /** @} driveMode */
/** @} group_constants */
    
/* Digital Port Constants */
#define ClockIn_MASK               ClockIn__MASK
#define ClockIn_SHIFT              ClockIn__SHIFT
#define ClockIn_WIDTH              1u

/* Interrupt constants */
#if defined(ClockIn__INTSTAT)
/**
* \addtogroup group_constants
* @{
*/
    /** \addtogroup intrMode Interrupt constants
     * \brief Constants to be passed as "mode" parameter in ClockIn_SetInterruptMode() function.
     *  @{
     */
        #define ClockIn_INTR_NONE      (uint16)(0x0000u)
        #define ClockIn_INTR_RISING    (uint16)(0x0001u)
        #define ClockIn_INTR_FALLING   (uint16)(0x0002u)
        #define ClockIn_INTR_BOTH      (uint16)(0x0003u) 
    /** @} intrMode */
/** @} group_constants */

    #define ClockIn_INTR_MASK      (0x01u) 
#endif /* (ClockIn__INTSTAT) */


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define ClockIn_PS                     (* (reg8 *) ClockIn__PS)
/* Data Register */
#define ClockIn_DR                     (* (reg8 *) ClockIn__DR)
/* Port Number */
#define ClockIn_PRT_NUM                (* (reg8 *) ClockIn__PRT) 
/* Connect to Analog Globals */                                                  
#define ClockIn_AG                     (* (reg8 *) ClockIn__AG)                       
/* Analog MUX bux enable */
#define ClockIn_AMUX                   (* (reg8 *) ClockIn__AMUX) 
/* Bidirectional Enable */                                                        
#define ClockIn_BIE                    (* (reg8 *) ClockIn__BIE)
/* Bit-mask for Aliased Register Access */
#define ClockIn_BIT_MASK               (* (reg8 *) ClockIn__BIT_MASK)
/* Bypass Enable */
#define ClockIn_BYP                    (* (reg8 *) ClockIn__BYP)
/* Port wide control signals */                                                   
#define ClockIn_CTL                    (* (reg8 *) ClockIn__CTL)
/* Drive Modes */
#define ClockIn_DM0                    (* (reg8 *) ClockIn__DM0) 
#define ClockIn_DM1                    (* (reg8 *) ClockIn__DM1)
#define ClockIn_DM2                    (* (reg8 *) ClockIn__DM2) 
/* Input Buffer Disable Override */
#define ClockIn_INP_DIS                (* (reg8 *) ClockIn__INP_DIS)
/* LCD Common or Segment Drive */
#define ClockIn_LCD_COM_SEG            (* (reg8 *) ClockIn__LCD_COM_SEG)
/* Enable Segment LCD */
#define ClockIn_LCD_EN                 (* (reg8 *) ClockIn__LCD_EN)
/* Slew Rate Control */
#define ClockIn_SLW                    (* (reg8 *) ClockIn__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define ClockIn_PRTDSI__CAPS_SEL       (* (reg8 *) ClockIn__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define ClockIn_PRTDSI__DBL_SYNC_IN    (* (reg8 *) ClockIn__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define ClockIn_PRTDSI__OE_SEL0        (* (reg8 *) ClockIn__PRTDSI__OE_SEL0) 
#define ClockIn_PRTDSI__OE_SEL1        (* (reg8 *) ClockIn__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define ClockIn_PRTDSI__OUT_SEL0       (* (reg8 *) ClockIn__PRTDSI__OUT_SEL0) 
#define ClockIn_PRTDSI__OUT_SEL1       (* (reg8 *) ClockIn__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define ClockIn_PRTDSI__SYNC_OUT       (* (reg8 *) ClockIn__PRTDSI__SYNC_OUT) 

/* SIO registers */
#if defined(ClockIn__SIO_CFG)
    #define ClockIn_SIO_HYST_EN        (* (reg8 *) ClockIn__SIO_HYST_EN)
    #define ClockIn_SIO_REG_HIFREQ     (* (reg8 *) ClockIn__SIO_REG_HIFREQ)
    #define ClockIn_SIO_CFG            (* (reg8 *) ClockIn__SIO_CFG)
    #define ClockIn_SIO_DIFF           (* (reg8 *) ClockIn__SIO_DIFF)
#endif /* (ClockIn__SIO_CFG) */

/* Interrupt Registers */
#if defined(ClockIn__INTSTAT)
    #define ClockIn_INTSTAT            (* (reg8 *) ClockIn__INTSTAT)
    #define ClockIn_SNAP               (* (reg8 *) ClockIn__SNAP)
    
	#define ClockIn_0_INTTYPE_REG 		(* (reg8 *) ClockIn__0__INTTYPE)
#endif /* (ClockIn__INTSTAT) */

#endif /* CY_PSOC5A... */

#endif /*  CY_PINS_ClockIn_H */


/* [] END OF FILE */
