/*******************************************************************************
* File Name: GPIO1.h  
* Version 1.90
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_GPIO1_H) /* Pins GPIO1_H */
#define CY_PINS_GPIO1_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "GPIO1_aliases.h"

/* Check to see if required defines such as CY_PSOC5A are available */
/* They are defined starting with cy_boot v3.0 */
#if !defined (CY_PSOC5A)
    #error Component cy_pins_v1_90 requires cy_boot v3.0 or later
#endif /* (CY_PSOC5A) */

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 GPIO1__PORT == 15 && ((GPIO1__MASK & 0xC0) != 0))


/***************************************
*        Function Prototypes             
***************************************/    

void    GPIO1_Write(uint8 value) ;
void    GPIO1_SetDriveMode(uint8 mode) ;
uint8   GPIO1_ReadDataReg(void) ;
uint8   GPIO1_Read(void) ;
uint8   GPIO1_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define GPIO1_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define GPIO1_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define GPIO1_DM_RES_UP          PIN_DM_RES_UP
#define GPIO1_DM_RES_DWN         PIN_DM_RES_DWN
#define GPIO1_DM_OD_LO           PIN_DM_OD_LO
#define GPIO1_DM_OD_HI           PIN_DM_OD_HI
#define GPIO1_DM_STRONG          PIN_DM_STRONG
#define GPIO1_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define GPIO1_MASK               GPIO1__MASK
#define GPIO1_SHIFT              GPIO1__SHIFT
#define GPIO1_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define GPIO1_PS                     (* (reg8 *) GPIO1__PS)
/* Data Register */
#define GPIO1_DR                     (* (reg8 *) GPIO1__DR)
/* Port Number */
#define GPIO1_PRT_NUM                (* (reg8 *) GPIO1__PRT) 
/* Connect to Analog Globals */                                                  
#define GPIO1_AG                     (* (reg8 *) GPIO1__AG)                       
/* Analog MUX bux enable */
#define GPIO1_AMUX                   (* (reg8 *) GPIO1__AMUX) 
/* Bidirectional Enable */                                                        
#define GPIO1_BIE                    (* (reg8 *) GPIO1__BIE)
/* Bit-mask for Aliased Register Access */
#define GPIO1_BIT_MASK               (* (reg8 *) GPIO1__BIT_MASK)
/* Bypass Enable */
#define GPIO1_BYP                    (* (reg8 *) GPIO1__BYP)
/* Port wide control signals */                                                   
#define GPIO1_CTL                    (* (reg8 *) GPIO1__CTL)
/* Drive Modes */
#define GPIO1_DM0                    (* (reg8 *) GPIO1__DM0) 
#define GPIO1_DM1                    (* (reg8 *) GPIO1__DM1)
#define GPIO1_DM2                    (* (reg8 *) GPIO1__DM2) 
/* Input Buffer Disable Override */
#define GPIO1_INP_DIS                (* (reg8 *) GPIO1__INP_DIS)
/* LCD Common or Segment Drive */
#define GPIO1_LCD_COM_SEG            (* (reg8 *) GPIO1__LCD_COM_SEG)
/* Enable Segment LCD */
#define GPIO1_LCD_EN                 (* (reg8 *) GPIO1__LCD_EN)
/* Slew Rate Control */
#define GPIO1_SLW                    (* (reg8 *) GPIO1__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define GPIO1_PRTDSI__CAPS_SEL       (* (reg8 *) GPIO1__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define GPIO1_PRTDSI__DBL_SYNC_IN    (* (reg8 *) GPIO1__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define GPIO1_PRTDSI__OE_SEL0        (* (reg8 *) GPIO1__PRTDSI__OE_SEL0) 
#define GPIO1_PRTDSI__OE_SEL1        (* (reg8 *) GPIO1__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define GPIO1_PRTDSI__OUT_SEL0       (* (reg8 *) GPIO1__PRTDSI__OUT_SEL0) 
#define GPIO1_PRTDSI__OUT_SEL1       (* (reg8 *) GPIO1__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define GPIO1_PRTDSI__SYNC_OUT       (* (reg8 *) GPIO1__PRTDSI__SYNC_OUT) 


#if defined(GPIO1__INTSTAT)  /* Interrupt Registers */

    #define GPIO1_INTSTAT                (* (reg8 *) GPIO1__INTSTAT)
    #define GPIO1_SNAP                   (* (reg8 *) GPIO1__SNAP)

#endif /* Interrupt Registers */

#endif /* CY_PSOC5A... */

#endif /*  CY_PINS_GPIO1_H */


/* [] END OF FILE */
