/*******************************************************************************
* File Name: GPIO3.h  
* Version 2.20
*
* Description:
*  This file contains Pin function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_GPIO3_H) /* Pins GPIO3_H */
#define CY_PINS_GPIO3_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "GPIO3_aliases.h"

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 GPIO3__PORT == 15 && ((GPIO3__MASK & 0xC0) != 0))


/***************************************
*        Function Prototypes             
***************************************/    

/**
* \addtogroup group_general
* @{
*/
void    GPIO3_Write(uint8 value);
void    GPIO3_SetDriveMode(uint8 mode);
uint8   GPIO3_ReadDataReg(void);
uint8   GPIO3_Read(void);
void    GPIO3_SetInterruptMode(uint16 position, uint16 mode);
uint8   GPIO3_ClearInterrupt(void);
/** @} general */

/***************************************
*           API Constants        
***************************************/
/**
* \addtogroup group_constants
* @{
*/
    /** \addtogroup driveMode Drive mode constants
     * \brief Constants to be passed as "mode" parameter in the GPIO3_SetDriveMode() function.
     *  @{
     */
        #define GPIO3_DM_ALG_HIZ         PIN_DM_ALG_HIZ
        #define GPIO3_DM_DIG_HIZ         PIN_DM_DIG_HIZ
        #define GPIO3_DM_RES_UP          PIN_DM_RES_UP
        #define GPIO3_DM_RES_DWN         PIN_DM_RES_DWN
        #define GPIO3_DM_OD_LO           PIN_DM_OD_LO
        #define GPIO3_DM_OD_HI           PIN_DM_OD_HI
        #define GPIO3_DM_STRONG          PIN_DM_STRONG
        #define GPIO3_DM_RES_UPDWN       PIN_DM_RES_UPDWN
    /** @} driveMode */
/** @} group_constants */
    
/* Digital Port Constants */
#define GPIO3_MASK               GPIO3__MASK
#define GPIO3_SHIFT              GPIO3__SHIFT
#define GPIO3_WIDTH              1u

/* Interrupt constants */
#if defined(GPIO3__INTSTAT)
/**
* \addtogroup group_constants
* @{
*/
    /** \addtogroup intrMode Interrupt constants
     * \brief Constants to be passed as "mode" parameter in GPIO3_SetInterruptMode() function.
     *  @{
     */
        #define GPIO3_INTR_NONE      (uint16)(0x0000u)
        #define GPIO3_INTR_RISING    (uint16)(0x0001u)
        #define GPIO3_INTR_FALLING   (uint16)(0x0002u)
        #define GPIO3_INTR_BOTH      (uint16)(0x0003u) 
    /** @} intrMode */
/** @} group_constants */

    #define GPIO3_INTR_MASK      (0x01u) 
#endif /* (GPIO3__INTSTAT) */


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define GPIO3_PS                     (* (reg8 *) GPIO3__PS)
/* Data Register */
#define GPIO3_DR                     (* (reg8 *) GPIO3__DR)
/* Port Number */
#define GPIO3_PRT_NUM                (* (reg8 *) GPIO3__PRT) 
/* Connect to Analog Globals */                                                  
#define GPIO3_AG                     (* (reg8 *) GPIO3__AG)                       
/* Analog MUX bux enable */
#define GPIO3_AMUX                   (* (reg8 *) GPIO3__AMUX) 
/* Bidirectional Enable */                                                        
#define GPIO3_BIE                    (* (reg8 *) GPIO3__BIE)
/* Bit-mask for Aliased Register Access */
#define GPIO3_BIT_MASK               (* (reg8 *) GPIO3__BIT_MASK)
/* Bypass Enable */
#define GPIO3_BYP                    (* (reg8 *) GPIO3__BYP)
/* Port wide control signals */                                                   
#define GPIO3_CTL                    (* (reg8 *) GPIO3__CTL)
/* Drive Modes */
#define GPIO3_DM0                    (* (reg8 *) GPIO3__DM0) 
#define GPIO3_DM1                    (* (reg8 *) GPIO3__DM1)
#define GPIO3_DM2                    (* (reg8 *) GPIO3__DM2) 
/* Input Buffer Disable Override */
#define GPIO3_INP_DIS                (* (reg8 *) GPIO3__INP_DIS)
/* LCD Common or Segment Drive */
#define GPIO3_LCD_COM_SEG            (* (reg8 *) GPIO3__LCD_COM_SEG)
/* Enable Segment LCD */
#define GPIO3_LCD_EN                 (* (reg8 *) GPIO3__LCD_EN)
/* Slew Rate Control */
#define GPIO3_SLW                    (* (reg8 *) GPIO3__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define GPIO3_PRTDSI__CAPS_SEL       (* (reg8 *) GPIO3__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define GPIO3_PRTDSI__DBL_SYNC_IN    (* (reg8 *) GPIO3__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define GPIO3_PRTDSI__OE_SEL0        (* (reg8 *) GPIO3__PRTDSI__OE_SEL0) 
#define GPIO3_PRTDSI__OE_SEL1        (* (reg8 *) GPIO3__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define GPIO3_PRTDSI__OUT_SEL0       (* (reg8 *) GPIO3__PRTDSI__OUT_SEL0) 
#define GPIO3_PRTDSI__OUT_SEL1       (* (reg8 *) GPIO3__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define GPIO3_PRTDSI__SYNC_OUT       (* (reg8 *) GPIO3__PRTDSI__SYNC_OUT) 

/* SIO registers */
#if defined(GPIO3__SIO_CFG)
    #define GPIO3_SIO_HYST_EN        (* (reg8 *) GPIO3__SIO_HYST_EN)
    #define GPIO3_SIO_REG_HIFREQ     (* (reg8 *) GPIO3__SIO_REG_HIFREQ)
    #define GPIO3_SIO_CFG            (* (reg8 *) GPIO3__SIO_CFG)
    #define GPIO3_SIO_DIFF           (* (reg8 *) GPIO3__SIO_DIFF)
#endif /* (GPIO3__SIO_CFG) */

/* Interrupt Registers */
#if defined(GPIO3__INTSTAT)
    #define GPIO3_INTSTAT            (* (reg8 *) GPIO3__INTSTAT)
    #define GPIO3_SNAP               (* (reg8 *) GPIO3__SNAP)
    
	#define GPIO3_0_INTTYPE_REG 		(* (reg8 *) GPIO3__0__INTTYPE)
#endif /* (GPIO3__INTSTAT) */

#endif /* CY_PSOC5A... */

#endif /*  CY_PINS_GPIO3_H */


/* [] END OF FILE */
