/*******************************************************************************
* File Name: GPIO5.h  
* Version 2.20
*
* Description:
*  This file contains Pin function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_GPIO5_H) /* Pins GPIO5_H */
#define CY_PINS_GPIO5_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "GPIO5_aliases.h"

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 GPIO5__PORT == 15 && ((GPIO5__MASK & 0xC0) != 0))


/***************************************
*        Function Prototypes             
***************************************/    

/**
* \addtogroup group_general
* @{
*/
void    GPIO5_Write(uint8 value);
void    GPIO5_SetDriveMode(uint8 mode);
uint8   GPIO5_ReadDataReg(void);
uint8   GPIO5_Read(void);
void    GPIO5_SetInterruptMode(uint16 position, uint16 mode);
uint8   GPIO5_ClearInterrupt(void);
/** @} general */

/***************************************
*           API Constants        
***************************************/
/**
* \addtogroup group_constants
* @{
*/
    /** \addtogroup driveMode Drive mode constants
     * \brief Constants to be passed as "mode" parameter in the GPIO5_SetDriveMode() function.
     *  @{
     */
        #define GPIO5_DM_ALG_HIZ         PIN_DM_ALG_HIZ
        #define GPIO5_DM_DIG_HIZ         PIN_DM_DIG_HIZ
        #define GPIO5_DM_RES_UP          PIN_DM_RES_UP
        #define GPIO5_DM_RES_DWN         PIN_DM_RES_DWN
        #define GPIO5_DM_OD_LO           PIN_DM_OD_LO
        #define GPIO5_DM_OD_HI           PIN_DM_OD_HI
        #define GPIO5_DM_STRONG          PIN_DM_STRONG
        #define GPIO5_DM_RES_UPDWN       PIN_DM_RES_UPDWN
    /** @} driveMode */
/** @} group_constants */
    
/* Digital Port Constants */
#define GPIO5_MASK               GPIO5__MASK
#define GPIO5_SHIFT              GPIO5__SHIFT
#define GPIO5_WIDTH              1u

/* Interrupt constants */
#if defined(GPIO5__INTSTAT)
/**
* \addtogroup group_constants
* @{
*/
    /** \addtogroup intrMode Interrupt constants
     * \brief Constants to be passed as "mode" parameter in GPIO5_SetInterruptMode() function.
     *  @{
     */
        #define GPIO5_INTR_NONE      (uint16)(0x0000u)
        #define GPIO5_INTR_RISING    (uint16)(0x0001u)
        #define GPIO5_INTR_FALLING   (uint16)(0x0002u)
        #define GPIO5_INTR_BOTH      (uint16)(0x0003u) 
    /** @} intrMode */
/** @} group_constants */

    #define GPIO5_INTR_MASK      (0x01u) 
#endif /* (GPIO5__INTSTAT) */


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define GPIO5_PS                     (* (reg8 *) GPIO5__PS)
/* Data Register */
#define GPIO5_DR                     (* (reg8 *) GPIO5__DR)
/* Port Number */
#define GPIO5_PRT_NUM                (* (reg8 *) GPIO5__PRT) 
/* Connect to Analog Globals */                                                  
#define GPIO5_AG                     (* (reg8 *) GPIO5__AG)                       
/* Analog MUX bux enable */
#define GPIO5_AMUX                   (* (reg8 *) GPIO5__AMUX) 
/* Bidirectional Enable */                                                        
#define GPIO5_BIE                    (* (reg8 *) GPIO5__BIE)
/* Bit-mask for Aliased Register Access */
#define GPIO5_BIT_MASK               (* (reg8 *) GPIO5__BIT_MASK)
/* Bypass Enable */
#define GPIO5_BYP                    (* (reg8 *) GPIO5__BYP)
/* Port wide control signals */                                                   
#define GPIO5_CTL                    (* (reg8 *) GPIO5__CTL)
/* Drive Modes */
#define GPIO5_DM0                    (* (reg8 *) GPIO5__DM0) 
#define GPIO5_DM1                    (* (reg8 *) GPIO5__DM1)
#define GPIO5_DM2                    (* (reg8 *) GPIO5__DM2) 
/* Input Buffer Disable Override */
#define GPIO5_INP_DIS                (* (reg8 *) GPIO5__INP_DIS)
/* LCD Common or Segment Drive */
#define GPIO5_LCD_COM_SEG            (* (reg8 *) GPIO5__LCD_COM_SEG)
/* Enable Segment LCD */
#define GPIO5_LCD_EN                 (* (reg8 *) GPIO5__LCD_EN)
/* Slew Rate Control */
#define GPIO5_SLW                    (* (reg8 *) GPIO5__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define GPIO5_PRTDSI__CAPS_SEL       (* (reg8 *) GPIO5__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define GPIO5_PRTDSI__DBL_SYNC_IN    (* (reg8 *) GPIO5__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define GPIO5_PRTDSI__OE_SEL0        (* (reg8 *) GPIO5__PRTDSI__OE_SEL0) 
#define GPIO5_PRTDSI__OE_SEL1        (* (reg8 *) GPIO5__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define GPIO5_PRTDSI__OUT_SEL0       (* (reg8 *) GPIO5__PRTDSI__OUT_SEL0) 
#define GPIO5_PRTDSI__OUT_SEL1       (* (reg8 *) GPIO5__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define GPIO5_PRTDSI__SYNC_OUT       (* (reg8 *) GPIO5__PRTDSI__SYNC_OUT) 

/* SIO registers */
#if defined(GPIO5__SIO_CFG)
    #define GPIO5_SIO_HYST_EN        (* (reg8 *) GPIO5__SIO_HYST_EN)
    #define GPIO5_SIO_REG_HIFREQ     (* (reg8 *) GPIO5__SIO_REG_HIFREQ)
    #define GPIO5_SIO_CFG            (* (reg8 *) GPIO5__SIO_CFG)
    #define GPIO5_SIO_DIFF           (* (reg8 *) GPIO5__SIO_DIFF)
#endif /* (GPIO5__SIO_CFG) */

/* Interrupt Registers */
#if defined(GPIO5__INTSTAT)
    #define GPIO5_INTSTAT            (* (reg8 *) GPIO5__INTSTAT)
    #define GPIO5_SNAP               (* (reg8 *) GPIO5__SNAP)
    
	#define GPIO5_0_INTTYPE_REG 		(* (reg8 *) GPIO5__0__INTTYPE)
#endif /* (GPIO5__INTSTAT) */

#endif /* CY_PSOC5A... */

#endif /*  CY_PINS_GPIO5_H */


/* [] END OF FILE */
