/*******************************************************************************
* File Name: GPIO6.h  
* Version 2.20
*
* Description:
*  This file contains Pin function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_GPIO6_H) /* Pins GPIO6_H */
#define CY_PINS_GPIO6_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "GPIO6_aliases.h"

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 GPIO6__PORT == 15 && ((GPIO6__MASK & 0xC0) != 0))


/***************************************
*        Function Prototypes             
***************************************/    

/**
* \addtogroup group_general
* @{
*/
void    GPIO6_Write(uint8 value);
void    GPIO6_SetDriveMode(uint8 mode);
uint8   GPIO6_ReadDataReg(void);
uint8   GPIO6_Read(void);
void    GPIO6_SetInterruptMode(uint16 position, uint16 mode);
uint8   GPIO6_ClearInterrupt(void);
/** @} general */

/***************************************
*           API Constants        
***************************************/
/**
* \addtogroup group_constants
* @{
*/
    /** \addtogroup driveMode Drive mode constants
     * \brief Constants to be passed as "mode" parameter in the GPIO6_SetDriveMode() function.
     *  @{
     */
        #define GPIO6_DM_ALG_HIZ         PIN_DM_ALG_HIZ
        #define GPIO6_DM_DIG_HIZ         PIN_DM_DIG_HIZ
        #define GPIO6_DM_RES_UP          PIN_DM_RES_UP
        #define GPIO6_DM_RES_DWN         PIN_DM_RES_DWN
        #define GPIO6_DM_OD_LO           PIN_DM_OD_LO
        #define GPIO6_DM_OD_HI           PIN_DM_OD_HI
        #define GPIO6_DM_STRONG          PIN_DM_STRONG
        #define GPIO6_DM_RES_UPDWN       PIN_DM_RES_UPDWN
    /** @} driveMode */
/** @} group_constants */
    
/* Digital Port Constants */
#define GPIO6_MASK               GPIO6__MASK
#define GPIO6_SHIFT              GPIO6__SHIFT
#define GPIO6_WIDTH              1u

/* Interrupt constants */
#if defined(GPIO6__INTSTAT)
/**
* \addtogroup group_constants
* @{
*/
    /** \addtogroup intrMode Interrupt constants
     * \brief Constants to be passed as "mode" parameter in GPIO6_SetInterruptMode() function.
     *  @{
     */
        #define GPIO6_INTR_NONE      (uint16)(0x0000u)
        #define GPIO6_INTR_RISING    (uint16)(0x0001u)
        #define GPIO6_INTR_FALLING   (uint16)(0x0002u)
        #define GPIO6_INTR_BOTH      (uint16)(0x0003u) 
    /** @} intrMode */
/** @} group_constants */

    #define GPIO6_INTR_MASK      (0x01u) 
#endif /* (GPIO6__INTSTAT) */


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define GPIO6_PS                     (* (reg8 *) GPIO6__PS)
/* Data Register */
#define GPIO6_DR                     (* (reg8 *) GPIO6__DR)
/* Port Number */
#define GPIO6_PRT_NUM                (* (reg8 *) GPIO6__PRT) 
/* Connect to Analog Globals */                                                  
#define GPIO6_AG                     (* (reg8 *) GPIO6__AG)                       
/* Analog MUX bux enable */
#define GPIO6_AMUX                   (* (reg8 *) GPIO6__AMUX) 
/* Bidirectional Enable */                                                        
#define GPIO6_BIE                    (* (reg8 *) GPIO6__BIE)
/* Bit-mask for Aliased Register Access */
#define GPIO6_BIT_MASK               (* (reg8 *) GPIO6__BIT_MASK)
/* Bypass Enable */
#define GPIO6_BYP                    (* (reg8 *) GPIO6__BYP)
/* Port wide control signals */                                                   
#define GPIO6_CTL                    (* (reg8 *) GPIO6__CTL)
/* Drive Modes */
#define GPIO6_DM0                    (* (reg8 *) GPIO6__DM0) 
#define GPIO6_DM1                    (* (reg8 *) GPIO6__DM1)
#define GPIO6_DM2                    (* (reg8 *) GPIO6__DM2) 
/* Input Buffer Disable Override */
#define GPIO6_INP_DIS                (* (reg8 *) GPIO6__INP_DIS)
/* LCD Common or Segment Drive */
#define GPIO6_LCD_COM_SEG            (* (reg8 *) GPIO6__LCD_COM_SEG)
/* Enable Segment LCD */
#define GPIO6_LCD_EN                 (* (reg8 *) GPIO6__LCD_EN)
/* Slew Rate Control */
#define GPIO6_SLW                    (* (reg8 *) GPIO6__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define GPIO6_PRTDSI__CAPS_SEL       (* (reg8 *) GPIO6__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define GPIO6_PRTDSI__DBL_SYNC_IN    (* (reg8 *) GPIO6__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define GPIO6_PRTDSI__OE_SEL0        (* (reg8 *) GPIO6__PRTDSI__OE_SEL0) 
#define GPIO6_PRTDSI__OE_SEL1        (* (reg8 *) GPIO6__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define GPIO6_PRTDSI__OUT_SEL0       (* (reg8 *) GPIO6__PRTDSI__OUT_SEL0) 
#define GPIO6_PRTDSI__OUT_SEL1       (* (reg8 *) GPIO6__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define GPIO6_PRTDSI__SYNC_OUT       (* (reg8 *) GPIO6__PRTDSI__SYNC_OUT) 

/* SIO registers */
#if defined(GPIO6__SIO_CFG)
    #define GPIO6_SIO_HYST_EN        (* (reg8 *) GPIO6__SIO_HYST_EN)
    #define GPIO6_SIO_REG_HIFREQ     (* (reg8 *) GPIO6__SIO_REG_HIFREQ)
    #define GPIO6_SIO_CFG            (* (reg8 *) GPIO6__SIO_CFG)
    #define GPIO6_SIO_DIFF           (* (reg8 *) GPIO6__SIO_DIFF)
#endif /* (GPIO6__SIO_CFG) */

/* Interrupt Registers */
#if defined(GPIO6__INTSTAT)
    #define GPIO6_INTSTAT            (* (reg8 *) GPIO6__INTSTAT)
    #define GPIO6_SNAP               (* (reg8 *) GPIO6__SNAP)
    
	#define GPIO6_0_INTTYPE_REG 		(* (reg8 *) GPIO6__0__INTTYPE)
#endif /* (GPIO6__INTSTAT) */

#endif /* CY_PSOC5A... */

#endif /*  CY_PINS_GPIO6_H */


/* [] END OF FILE */
