/*******************************************************************************
* File Name: Iantenna.h  
* Version 2.20
*
* Description:
*  This file contains Pin function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_Iantenna_H) /* Pins Iantenna_H */
#define CY_PINS_Iantenna_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "Iantenna_aliases.h"

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 Iantenna__PORT == 15 && ((Iantenna__MASK & 0xC0) != 0))


/***************************************
*        Function Prototypes             
***************************************/    

/**
* \addtogroup group_general
* @{
*/
void    Iantenna_Write(uint8 value);
void    Iantenna_SetDriveMode(uint8 mode);
uint8   Iantenna_ReadDataReg(void);
uint8   Iantenna_Read(void);
void    Iantenna_SetInterruptMode(uint16 position, uint16 mode);
uint8   Iantenna_ClearInterrupt(void);
/** @} general */

/***************************************
*           API Constants        
***************************************/
/**
* \addtogroup group_constants
* @{
*/
    /** \addtogroup driveMode Drive mode constants
     * \brief Constants to be passed as "mode" parameter in the Iantenna_SetDriveMode() function.
     *  @{
     */
        #define Iantenna_DM_ALG_HIZ         PIN_DM_ALG_HIZ
        #define Iantenna_DM_DIG_HIZ         PIN_DM_DIG_HIZ
        #define Iantenna_DM_RES_UP          PIN_DM_RES_UP
        #define Iantenna_DM_RES_DWN         PIN_DM_RES_DWN
        #define Iantenna_DM_OD_LO           PIN_DM_OD_LO
        #define Iantenna_DM_OD_HI           PIN_DM_OD_HI
        #define Iantenna_DM_STRONG          PIN_DM_STRONG
        #define Iantenna_DM_RES_UPDWN       PIN_DM_RES_UPDWN
    /** @} driveMode */
/** @} group_constants */
    
/* Digital Port Constants */
#define Iantenna_MASK               Iantenna__MASK
#define Iantenna_SHIFT              Iantenna__SHIFT
#define Iantenna_WIDTH              1u

/* Interrupt constants */
#if defined(Iantenna__INTSTAT)
/**
* \addtogroup group_constants
* @{
*/
    /** \addtogroup intrMode Interrupt constants
     * \brief Constants to be passed as "mode" parameter in Iantenna_SetInterruptMode() function.
     *  @{
     */
        #define Iantenna_INTR_NONE      (uint16)(0x0000u)
        #define Iantenna_INTR_RISING    (uint16)(0x0001u)
        #define Iantenna_INTR_FALLING   (uint16)(0x0002u)
        #define Iantenna_INTR_BOTH      (uint16)(0x0003u) 
    /** @} intrMode */
/** @} group_constants */

    #define Iantenna_INTR_MASK      (0x01u) 
#endif /* (Iantenna__INTSTAT) */


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define Iantenna_PS                     (* (reg8 *) Iantenna__PS)
/* Data Register */
#define Iantenna_DR                     (* (reg8 *) Iantenna__DR)
/* Port Number */
#define Iantenna_PRT_NUM                (* (reg8 *) Iantenna__PRT) 
/* Connect to Analog Globals */                                                  
#define Iantenna_AG                     (* (reg8 *) Iantenna__AG)                       
/* Analog MUX bux enable */
#define Iantenna_AMUX                   (* (reg8 *) Iantenna__AMUX) 
/* Bidirectional Enable */                                                        
#define Iantenna_BIE                    (* (reg8 *) Iantenna__BIE)
/* Bit-mask for Aliased Register Access */
#define Iantenna_BIT_MASK               (* (reg8 *) Iantenna__BIT_MASK)
/* Bypass Enable */
#define Iantenna_BYP                    (* (reg8 *) Iantenna__BYP)
/* Port wide control signals */                                                   
#define Iantenna_CTL                    (* (reg8 *) Iantenna__CTL)
/* Drive Modes */
#define Iantenna_DM0                    (* (reg8 *) Iantenna__DM0) 
#define Iantenna_DM1                    (* (reg8 *) Iantenna__DM1)
#define Iantenna_DM2                    (* (reg8 *) Iantenna__DM2) 
/* Input Buffer Disable Override */
#define Iantenna_INP_DIS                (* (reg8 *) Iantenna__INP_DIS)
/* LCD Common or Segment Drive */
#define Iantenna_LCD_COM_SEG            (* (reg8 *) Iantenna__LCD_COM_SEG)
/* Enable Segment LCD */
#define Iantenna_LCD_EN                 (* (reg8 *) Iantenna__LCD_EN)
/* Slew Rate Control */
#define Iantenna_SLW                    (* (reg8 *) Iantenna__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define Iantenna_PRTDSI__CAPS_SEL       (* (reg8 *) Iantenna__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define Iantenna_PRTDSI__DBL_SYNC_IN    (* (reg8 *) Iantenna__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define Iantenna_PRTDSI__OE_SEL0        (* (reg8 *) Iantenna__PRTDSI__OE_SEL0) 
#define Iantenna_PRTDSI__OE_SEL1        (* (reg8 *) Iantenna__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define Iantenna_PRTDSI__OUT_SEL0       (* (reg8 *) Iantenna__PRTDSI__OUT_SEL0) 
#define Iantenna_PRTDSI__OUT_SEL1       (* (reg8 *) Iantenna__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define Iantenna_PRTDSI__SYNC_OUT       (* (reg8 *) Iantenna__PRTDSI__SYNC_OUT) 

/* SIO registers */
#if defined(Iantenna__SIO_CFG)
    #define Iantenna_SIO_HYST_EN        (* (reg8 *) Iantenna__SIO_HYST_EN)
    #define Iantenna_SIO_REG_HIFREQ     (* (reg8 *) Iantenna__SIO_REG_HIFREQ)
    #define Iantenna_SIO_CFG            (* (reg8 *) Iantenna__SIO_CFG)
    #define Iantenna_SIO_DIFF           (* (reg8 *) Iantenna__SIO_DIFF)
#endif /* (Iantenna__SIO_CFG) */

/* Interrupt Registers */
#if defined(Iantenna__INTSTAT)
    #define Iantenna_INTSTAT            (* (reg8 *) Iantenna__INTSTAT)
    #define Iantenna_SNAP               (* (reg8 *) Iantenna__SNAP)
    
	#define Iantenna_0_INTTYPE_REG 		(* (reg8 *) Iantenna__0__INTTYPE)
#endif /* (Iantenna__INTSTAT) */

#endif /* CY_PSOC5A... */

#endif /*  CY_PINS_Iantenna_H */


/* [] END OF FILE */
