/*******************************************************************************
* File Name: Idisplay.h  
* Version 2.20
*
* Description:
*  This file contains Pin function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_Idisplay_H) /* Pins Idisplay_H */
#define CY_PINS_Idisplay_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "Idisplay_aliases.h"

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 Idisplay__PORT == 15 && ((Idisplay__MASK & 0xC0) != 0))


/***************************************
*        Function Prototypes             
***************************************/    

/**
* \addtogroup group_general
* @{
*/
void    Idisplay_Write(uint8 value);
void    Idisplay_SetDriveMode(uint8 mode);
uint8   Idisplay_ReadDataReg(void);
uint8   Idisplay_Read(void);
void    Idisplay_SetInterruptMode(uint16 position, uint16 mode);
uint8   Idisplay_ClearInterrupt(void);
/** @} general */

/***************************************
*           API Constants        
***************************************/
/**
* \addtogroup group_constants
* @{
*/
    /** \addtogroup driveMode Drive mode constants
     * \brief Constants to be passed as "mode" parameter in the Idisplay_SetDriveMode() function.
     *  @{
     */
        #define Idisplay_DM_ALG_HIZ         PIN_DM_ALG_HIZ
        #define Idisplay_DM_DIG_HIZ         PIN_DM_DIG_HIZ
        #define Idisplay_DM_RES_UP          PIN_DM_RES_UP
        #define Idisplay_DM_RES_DWN         PIN_DM_RES_DWN
        #define Idisplay_DM_OD_LO           PIN_DM_OD_LO
        #define Idisplay_DM_OD_HI           PIN_DM_OD_HI
        #define Idisplay_DM_STRONG          PIN_DM_STRONG
        #define Idisplay_DM_RES_UPDWN       PIN_DM_RES_UPDWN
    /** @} driveMode */
/** @} group_constants */
    
/* Digital Port Constants */
#define Idisplay_MASK               Idisplay__MASK
#define Idisplay_SHIFT              Idisplay__SHIFT
#define Idisplay_WIDTH              1u

/* Interrupt constants */
#if defined(Idisplay__INTSTAT)
/**
* \addtogroup group_constants
* @{
*/
    /** \addtogroup intrMode Interrupt constants
     * \brief Constants to be passed as "mode" parameter in Idisplay_SetInterruptMode() function.
     *  @{
     */
        #define Idisplay_INTR_NONE      (uint16)(0x0000u)
        #define Idisplay_INTR_RISING    (uint16)(0x0001u)
        #define Idisplay_INTR_FALLING   (uint16)(0x0002u)
        #define Idisplay_INTR_BOTH      (uint16)(0x0003u) 
    /** @} intrMode */
/** @} group_constants */

    #define Idisplay_INTR_MASK      (0x01u) 
#endif /* (Idisplay__INTSTAT) */


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define Idisplay_PS                     (* (reg8 *) Idisplay__PS)
/* Data Register */
#define Idisplay_DR                     (* (reg8 *) Idisplay__DR)
/* Port Number */
#define Idisplay_PRT_NUM                (* (reg8 *) Idisplay__PRT) 
/* Connect to Analog Globals */                                                  
#define Idisplay_AG                     (* (reg8 *) Idisplay__AG)                       
/* Analog MUX bux enable */
#define Idisplay_AMUX                   (* (reg8 *) Idisplay__AMUX) 
/* Bidirectional Enable */                                                        
#define Idisplay_BIE                    (* (reg8 *) Idisplay__BIE)
/* Bit-mask for Aliased Register Access */
#define Idisplay_BIT_MASK               (* (reg8 *) Idisplay__BIT_MASK)
/* Bypass Enable */
#define Idisplay_BYP                    (* (reg8 *) Idisplay__BYP)
/* Port wide control signals */                                                   
#define Idisplay_CTL                    (* (reg8 *) Idisplay__CTL)
/* Drive Modes */
#define Idisplay_DM0                    (* (reg8 *) Idisplay__DM0) 
#define Idisplay_DM1                    (* (reg8 *) Idisplay__DM1)
#define Idisplay_DM2                    (* (reg8 *) Idisplay__DM2) 
/* Input Buffer Disable Override */
#define Idisplay_INP_DIS                (* (reg8 *) Idisplay__INP_DIS)
/* LCD Common or Segment Drive */
#define Idisplay_LCD_COM_SEG            (* (reg8 *) Idisplay__LCD_COM_SEG)
/* Enable Segment LCD */
#define Idisplay_LCD_EN                 (* (reg8 *) Idisplay__LCD_EN)
/* Slew Rate Control */
#define Idisplay_SLW                    (* (reg8 *) Idisplay__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define Idisplay_PRTDSI__CAPS_SEL       (* (reg8 *) Idisplay__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define Idisplay_PRTDSI__DBL_SYNC_IN    (* (reg8 *) Idisplay__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define Idisplay_PRTDSI__OE_SEL0        (* (reg8 *) Idisplay__PRTDSI__OE_SEL0) 
#define Idisplay_PRTDSI__OE_SEL1        (* (reg8 *) Idisplay__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define Idisplay_PRTDSI__OUT_SEL0       (* (reg8 *) Idisplay__PRTDSI__OUT_SEL0) 
#define Idisplay_PRTDSI__OUT_SEL1       (* (reg8 *) Idisplay__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define Idisplay_PRTDSI__SYNC_OUT       (* (reg8 *) Idisplay__PRTDSI__SYNC_OUT) 

/* SIO registers */
#if defined(Idisplay__SIO_CFG)
    #define Idisplay_SIO_HYST_EN        (* (reg8 *) Idisplay__SIO_HYST_EN)
    #define Idisplay_SIO_REG_HIFREQ     (* (reg8 *) Idisplay__SIO_REG_HIFREQ)
    #define Idisplay_SIO_CFG            (* (reg8 *) Idisplay__SIO_CFG)
    #define Idisplay_SIO_DIFF           (* (reg8 *) Idisplay__SIO_DIFF)
#endif /* (Idisplay__SIO_CFG) */

/* Interrupt Registers */
#if defined(Idisplay__INTSTAT)
    #define Idisplay_INTSTAT            (* (reg8 *) Idisplay__INTSTAT)
    #define Idisplay_SNAP               (* (reg8 *) Idisplay__SNAP)
    
	#define Idisplay_0_INTTYPE_REG 		(* (reg8 *) Idisplay__0__INTTYPE)
#endif /* (Idisplay__INTSTAT) */

#endif /* CY_PSOC5A... */

#endif /*  CY_PINS_Idisplay_H */


/* [] END OF FILE */
