/*******************************************************************************
* File Name: Idut.h  
* Version 2.20
*
* Description:
*  This file contains Pin function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_Idut_H) /* Pins Idut_H */
#define CY_PINS_Idut_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "Idut_aliases.h"

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 Idut__PORT == 15 && ((Idut__MASK & 0xC0) != 0))


/***************************************
*        Function Prototypes             
***************************************/    

/**
* \addtogroup group_general
* @{
*/
void    Idut_Write(uint8 value);
void    Idut_SetDriveMode(uint8 mode);
uint8   Idut_ReadDataReg(void);
uint8   Idut_Read(void);
void    Idut_SetInterruptMode(uint16 position, uint16 mode);
uint8   Idut_ClearInterrupt(void);
/** @} general */

/***************************************
*           API Constants        
***************************************/
/**
* \addtogroup group_constants
* @{
*/
    /** \addtogroup driveMode Drive mode constants
     * \brief Constants to be passed as "mode" parameter in the Idut_SetDriveMode() function.
     *  @{
     */
        #define Idut_DM_ALG_HIZ         PIN_DM_ALG_HIZ
        #define Idut_DM_DIG_HIZ         PIN_DM_DIG_HIZ
        #define Idut_DM_RES_UP          PIN_DM_RES_UP
        #define Idut_DM_RES_DWN         PIN_DM_RES_DWN
        #define Idut_DM_OD_LO           PIN_DM_OD_LO
        #define Idut_DM_OD_HI           PIN_DM_OD_HI
        #define Idut_DM_STRONG          PIN_DM_STRONG
        #define Idut_DM_RES_UPDWN       PIN_DM_RES_UPDWN
    /** @} driveMode */
/** @} group_constants */
    
/* Digital Port Constants */
#define Idut_MASK               Idut__MASK
#define Idut_SHIFT              Idut__SHIFT
#define Idut_WIDTH              1u

/* Interrupt constants */
#if defined(Idut__INTSTAT)
/**
* \addtogroup group_constants
* @{
*/
    /** \addtogroup intrMode Interrupt constants
     * \brief Constants to be passed as "mode" parameter in Idut_SetInterruptMode() function.
     *  @{
     */
        #define Idut_INTR_NONE      (uint16)(0x0000u)
        #define Idut_INTR_RISING    (uint16)(0x0001u)
        #define Idut_INTR_FALLING   (uint16)(0x0002u)
        #define Idut_INTR_BOTH      (uint16)(0x0003u) 
    /** @} intrMode */
/** @} group_constants */

    #define Idut_INTR_MASK      (0x01u) 
#endif /* (Idut__INTSTAT) */


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define Idut_PS                     (* (reg8 *) Idut__PS)
/* Data Register */
#define Idut_DR                     (* (reg8 *) Idut__DR)
/* Port Number */
#define Idut_PRT_NUM                (* (reg8 *) Idut__PRT) 
/* Connect to Analog Globals */                                                  
#define Idut_AG                     (* (reg8 *) Idut__AG)                       
/* Analog MUX bux enable */
#define Idut_AMUX                   (* (reg8 *) Idut__AMUX) 
/* Bidirectional Enable */                                                        
#define Idut_BIE                    (* (reg8 *) Idut__BIE)
/* Bit-mask for Aliased Register Access */
#define Idut_BIT_MASK               (* (reg8 *) Idut__BIT_MASK)
/* Bypass Enable */
#define Idut_BYP                    (* (reg8 *) Idut__BYP)
/* Port wide control signals */                                                   
#define Idut_CTL                    (* (reg8 *) Idut__CTL)
/* Drive Modes */
#define Idut_DM0                    (* (reg8 *) Idut__DM0) 
#define Idut_DM1                    (* (reg8 *) Idut__DM1)
#define Idut_DM2                    (* (reg8 *) Idut__DM2) 
/* Input Buffer Disable Override */
#define Idut_INP_DIS                (* (reg8 *) Idut__INP_DIS)
/* LCD Common or Segment Drive */
#define Idut_LCD_COM_SEG            (* (reg8 *) Idut__LCD_COM_SEG)
/* Enable Segment LCD */
#define Idut_LCD_EN                 (* (reg8 *) Idut__LCD_EN)
/* Slew Rate Control */
#define Idut_SLW                    (* (reg8 *) Idut__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define Idut_PRTDSI__CAPS_SEL       (* (reg8 *) Idut__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define Idut_PRTDSI__DBL_SYNC_IN    (* (reg8 *) Idut__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define Idut_PRTDSI__OE_SEL0        (* (reg8 *) Idut__PRTDSI__OE_SEL0) 
#define Idut_PRTDSI__OE_SEL1        (* (reg8 *) Idut__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define Idut_PRTDSI__OUT_SEL0       (* (reg8 *) Idut__PRTDSI__OUT_SEL0) 
#define Idut_PRTDSI__OUT_SEL1       (* (reg8 *) Idut__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define Idut_PRTDSI__SYNC_OUT       (* (reg8 *) Idut__PRTDSI__SYNC_OUT) 

/* SIO registers */
#if defined(Idut__SIO_CFG)
    #define Idut_SIO_HYST_EN        (* (reg8 *) Idut__SIO_HYST_EN)
    #define Idut_SIO_REG_HIFREQ     (* (reg8 *) Idut__SIO_REG_HIFREQ)
    #define Idut_SIO_CFG            (* (reg8 *) Idut__SIO_CFG)
    #define Idut_SIO_DIFF           (* (reg8 *) Idut__SIO_DIFF)
#endif /* (Idut__SIO_CFG) */

/* Interrupt Registers */
#if defined(Idut__INTSTAT)
    #define Idut_INTSTAT            (* (reg8 *) Idut__INTSTAT)
    #define Idut_SNAP               (* (reg8 *) Idut__SNAP)
    
	#define Idut_0_INTTYPE_REG 		(* (reg8 *) Idut__0__INTTYPE)
#endif /* (Idut__INTSTAT) */

#endif /* CY_PSOC5A... */

#endif /*  CY_PINS_Idut_H */


/* [] END OF FILE */
