/*******************************************************************************
* File Name: .h
* Version 2.50
*
* Description:
*  This private header file contains internal definitions for the SPIM
*  component. Do not use these definitions directly in your application.
*
* Note:
*
********************************************************************************
* Copyright 2012-2015, Cypress Semiconductor Corporation. All rights reserved.
* You may use this file only in accordance with the license, terms, conditions,
* disclaimers, and limitations in the end user license agreement accompanying
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_SPIM_PVT_SPIM_BGT_H)
#define CY_SPIM_PVT_SPIM_BGT_H

#include "SPIM_BGT.h"


/**********************************
*   Functions with external linkage
**********************************/


/**********************************
*   Variables with external linkage
**********************************/

extern volatile uint8 SPIM_BGT_swStatusTx;
extern volatile uint8 SPIM_BGT_swStatusRx;

#if(SPIM_BGT_TX_SOFTWARE_BUF_ENABLED)
    extern volatile uint16 SPIM_BGT_txBuffer[SPIM_BGT_TX_BUFFER_SIZE];
    extern volatile uint8 SPIM_BGT_txBufferRead;
    extern volatile uint8 SPIM_BGT_txBufferWrite;
    extern volatile uint8 SPIM_BGT_txBufferFull;
#endif /* (SPIM_BGT_TX_SOFTWARE_BUF_ENABLED) */

#if(SPIM_BGT_RX_SOFTWARE_BUF_ENABLED)
    extern volatile uint16 SPIM_BGT_rxBuffer[SPIM_BGT_RX_BUFFER_SIZE];
    extern volatile uint8 SPIM_BGT_rxBufferRead;
    extern volatile uint8 SPIM_BGT_rxBufferWrite;
    extern volatile uint8 SPIM_BGT_rxBufferFull;
#endif /* (SPIM_BGT_RX_SOFTWARE_BUF_ENABLED) */

#endif /* CY_SPIM_PVT_SPIM_BGT_H */


/* [] END OF FILE */
