/*******************************************************************************
* File Name: SpeedMsgInterrupt.h
* Version 1.70
*
*  Description:
*   Provides the function definitions for the Interrupt Controller.
*
*
********************************************************************************
* Copyright 2008-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/
#if !defined(CY_ISR_SpeedMsgInterrupt_H)
#define CY_ISR_SpeedMsgInterrupt_H


#include <cytypes.h>
#include <cyfitter.h>

/* Interrupt Controller API. */
void SpeedMsgInterrupt_Start(void);
void SpeedMsgInterrupt_StartEx(cyisraddress address);
void SpeedMsgInterrupt_Stop(void);

CY_ISR_PROTO(SpeedMsgInterrupt_Interrupt);

void SpeedMsgInterrupt_SetVector(cyisraddress address);
cyisraddress SpeedMsgInterrupt_GetVector(void);

void SpeedMsgInterrupt_SetPriority(uint8 priority);
uint8 SpeedMsgInterrupt_GetPriority(void);

void SpeedMsgInterrupt_Enable(void);
uint8 SpeedMsgInterrupt_GetState(void);
void SpeedMsgInterrupt_Disable(void);

void SpeedMsgInterrupt_SetPending(void);
void SpeedMsgInterrupt_ClearPending(void);


/* Interrupt Controller Constants */

/* Address of the INTC.VECT[x] register that contains the Address of the SpeedMsgInterrupt ISR. */
#define SpeedMsgInterrupt_INTC_VECTOR            ((reg32 *) SpeedMsgInterrupt__INTC_VECT)

/* Address of the SpeedMsgInterrupt ISR priority. */
#define SpeedMsgInterrupt_INTC_PRIOR             ((reg8 *) SpeedMsgInterrupt__INTC_PRIOR_REG)

/* Priority of the SpeedMsgInterrupt interrupt. */
#define SpeedMsgInterrupt_INTC_PRIOR_NUMBER      SpeedMsgInterrupt__INTC_PRIOR_NUM

/* Address of the INTC.SET_EN[x] byte to bit enable SpeedMsgInterrupt interrupt. */
#define SpeedMsgInterrupt_INTC_SET_EN            ((reg32 *) SpeedMsgInterrupt__INTC_SET_EN_REG)

/* Address of the INTC.CLR_EN[x] register to bit clear the SpeedMsgInterrupt interrupt. */
#define SpeedMsgInterrupt_INTC_CLR_EN            ((reg32 *) SpeedMsgInterrupt__INTC_CLR_EN_REG)

/* Address of the INTC.SET_PD[x] register to set the SpeedMsgInterrupt interrupt state to pending. */
#define SpeedMsgInterrupt_INTC_SET_PD            ((reg32 *) SpeedMsgInterrupt__INTC_SET_PD_REG)

/* Address of the INTC.CLR_PD[x] register to clear the SpeedMsgInterrupt interrupt. */
#define SpeedMsgInterrupt_INTC_CLR_PD            ((reg32 *) SpeedMsgInterrupt__INTC_CLR_PD_REG)


#endif /* CY_ISR_SpeedMsgInterrupt_H */


/* [] END OF FILE */
