/*******************************************************************************
* File Name: Vcon2_PWM.h  
* Version 2.20
*
* Description:
*  This file contains Pin function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_Vcon2_PWM_H) /* Pins Vcon2_PWM_H */
#define CY_PINS_Vcon2_PWM_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "Vcon2_PWM_aliases.h"

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 Vcon2_PWM__PORT == 15 && ((Vcon2_PWM__MASK & 0xC0) != 0))


/***************************************
*        Function Prototypes             
***************************************/    

/**
* \addtogroup group_general
* @{
*/
void    Vcon2_PWM_Write(uint8 value);
void    Vcon2_PWM_SetDriveMode(uint8 mode);
uint8   Vcon2_PWM_ReadDataReg(void);
uint8   Vcon2_PWM_Read(void);
void    Vcon2_PWM_SetInterruptMode(uint16 position, uint16 mode);
uint8   Vcon2_PWM_ClearInterrupt(void);
/** @} general */

/***************************************
*           API Constants        
***************************************/
/**
* \addtogroup group_constants
* @{
*/
    /** \addtogroup driveMode Drive mode constants
     * \brief Constants to be passed as "mode" parameter in the Vcon2_PWM_SetDriveMode() function.
     *  @{
     */
        #define Vcon2_PWM_DM_ALG_HIZ         PIN_DM_ALG_HIZ
        #define Vcon2_PWM_DM_DIG_HIZ         PIN_DM_DIG_HIZ
        #define Vcon2_PWM_DM_RES_UP          PIN_DM_RES_UP
        #define Vcon2_PWM_DM_RES_DWN         PIN_DM_RES_DWN
        #define Vcon2_PWM_DM_OD_LO           PIN_DM_OD_LO
        #define Vcon2_PWM_DM_OD_HI           PIN_DM_OD_HI
        #define Vcon2_PWM_DM_STRONG          PIN_DM_STRONG
        #define Vcon2_PWM_DM_RES_UPDWN       PIN_DM_RES_UPDWN
    /** @} driveMode */
/** @} group_constants */
    
/* Digital Port Constants */
#define Vcon2_PWM_MASK               Vcon2_PWM__MASK
#define Vcon2_PWM_SHIFT              Vcon2_PWM__SHIFT
#define Vcon2_PWM_WIDTH              1u

/* Interrupt constants */
#if defined(Vcon2_PWM__INTSTAT)
/**
* \addtogroup group_constants
* @{
*/
    /** \addtogroup intrMode Interrupt constants
     * \brief Constants to be passed as "mode" parameter in Vcon2_PWM_SetInterruptMode() function.
     *  @{
     */
        #define Vcon2_PWM_INTR_NONE      (uint16)(0x0000u)
        #define Vcon2_PWM_INTR_RISING    (uint16)(0x0001u)
        #define Vcon2_PWM_INTR_FALLING   (uint16)(0x0002u)
        #define Vcon2_PWM_INTR_BOTH      (uint16)(0x0003u) 
    /** @} intrMode */
/** @} group_constants */

    #define Vcon2_PWM_INTR_MASK      (0x01u) 
#endif /* (Vcon2_PWM__INTSTAT) */


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define Vcon2_PWM_PS                     (* (reg8 *) Vcon2_PWM__PS)
/* Data Register */
#define Vcon2_PWM_DR                     (* (reg8 *) Vcon2_PWM__DR)
/* Port Number */
#define Vcon2_PWM_PRT_NUM                (* (reg8 *) Vcon2_PWM__PRT) 
/* Connect to Analog Globals */                                                  
#define Vcon2_PWM_AG                     (* (reg8 *) Vcon2_PWM__AG)                       
/* Analog MUX bux enable */
#define Vcon2_PWM_AMUX                   (* (reg8 *) Vcon2_PWM__AMUX) 
/* Bidirectional Enable */                                                        
#define Vcon2_PWM_BIE                    (* (reg8 *) Vcon2_PWM__BIE)
/* Bit-mask for Aliased Register Access */
#define Vcon2_PWM_BIT_MASK               (* (reg8 *) Vcon2_PWM__BIT_MASK)
/* Bypass Enable */
#define Vcon2_PWM_BYP                    (* (reg8 *) Vcon2_PWM__BYP)
/* Port wide control signals */                                                   
#define Vcon2_PWM_CTL                    (* (reg8 *) Vcon2_PWM__CTL)
/* Drive Modes */
#define Vcon2_PWM_DM0                    (* (reg8 *) Vcon2_PWM__DM0) 
#define Vcon2_PWM_DM1                    (* (reg8 *) Vcon2_PWM__DM1)
#define Vcon2_PWM_DM2                    (* (reg8 *) Vcon2_PWM__DM2) 
/* Input Buffer Disable Override */
#define Vcon2_PWM_INP_DIS                (* (reg8 *) Vcon2_PWM__INP_DIS)
/* LCD Common or Segment Drive */
#define Vcon2_PWM_LCD_COM_SEG            (* (reg8 *) Vcon2_PWM__LCD_COM_SEG)
/* Enable Segment LCD */
#define Vcon2_PWM_LCD_EN                 (* (reg8 *) Vcon2_PWM__LCD_EN)
/* Slew Rate Control */
#define Vcon2_PWM_SLW                    (* (reg8 *) Vcon2_PWM__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define Vcon2_PWM_PRTDSI__CAPS_SEL       (* (reg8 *) Vcon2_PWM__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define Vcon2_PWM_PRTDSI__DBL_SYNC_IN    (* (reg8 *) Vcon2_PWM__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define Vcon2_PWM_PRTDSI__OE_SEL0        (* (reg8 *) Vcon2_PWM__PRTDSI__OE_SEL0) 
#define Vcon2_PWM_PRTDSI__OE_SEL1        (* (reg8 *) Vcon2_PWM__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define Vcon2_PWM_PRTDSI__OUT_SEL0       (* (reg8 *) Vcon2_PWM__PRTDSI__OUT_SEL0) 
#define Vcon2_PWM_PRTDSI__OUT_SEL1       (* (reg8 *) Vcon2_PWM__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define Vcon2_PWM_PRTDSI__SYNC_OUT       (* (reg8 *) Vcon2_PWM__PRTDSI__SYNC_OUT) 

/* SIO registers */
#if defined(Vcon2_PWM__SIO_CFG)
    #define Vcon2_PWM_SIO_HYST_EN        (* (reg8 *) Vcon2_PWM__SIO_HYST_EN)
    #define Vcon2_PWM_SIO_REG_HIFREQ     (* (reg8 *) Vcon2_PWM__SIO_REG_HIFREQ)
    #define Vcon2_PWM_SIO_CFG            (* (reg8 *) Vcon2_PWM__SIO_CFG)
    #define Vcon2_PWM_SIO_DIFF           (* (reg8 *) Vcon2_PWM__SIO_DIFF)
#endif /* (Vcon2_PWM__SIO_CFG) */

/* Interrupt Registers */
#if defined(Vcon2_PWM__INTSTAT)
    #define Vcon2_PWM_INTSTAT            (* (reg8 *) Vcon2_PWM__INTSTAT)
    #define Vcon2_PWM_SNAP               (* (reg8 *) Vcon2_PWM__SNAP)
    
	#define Vcon2_PWM_0_INTTYPE_REG 		(* (reg8 *) Vcon2_PWM__0__INTTYPE)
#endif /* (Vcon2_PWM__INTSTAT) */

#endif /* CY_PSOC5A... */

#endif /*  CY_PINS_Vcon2_PWM_H */


/* [] END OF FILE */
