/*******************************************************************************
* File Name: Vdisplay.h  
* Version 2.20
*
* Description:
*  This file contains Pin function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_Vdisplay_H) /* Pins Vdisplay_H */
#define CY_PINS_Vdisplay_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "Vdisplay_aliases.h"

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 Vdisplay__PORT == 15 && ((Vdisplay__MASK & 0xC0) != 0))


/***************************************
*        Function Prototypes             
***************************************/    

/**
* \addtogroup group_general
* @{
*/
void    Vdisplay_Write(uint8 value);
void    Vdisplay_SetDriveMode(uint8 mode);
uint8   Vdisplay_ReadDataReg(void);
uint8   Vdisplay_Read(void);
void    Vdisplay_SetInterruptMode(uint16 position, uint16 mode);
uint8   Vdisplay_ClearInterrupt(void);
/** @} general */

/***************************************
*           API Constants        
***************************************/
/**
* \addtogroup group_constants
* @{
*/
    /** \addtogroup driveMode Drive mode constants
     * \brief Constants to be passed as "mode" parameter in the Vdisplay_SetDriveMode() function.
     *  @{
     */
        #define Vdisplay_DM_ALG_HIZ         PIN_DM_ALG_HIZ
        #define Vdisplay_DM_DIG_HIZ         PIN_DM_DIG_HIZ
        #define Vdisplay_DM_RES_UP          PIN_DM_RES_UP
        #define Vdisplay_DM_RES_DWN         PIN_DM_RES_DWN
        #define Vdisplay_DM_OD_LO           PIN_DM_OD_LO
        #define Vdisplay_DM_OD_HI           PIN_DM_OD_HI
        #define Vdisplay_DM_STRONG          PIN_DM_STRONG
        #define Vdisplay_DM_RES_UPDWN       PIN_DM_RES_UPDWN
    /** @} driveMode */
/** @} group_constants */
    
/* Digital Port Constants */
#define Vdisplay_MASK               Vdisplay__MASK
#define Vdisplay_SHIFT              Vdisplay__SHIFT
#define Vdisplay_WIDTH              1u

/* Interrupt constants */
#if defined(Vdisplay__INTSTAT)
/**
* \addtogroup group_constants
* @{
*/
    /** \addtogroup intrMode Interrupt constants
     * \brief Constants to be passed as "mode" parameter in Vdisplay_SetInterruptMode() function.
     *  @{
     */
        #define Vdisplay_INTR_NONE      (uint16)(0x0000u)
        #define Vdisplay_INTR_RISING    (uint16)(0x0001u)
        #define Vdisplay_INTR_FALLING   (uint16)(0x0002u)
        #define Vdisplay_INTR_BOTH      (uint16)(0x0003u) 
    /** @} intrMode */
/** @} group_constants */

    #define Vdisplay_INTR_MASK      (0x01u) 
#endif /* (Vdisplay__INTSTAT) */


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define Vdisplay_PS                     (* (reg8 *) Vdisplay__PS)
/* Data Register */
#define Vdisplay_DR                     (* (reg8 *) Vdisplay__DR)
/* Port Number */
#define Vdisplay_PRT_NUM                (* (reg8 *) Vdisplay__PRT) 
/* Connect to Analog Globals */                                                  
#define Vdisplay_AG                     (* (reg8 *) Vdisplay__AG)                       
/* Analog MUX bux enable */
#define Vdisplay_AMUX                   (* (reg8 *) Vdisplay__AMUX) 
/* Bidirectional Enable */                                                        
#define Vdisplay_BIE                    (* (reg8 *) Vdisplay__BIE)
/* Bit-mask for Aliased Register Access */
#define Vdisplay_BIT_MASK               (* (reg8 *) Vdisplay__BIT_MASK)
/* Bypass Enable */
#define Vdisplay_BYP                    (* (reg8 *) Vdisplay__BYP)
/* Port wide control signals */                                                   
#define Vdisplay_CTL                    (* (reg8 *) Vdisplay__CTL)
/* Drive Modes */
#define Vdisplay_DM0                    (* (reg8 *) Vdisplay__DM0) 
#define Vdisplay_DM1                    (* (reg8 *) Vdisplay__DM1)
#define Vdisplay_DM2                    (* (reg8 *) Vdisplay__DM2) 
/* Input Buffer Disable Override */
#define Vdisplay_INP_DIS                (* (reg8 *) Vdisplay__INP_DIS)
/* LCD Common or Segment Drive */
#define Vdisplay_LCD_COM_SEG            (* (reg8 *) Vdisplay__LCD_COM_SEG)
/* Enable Segment LCD */
#define Vdisplay_LCD_EN                 (* (reg8 *) Vdisplay__LCD_EN)
/* Slew Rate Control */
#define Vdisplay_SLW                    (* (reg8 *) Vdisplay__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define Vdisplay_PRTDSI__CAPS_SEL       (* (reg8 *) Vdisplay__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define Vdisplay_PRTDSI__DBL_SYNC_IN    (* (reg8 *) Vdisplay__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define Vdisplay_PRTDSI__OE_SEL0        (* (reg8 *) Vdisplay__PRTDSI__OE_SEL0) 
#define Vdisplay_PRTDSI__OE_SEL1        (* (reg8 *) Vdisplay__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define Vdisplay_PRTDSI__OUT_SEL0       (* (reg8 *) Vdisplay__PRTDSI__OUT_SEL0) 
#define Vdisplay_PRTDSI__OUT_SEL1       (* (reg8 *) Vdisplay__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define Vdisplay_PRTDSI__SYNC_OUT       (* (reg8 *) Vdisplay__PRTDSI__SYNC_OUT) 

/* SIO registers */
#if defined(Vdisplay__SIO_CFG)
    #define Vdisplay_SIO_HYST_EN        (* (reg8 *) Vdisplay__SIO_HYST_EN)
    #define Vdisplay_SIO_REG_HIFREQ     (* (reg8 *) Vdisplay__SIO_REG_HIFREQ)
    #define Vdisplay_SIO_CFG            (* (reg8 *) Vdisplay__SIO_CFG)
    #define Vdisplay_SIO_DIFF           (* (reg8 *) Vdisplay__SIO_DIFF)
#endif /* (Vdisplay__SIO_CFG) */

/* Interrupt Registers */
#if defined(Vdisplay__INTSTAT)
    #define Vdisplay_INTSTAT            (* (reg8 *) Vdisplay__INTSTAT)
    #define Vdisplay_SNAP               (* (reg8 *) Vdisplay__SNAP)
    
	#define Vdisplay_0_INTTYPE_REG 		(* (reg8 *) Vdisplay__0__INTTYPE)
#endif /* (Vdisplay__INTSTAT) */

#endif /* CY_PSOC5A... */

#endif /*  CY_PINS_Vdisplay_H */


/* [] END OF FILE */
