/*******************************************************************************
* File Name: out1_done.h  
* Version 2.20
*
* Description:
*  This file contains Pin function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_out1_done_H) /* Pins out1_done_H */
#define CY_PINS_out1_done_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "out1_done_aliases.h"

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 out1_done__PORT == 15 && ((out1_done__MASK & 0xC0) != 0))


/***************************************
*        Function Prototypes             
***************************************/    

/**
* \addtogroup group_general
* @{
*/
void    out1_done_Write(uint8 value);
void    out1_done_SetDriveMode(uint8 mode);
uint8   out1_done_ReadDataReg(void);
uint8   out1_done_Read(void);
void    out1_done_SetInterruptMode(uint16 position, uint16 mode);
uint8   out1_done_ClearInterrupt(void);
/** @} general */

/***************************************
*           API Constants        
***************************************/
/**
* \addtogroup group_constants
* @{
*/
    /** \addtogroup driveMode Drive mode constants
     * \brief Constants to be passed as "mode" parameter in the out1_done_SetDriveMode() function.
     *  @{
     */
        #define out1_done_DM_ALG_HIZ         PIN_DM_ALG_HIZ
        #define out1_done_DM_DIG_HIZ         PIN_DM_DIG_HIZ
        #define out1_done_DM_RES_UP          PIN_DM_RES_UP
        #define out1_done_DM_RES_DWN         PIN_DM_RES_DWN
        #define out1_done_DM_OD_LO           PIN_DM_OD_LO
        #define out1_done_DM_OD_HI           PIN_DM_OD_HI
        #define out1_done_DM_STRONG          PIN_DM_STRONG
        #define out1_done_DM_RES_UPDWN       PIN_DM_RES_UPDWN
    /** @} driveMode */
/** @} group_constants */
    
/* Digital Port Constants */
#define out1_done_MASK               out1_done__MASK
#define out1_done_SHIFT              out1_done__SHIFT
#define out1_done_WIDTH              1u

/* Interrupt constants */
#if defined(out1_done__INTSTAT)
/**
* \addtogroup group_constants
* @{
*/
    /** \addtogroup intrMode Interrupt constants
     * \brief Constants to be passed as "mode" parameter in out1_done_SetInterruptMode() function.
     *  @{
     */
        #define out1_done_INTR_NONE      (uint16)(0x0000u)
        #define out1_done_INTR_RISING    (uint16)(0x0001u)
        #define out1_done_INTR_FALLING   (uint16)(0x0002u)
        #define out1_done_INTR_BOTH      (uint16)(0x0003u) 
    /** @} intrMode */
/** @} group_constants */

    #define out1_done_INTR_MASK      (0x01u) 
#endif /* (out1_done__INTSTAT) */


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define out1_done_PS                     (* (reg8 *) out1_done__PS)
/* Data Register */
#define out1_done_DR                     (* (reg8 *) out1_done__DR)
/* Port Number */
#define out1_done_PRT_NUM                (* (reg8 *) out1_done__PRT) 
/* Connect to Analog Globals */                                                  
#define out1_done_AG                     (* (reg8 *) out1_done__AG)                       
/* Analog MUX bux enable */
#define out1_done_AMUX                   (* (reg8 *) out1_done__AMUX) 
/* Bidirectional Enable */                                                        
#define out1_done_BIE                    (* (reg8 *) out1_done__BIE)
/* Bit-mask for Aliased Register Access */
#define out1_done_BIT_MASK               (* (reg8 *) out1_done__BIT_MASK)
/* Bypass Enable */
#define out1_done_BYP                    (* (reg8 *) out1_done__BYP)
/* Port wide control signals */                                                   
#define out1_done_CTL                    (* (reg8 *) out1_done__CTL)
/* Drive Modes */
#define out1_done_DM0                    (* (reg8 *) out1_done__DM0) 
#define out1_done_DM1                    (* (reg8 *) out1_done__DM1)
#define out1_done_DM2                    (* (reg8 *) out1_done__DM2) 
/* Input Buffer Disable Override */
#define out1_done_INP_DIS                (* (reg8 *) out1_done__INP_DIS)
/* LCD Common or Segment Drive */
#define out1_done_LCD_COM_SEG            (* (reg8 *) out1_done__LCD_COM_SEG)
/* Enable Segment LCD */
#define out1_done_LCD_EN                 (* (reg8 *) out1_done__LCD_EN)
/* Slew Rate Control */
#define out1_done_SLW                    (* (reg8 *) out1_done__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define out1_done_PRTDSI__CAPS_SEL       (* (reg8 *) out1_done__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define out1_done_PRTDSI__DBL_SYNC_IN    (* (reg8 *) out1_done__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define out1_done_PRTDSI__OE_SEL0        (* (reg8 *) out1_done__PRTDSI__OE_SEL0) 
#define out1_done_PRTDSI__OE_SEL1        (* (reg8 *) out1_done__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define out1_done_PRTDSI__OUT_SEL0       (* (reg8 *) out1_done__PRTDSI__OUT_SEL0) 
#define out1_done_PRTDSI__OUT_SEL1       (* (reg8 *) out1_done__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define out1_done_PRTDSI__SYNC_OUT       (* (reg8 *) out1_done__PRTDSI__SYNC_OUT) 

/* SIO registers */
#if defined(out1_done__SIO_CFG)
    #define out1_done_SIO_HYST_EN        (* (reg8 *) out1_done__SIO_HYST_EN)
    #define out1_done_SIO_REG_HIFREQ     (* (reg8 *) out1_done__SIO_REG_HIFREQ)
    #define out1_done_SIO_CFG            (* (reg8 *) out1_done__SIO_CFG)
    #define out1_done_SIO_DIFF           (* (reg8 *) out1_done__SIO_DIFF)
#endif /* (out1_done__SIO_CFG) */

/* Interrupt Registers */
#if defined(out1_done__INTSTAT)
    #define out1_done_INTSTAT            (* (reg8 *) out1_done__INTSTAT)
    #define out1_done_SNAP               (* (reg8 *) out1_done__SNAP)
    
	#define out1_done_0_INTTYPE_REG 		(* (reg8 *) out1_done__0__INTTYPE)
#endif /* (out1_done__INTSTAT) */

#endif /* CY_PSOC5A... */

#endif /*  CY_PINS_out1_done_H */


/* [] END OF FILE */
