/*******************************************************************************
* File Name: test1.h  
* Version 2.20
*
* Description:
*  This file contains Pin function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_test1_H) /* Pins test1_H */
#define CY_PINS_test1_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "test1_aliases.h"

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 test1__PORT == 15 && ((test1__MASK & 0xC0) != 0))


/***************************************
*        Function Prototypes             
***************************************/    

/**
* \addtogroup group_general
* @{
*/
void    test1_Write(uint8 value);
void    test1_SetDriveMode(uint8 mode);
uint8   test1_ReadDataReg(void);
uint8   test1_Read(void);
void    test1_SetInterruptMode(uint16 position, uint16 mode);
uint8   test1_ClearInterrupt(void);
/** @} general */

/***************************************
*           API Constants        
***************************************/
/**
* \addtogroup group_constants
* @{
*/
    /** \addtogroup driveMode Drive mode constants
     * \brief Constants to be passed as "mode" parameter in the test1_SetDriveMode() function.
     *  @{
     */
        #define test1_DM_ALG_HIZ         PIN_DM_ALG_HIZ
        #define test1_DM_DIG_HIZ         PIN_DM_DIG_HIZ
        #define test1_DM_RES_UP          PIN_DM_RES_UP
        #define test1_DM_RES_DWN         PIN_DM_RES_DWN
        #define test1_DM_OD_LO           PIN_DM_OD_LO
        #define test1_DM_OD_HI           PIN_DM_OD_HI
        #define test1_DM_STRONG          PIN_DM_STRONG
        #define test1_DM_RES_UPDWN       PIN_DM_RES_UPDWN
    /** @} driveMode */
/** @} group_constants */
    
/* Digital Port Constants */
#define test1_MASK               test1__MASK
#define test1_SHIFT              test1__SHIFT
#define test1_WIDTH              1u

/* Interrupt constants */
#if defined(test1__INTSTAT)
/**
* \addtogroup group_constants
* @{
*/
    /** \addtogroup intrMode Interrupt constants
     * \brief Constants to be passed as "mode" parameter in test1_SetInterruptMode() function.
     *  @{
     */
        #define test1_INTR_NONE      (uint16)(0x0000u)
        #define test1_INTR_RISING    (uint16)(0x0001u)
        #define test1_INTR_FALLING   (uint16)(0x0002u)
        #define test1_INTR_BOTH      (uint16)(0x0003u) 
    /** @} intrMode */
/** @} group_constants */

    #define test1_INTR_MASK      (0x01u) 
#endif /* (test1__INTSTAT) */


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define test1_PS                     (* (reg8 *) test1__PS)
/* Data Register */
#define test1_DR                     (* (reg8 *) test1__DR)
/* Port Number */
#define test1_PRT_NUM                (* (reg8 *) test1__PRT) 
/* Connect to Analog Globals */                                                  
#define test1_AG                     (* (reg8 *) test1__AG)                       
/* Analog MUX bux enable */
#define test1_AMUX                   (* (reg8 *) test1__AMUX) 
/* Bidirectional Enable */                                                        
#define test1_BIE                    (* (reg8 *) test1__BIE)
/* Bit-mask for Aliased Register Access */
#define test1_BIT_MASK               (* (reg8 *) test1__BIT_MASK)
/* Bypass Enable */
#define test1_BYP                    (* (reg8 *) test1__BYP)
/* Port wide control signals */                                                   
#define test1_CTL                    (* (reg8 *) test1__CTL)
/* Drive Modes */
#define test1_DM0                    (* (reg8 *) test1__DM0) 
#define test1_DM1                    (* (reg8 *) test1__DM1)
#define test1_DM2                    (* (reg8 *) test1__DM2) 
/* Input Buffer Disable Override */
#define test1_INP_DIS                (* (reg8 *) test1__INP_DIS)
/* LCD Common or Segment Drive */
#define test1_LCD_COM_SEG            (* (reg8 *) test1__LCD_COM_SEG)
/* Enable Segment LCD */
#define test1_LCD_EN                 (* (reg8 *) test1__LCD_EN)
/* Slew Rate Control */
#define test1_SLW                    (* (reg8 *) test1__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define test1_PRTDSI__CAPS_SEL       (* (reg8 *) test1__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define test1_PRTDSI__DBL_SYNC_IN    (* (reg8 *) test1__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define test1_PRTDSI__OE_SEL0        (* (reg8 *) test1__PRTDSI__OE_SEL0) 
#define test1_PRTDSI__OE_SEL1        (* (reg8 *) test1__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define test1_PRTDSI__OUT_SEL0       (* (reg8 *) test1__PRTDSI__OUT_SEL0) 
#define test1_PRTDSI__OUT_SEL1       (* (reg8 *) test1__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define test1_PRTDSI__SYNC_OUT       (* (reg8 *) test1__PRTDSI__SYNC_OUT) 

/* SIO registers */
#if defined(test1__SIO_CFG)
    #define test1_SIO_HYST_EN        (* (reg8 *) test1__SIO_HYST_EN)
    #define test1_SIO_REG_HIFREQ     (* (reg8 *) test1__SIO_REG_HIFREQ)
    #define test1_SIO_CFG            (* (reg8 *) test1__SIO_CFG)
    #define test1_SIO_DIFF           (* (reg8 *) test1__SIO_DIFF)
#endif /* (test1__SIO_CFG) */

/* Interrupt Registers */
#if defined(test1__INTSTAT)
    #define test1_INTSTAT            (* (reg8 *) test1__INTSTAT)
    #define test1_SNAP               (* (reg8 *) test1__SNAP)
    
	#define test1_0_INTTYPE_REG 		(* (reg8 *) test1__0__INTTYPE)
#endif /* (test1__INTSTAT) */

#endif /* CY_PSOC5A... */

#endif /*  CY_PINS_test1_H */


/* [] END OF FILE */
