/*******************************************************************************
* File Name: timeout.h
* Version 1.70
*
*  Description:
*   Provides the function definitions for the Interrupt Controller.
*
*
********************************************************************************
* Copyright 2008-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/
#if !defined(CY_ISR_timeout_H)
#define CY_ISR_timeout_H


#include <cytypes.h>
#include <cyfitter.h>

/* Interrupt Controller API. */
void timeout_Start(void);
void timeout_StartEx(cyisraddress address);
void timeout_Stop(void);

CY_ISR_PROTO(timeout_Interrupt);

void timeout_SetVector(cyisraddress address);
cyisraddress timeout_GetVector(void);

void timeout_SetPriority(uint8 priority);
uint8 timeout_GetPriority(void);

void timeout_Enable(void);
uint8 timeout_GetState(void);
void timeout_Disable(void);

void timeout_SetPending(void);
void timeout_ClearPending(void);


/* Interrupt Controller Constants */

/* Address of the INTC.VECT[x] register that contains the Address of the timeout ISR. */
#define timeout_INTC_VECTOR            ((reg32 *) timeout__INTC_VECT)

/* Address of the timeout ISR priority. */
#define timeout_INTC_PRIOR             ((reg8 *) timeout__INTC_PRIOR_REG)

/* Priority of the timeout interrupt. */
#define timeout_INTC_PRIOR_NUMBER      timeout__INTC_PRIOR_NUM

/* Address of the INTC.SET_EN[x] byte to bit enable timeout interrupt. */
#define timeout_INTC_SET_EN            ((reg32 *) timeout__INTC_SET_EN_REG)

/* Address of the INTC.CLR_EN[x] register to bit clear the timeout interrupt. */
#define timeout_INTC_CLR_EN            ((reg32 *) timeout__INTC_CLR_EN_REG)

/* Address of the INTC.SET_PD[x] register to set the timeout interrupt state to pending. */
#define timeout_INTC_SET_PD            ((reg32 *) timeout__INTC_SET_PD_REG)

/* Address of the INTC.CLR_PD[x] register to clear the timeout interrupt. */
#define timeout_INTC_CLR_PD            ((reg32 *) timeout__INTC_CLR_PD_REG)


#endif /* CY_ISR_timeout_H */


/* [] END OF FILE */
