/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/

#include <project.h>
#include <IO_Expander.h>
#include <MCP23017.h>
#include <main.h>

// Externs 
extern STATES* pCurrentStateMachine;
extern unsigned int NumberOfStates;
extern unsigned char CurrentStateIndex;
extern STATES STATE;
extern unsigned char test_state;
extern unsigned char ButtonMode;
extern double phase_counter;
extern unsigned int amplitude_counter;
extern unsigned int range_counter;
extern unsigned char ManualModeFlag;

extern STATES* pProcessorStateMachine;
extern STATES* pAntennaStateMachine;

unsigned char Init_IO_Expander(void)
{
    unsigned char Data = 0xFF;
    unsigned char *pData = &Data;
    
    if(!MCP_WriteRegister(IOCONA, 0x62))
    {
        return 0; // Fail!!
    } 
    else
    {
        MCP_ReadRegister(IOCONA, pData);  
        if( Data != 0x62)
        {
            return 0; // Fail!!
        }        
    }

    if(!MCP_WriteRegister(IODIRA, 0x50))
    {
        return 0; // Fail!!
    }
    else
    {
        MCP_ReadRegister(IODIRA, pData);  
        if( Data != 0x50)
        {
            return 0; // Fail!!
        }        
    }
    
    if(!MCP_WriteRegister(IPOLA, 0x00))
    {
        return 0; // Fail!!
    }
    else
    {
        MCP_ReadRegister(IPOLA, pData);  
        if( Data != 0x00)
        {
            return 0; // Fail!!
        }        
    }
    
    if(!MCP_WriteRegister(GPINTENA, 0x00))
    {
        return 0; // Fail!!
    }
    else
    {
        MCP_ReadRegister(GPINTENA, pData);  
        if( Data != 0x00)
        {
            return 0; // Fail!!
        }        
    }
    
    if(!MCP_WriteRegister(DEFVALA, 0x00))
    {
        return 0; // Fail!!
    }
    else
    {
        MCP_ReadRegister(DEFVALA, pData);  
        if( Data != 0x00)
        {
            return 0; // Fail!!
        }        
    }
    
    if(!MCP_WriteRegister(INTCONA, 0x00))
    {
        return 0; // Fail!!
    } 
    else
    {
        MCP_ReadRegister(INTCONA, pData);  
        if( Data != 0x00)
        {
            return 0; // Fail!!
        }        
    }
    
    if(!MCP_WriteRegister(GPPUA, 0x00))
    {
        return 0; // Fail!!
    }
    else
    {
        MCP_ReadRegister(GPPUA, pData);  
        if( Data != 0x00)
        {
            return 0; // Fail!!
        }        
    }
     
    if(!MCP_WriteRegister(GPIOA, 0x00))
    {
        return 0; // Fail!!
    }
    else
    {
        //MCP_ReadRegister(GPIOA, pData);  
        //if( (Data & ~ADF_MUX2) != 0x00)
        //{
        //    return 0; // Fail!!
        //}        
    }
    
    if(!MCP_WriteRegister(OLATA, 0x00))
    {
        return 0; // Fail!!
    }
    else
    {
        MCP_ReadRegister(OLATA, pData);  
        if( Data != 0x00)
        {
            return 0; // Fail!!
        }        
    }
    
    if(!MCP_WriteRegister(IODIRB, 0xC0))
    {
        return 0; // Fail!!
    }
    else
    {
        MCP_ReadRegister(IODIRB, pData);  
        if( Data != 0xC0)
        {
            return 0; // Fail!!
        }        
    }
    
    if(!MCP_WriteRegister(IPOLB, 0x00))
    {
        return 0; // Fail!!
    }
    else
    {
        MCP_ReadRegister(IPOLB, pData);  
        if( Data != 0x00)
        {
            return 0; // Fail!!
        }        
    }
    
    if(!MCP_WriteRegister(GPINTENB, 0xC0))
    {
        return 0; // Fail!!
    }
    else
    {
        MCP_ReadRegister(GPINTENB, pData);  
        if( Data != 0xC0)
        {
            return 0; // Fail!!
        }        
    }
    if(!MCP_WriteRegister(DEFVALAB, 0xC0))
    {
        return 0; // Fail!!
    }
    else
    {
        MCP_ReadRegister(DEFVALAB, pData);  
        if( Data != 0xC0)
        {
            return 0; // Fail!!
        }        
    }
    
    if(!MCP_WriteRegister(INTCONB, 0xC0))
    {
        return 0; // Fail!!
    }
    else
    {
        MCP_ReadRegister(INTCONB, pData);  
        if( Data != 0xC0)
        {
            return 0; // Fail!!
        }        
    }
 
    if(!MCP_WriteRegister(GPPUB, 0x40))
    {
        return 0; // Fail!!
    }
    else
    {
        MCP_ReadRegister(GPPUB, pData);  
        if( Data != 0x40)
        {
            return 0; // Fail!!
        }        
    }
    
    if(!MCP_WriteRegister(GPIOB, 0x00))
    {
        return 0; // Fail!!
    }
    else
    {
        MCP_ReadRegister(GPIOB, pData);  
        if( Data != 0xC0)
        {
            return 0; // Fail!!
        }        
    }
    if(!MCP_WriteRegister(OLATB, 0x00))
    {
        return 0; // Fail!!
    }
    else
    {
        MCP_ReadRegister(OLATB, pData);  
        if( Data != 0x00)
        {
            return 0; // Fail!!
        }        
    }
    
    // Initialize the extended I/O.
    PORTA = 0x00;
    PORTA = (CS_BGT2 | CS_AD2 | REVERSE);
    MCP_WriteRegister(GPIOA, PORTA);
    
    PORTB = 0x00;
    PORTB = (CS_BGT1 | CS_AD1 );
    MCP_WriteRegister(GPIOB, PORTB);
    
    // Clear any interrupt.
    unsigned char Temp = 0x00;
    unsigned char *pTemp = &Temp;
    MCP_ReadRegister(INTCAPA, pTemp);
    MCP_ReadRegister(INTCAPB, pTemp);
    
    return 1; // Success!!
    
}

void Poll_IO_Expander(void)
{   
    unsigned char INTB = 0x00;
    unsigned char *pINTB = &INTB;
    MCP_ReadRegister(INTCAPB, pINTB);
        
    if((INTB & BTN1))
    {
        LED_GRN_OFF;
        LED_RED_OFF;
        
        ManualModeFlag = 1;
        
        CurrentStateIndex++;
        if(CurrentStateIndex > NumberOfStates)
        {
            CurrentStateIndex = 1;            
        }  
        
        double current = 0.0;
        if(pCurrentStateMachine == pAntennaStateMachine)
        {
            current = GetAntennaCurrent();
        }
        else
        {
            current = GetProcessorCurrent();
        }
        if( current < 0.10 )
        {
            ManualModeFlag = 0;
            STATE = WAIT;
        }
        else
        {
            STATE = RUN;
        }
        
        test_state = 0;
           
    }
    
    if((INTB & BTN2))
    {
        if(STATE == TARGET_SIM_TEST)
        {
            if(ButtonMode == 0)
            {
                ButtonMode = 1;
                QuadDecoder_SetCounter(phase_counter);
            }
            else if(ButtonMode == 1)
            {
                ButtonMode = 2;
                QuadDecoder_SetCounter(amplitude_counter);
            }
            else
            {
                ButtonMode = 0;
                QuadDecoder_SetCounter(range_counter);
            }
        }
        else
        {
            test_state = 0;
        }
    }
    
    //I2C_MasterSendStop();   
    //I2C_MasterClearReadBuf();
    //I2C_MasterClearWriteBuf();
    //I2C_MasterClearStatus();

}
/* [] END OF FILE */
