/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/

#ifndef IO_H
#define IO_H
    
#include <project.h>
   
// Prototypes
unsigned char Init_IO_Expander(void);    
void Poll_IO_Expander(void);

// IO Extender PortA
#define CS_BGT2     0x80
#define ADF_MUX2    0x40
#define CS_AD2      0x20
#define ADF_MUX1    0x10
#define MUX_EN      0x08
#define REVERSE     0x04
#define IQ_SEL      0x02
#define NOT_USED    0x01

// IO Extender PortB
#define BTN2        0x80
#define BTN1        0x40
#define LED_GRN     0x20
#define LED_RED     0x10
#define CS_BGT1     0x08
#define CS_AD1      0x04
#define MUX1        0x02
#define MUX2        0x01

// Macros
extern unsigned char PORTA;
extern unsigned char PORTB;
#define CS_BGT2_HIGH    PORTA = (PORTA | CS_BGT2);   MCP_WriteRegister(GPIOA, PORTA);
#define CS_BGT2_LOW     PORTA = (PORTA & ~CS_BGT2);  MCP_WriteRegister(GPIOA, PORTA);
#define CS_AD2_HIGH     PORTA = (PORTA | CS_AD2);    MCP_WriteRegister(GPIOA, PORTA);
#define CS_AD2_LOW      PORTA = (PORTA & ~CS_AD2);   MCP_WriteRegister(GPIOA, PORTA);
#define MUX_EN_HIGH     PORTA = (PORTA | MUX_EN);    MCP_WriteRegister(GPIOA, PORTA);
#define MUX_EN_LOW      PORTA = (PORTA & ~MUX_EN);   MCP_WriteRegister(GPIOA, PORTA);
#define REVERSE_LOW     PORTA = (PORTA | REVERSE);   MCP_WriteRegister(GPIOA, PORTA);
#define REVERSE_HIGH    PORTA = (PORTA & ~REVERSE);  MCP_WriteRegister(GPIOA, PORTA);
#define IQ_SEL_HIGH     PORTA = (PORTA | IQ_SEL);    MCP_WriteRegister(GPIOA, PORTA);
#define IQ_SEL_LOW      PORTA = (PORTA & ~IQ_SEL);   MCP_WriteRegister(GPIOA, PORTA);
#define NOT_USED_HIGH   PORTA = (PORTA | NOT_USED);  MCP_WriteRegister(GPIOA, PORTA);
#define NOT_USED_LOW    PORTA = (PORTA & ~NOT_USED); MCP_WriteRegister(GPIOA, PORTA);

#define LED_GRN_ON      PORTB = (PORTB | LED_GRN);   MCP_WriteRegister(GPIOB, PORTB);
#define LED_GRN_OFF     PORTB = (PORTB & ~LED_GRN);  MCP_WriteRegister(GPIOB, PORTB);
#define LED_RED_ON      PORTB = (PORTB | LED_RED);   MCP_WriteRegister(GPIOB, PORTB);
#define LED_RED_OFF     PORTB = (PORTB & ~LED_RED);  MCP_WriteRegister(GPIOB, PORTB);
#define CS_BGT1_HIGH    PORTB = (PORTB | CS_BGT1);   MCP_WriteRegister(GPIOB, PORTB);
#define CS_BGT1_LOW     PORTB = (PORTB & ~CS_BGT1);  MCP_WriteRegister(GPIOB, PORTB);
#define CS_AD1_HIGH     PORTB = (PORTB | CS_AD1);    MCP_WriteRegister(GPIOB, PORTB);
#define CS_AD1_LOW      PORTB = (PORTB & ~CS_AD1);   MCP_WriteRegister(GPIOB, PORTB);
#define MUX1_HIGH       PORTB = (PORTB | MUX1);      MCP_WriteRegister(GPIOB, PORTB);
#define MUX1_LOW        PORTB = (PORTB & ~MUX1);     MCP_WriteRegister(GPIOB, PORTB);
#define MUX2_HIGH       PORTB = (PORTB | MUX2);      MCP_WriteRegister(GPIOB, PORTB);
#define MUX2_LOW        PORTB = (PORTB & ~MUX2);     MCP_WriteRegister(GPIOB, PORTB);


#endif

/* [] END OF FILE */
