/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/

#include <MCP23017.h>
#include <project.h>

unsigned char MCP_WriteRegister(unsigned char address, unsigned char data)
{  
    if( I2C_MSTR_NO_ERROR == I2C_MasterSendStart(MCP23017_ADDRESS, WR_CMD))
    {
        if( I2C_MSTR_NO_ERROR == I2C_MasterWriteByte(address) )
        {
            if( I2C_MSTR_NO_ERROR == I2C_MasterWriteByte(data) )
            {
                if( I2C_MSTR_NO_ERROR == I2C_MasterSendStop() )
                {
                    return 1; // Success!
                }
            }
        }
    }

    I2C_MasterSendStop();
    
    uint8 status = 0;
    status = I2C_MasterStatus();
    if( status != 0 )
    {
        while(1);
        //I2C_MasterClearStatus();
    }
     
    return 0; // Fail!
}

unsigned char MCP_ReadRegister(unsigned char address, unsigned char* pdata)
{
    if( I2C_MSTR_NO_ERROR == I2C_MasterSendStart(MCP23017_ADDRESS, WR_CMD))
    {
        if( I2C_MSTR_NO_ERROR == I2C_MasterWriteByte(address) )
        {
            if( I2C_MSTR_NO_ERROR == I2C_MasterSendRestart(MCP23017_ADDRESS, RD_CMD) )
            {                
                unsigned char temp;
                temp = I2C_MasterReadByte(I2C_ACK_DATA);
                *pdata = temp;
                
                if( I2C_MSTR_NO_ERROR == I2C_MasterSendStop() )
                {
                    return 1; // Success!
                }
            }
        }
    }
    
    I2C_MasterSendStop();
    return 0; // Fail!    
    
}



/* [] END OF FILE */
