/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/

// Prototypes
unsigned char MPR_Init(unsigned char);
unsigned char MPR_WriteRegister(unsigned char, unsigned char, unsigned char);
unsigned char MPR_ReadRegister(unsigned char, unsigned char, unsigned char*);
unsigned char MPR_GetCapData(unsigned char, unsigned int*);

// I2C Addresses
#define CAP_SENSE_TOP_I2C_ADDR  0x4A    // I2C Slave Address - Top IC
#define CAP_SENSE_BOT_I2C_ADDR  0x4B    // I2C Slave Address - Bottom IC

// Register Addresses
#define TOUCH_STATUS_REG        0x00
#define ELE0_FILT_LOW_REG       0x02
#define ELE0_FILT_HIGH_REG      0x03
#define ELE1_FILT_LOW_REG       0x04
#define ELE1_FILT_HIGH_REG      0x05
#define ELE2_FILT_LOW_REG       0x06
#define ELE2_FILT_HIGH_REG      0x07
#define ELE0_BASELINE_REG       0x1A
#define ELE1_BASELINE_REG       0x1B
#define ELE2_BASELINE_REG       0x1C
#define MAX_HALF_DELTA_REG      0x26
#define NOISE_HALF_DELTA_REG    0x27
#define NOISE_CNT_LIM_REG       0x28
#define ELE0_TOUCH_THREH_REG    0x29
#define ELE0_REL_THRESH_REG     0x2A
#define ELE1_TOUCH_THREH_REG    0x2B
#define ELE1_REL_THRESH_REG     0x2C
#define ELE2_TOUCH_THREH_REG    0x2D
#define ELE2_REL_THRESH_REG     0x2E
#define AFE_CONFIG_REG          0x41
#define FILTER_CONFIG_REG       0x43
#define ELECTRODE_CONFIG_REG    0x44

// Misc.
#define WR_CMD      0x00
#define RD_CMD      0x01

/* [] END OF FILE */
