/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/

#include <PrecoNet.h>
#include <main.h>

extern unsigned char newCANdata_SrvcToolResponse;
extern uint8 RxBuffer_SRVC_TOOL_RESPONSE[];
extern uint8 TxBuffer_SRVC_TOOL_REQUEST[];

extern TEST_RESULTS MyTestResults;

unsigned char SendSrvcToolCmd(unsigned char CMD, uint8* pRxBuffer)
{
    TxBuffer_SRVC_TOOL_REQUEST[0] = 0;
    TxBuffer_SRVC_TOOL_REQUEST[1] = 0;
    TxBuffer_SRVC_TOOL_REQUEST[2] = 0;
    TxBuffer_SRVC_TOOL_REQUEST[3] = 0;
    TxBuffer_SRVC_TOOL_REQUEST[4] = 0;
    TxBuffer_SRVC_TOOL_REQUEST[5] = 0;
    TxBuffer_SRVC_TOOL_REQUEST[6] = 0;
    TxBuffer_SRVC_TOOL_REQUEST[7] = 0;
         
    TxBuffer_SRVC_TOOL_REQUEST[0] = CMD;
    
    switch(CMD)
    {              
        case CMD_WR_NEW_PVS_RNG:

            TxBuffer_SRVC_TOOL_REQUEST[1] = 200; // ft.
                  
        break; 
        
        case CMD_ALM_ZONE:

            if(MyTestResults.DUT_DeviceClass == 16)
            {
                TxBuffer_SRVC_TOOL_REQUEST[1] = 28; // ft.
            }
            else
            {     
                TxBuffer_SRVC_TOOL_REQUEST[1] = 200; // ft.
            }
                  
        break;
                 
        case CMD_SET_PRE_PROC_SETTNGS:

            TxBuffer_SRVC_TOOL_REQUEST[1] = PreProcRangeType;   // Pre-processing range type.
            TxBuffer_SRVC_TOOL_REQUEST[2] = PreProcPhaseType;   // Pre-processing phase type.  
            TxBuffer_SRVC_TOOL_REQUEST[3] = NumScans;           // # of scans
            TxBuffer_SRVC_TOOL_REQUEST[4] = 0x00;               // Phase offset   
            TxBuffer_SRVC_TOOL_REQUEST[5] = WindowType;         // Window type
            TxBuffer_SRVC_TOOL_REQUEST[6] = 0x01;               // Software Gain (LSB)
            TxBuffer_SRVC_TOOL_REQUEST[7] = 0x00;               // Software Gain (MSB)
          
        break;  
                    
        case CMD_REQUEST_DATA_SNAPSHOT:
            
            TxBuffer_SRVC_TOOL_REQUEST[1] = IQ_DATA_BOTH; 
            
        break;
    
    }
       
    CAN_SendMsg_SRVC_TOOL_REQUEST();

    unsigned long TIMEOUT_COUNTER = 1000000;
    while(TIMEOUT_COUNTER != 0)
    {
        TIMEOUT_COUNTER--;
        
        if(newCANdata_SrvcToolResponse)
        {
            newCANdata_SrvcToolResponse = 0;
            if(RxBuffer_SRVC_TOOL_RESPONSE[0] == CMD)
            {
                // The DUT has ACK'd the command.
                pRxBuffer[1] = RxBuffer_SRVC_TOOL_RESPONSE[1];
                pRxBuffer[2] = RxBuffer_SRVC_TOOL_RESPONSE[2];
                pRxBuffer[3] = RxBuffer_SRVC_TOOL_RESPONSE[3];
                pRxBuffer[4] = RxBuffer_SRVC_TOOL_RESPONSE[4];
                pRxBuffer[5] = RxBuffer_SRVC_TOOL_RESPONSE[5];
                pRxBuffer[6] = RxBuffer_SRVC_TOOL_RESPONSE[6];
                pRxBuffer[7] = RxBuffer_SRVC_TOOL_RESPONSE[7];
                
                return 1; // Pass
            }  
        }  
    }
    
    return 0; // Fail
    
}

/* [] END OF FILE */
