/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#include <project.h>
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <main.h>
#include <MCP23017.h>
#include <IO_Expander.h>
#include <PrecoNet.h>
#include <PwmTable.h>
#include <ADF4158.h>
#include <BGT24MTR12.h>
#include <MPR03X.h>

unsigned char PORTA = 0x00;
unsigned char PORTB = 0x00;

// Global Variables
#define MAX_TABLE_SIZE  360
int TableSize = MAX_TABLE_SIZE;
__attribute__((aligned())) uint8 SineWave1Table[MAX_TABLE_SIZE];
__attribute__((aligned())) uint8 SineWave2Table[MAX_TABLE_SIZE];
__attribute__((aligned())) uint8 SineWave3Table[MAX_TABLE_SIZE];
__attribute__((aligned())) uint8 SineWave4Table[MAX_TABLE_SIZE];

uint8* pSineWave1;
uint8* pSineWave2;
uint8* pSineWave3;
uint8* pSineWave4;

// Defines for DMA_1 
#define DMA_1_BYTES_PER_BURST 1
#define DMA_1_REQUEST_PER_BURST 1
#define DMA_1_SRC_BASE (CYDEV_SRAM_BASE)
#define DMA_1_DST_BASE (CYDEV_PERIPH_BASE)

// Variable declarations for DMA_1
uint8 DMA_1_Chan;
uint8 DMA_1_TD[1];

// Defines for DMA_2 
#define DMA_2_BYTES_PER_BURST 1
#define DMA_2_REQUEST_PER_BURST 1
#define DMA_2_SRC_BASE (CYDEV_SRAM_BASE)
#define DMA_2_DST_BASE (CYDEV_PERIPH_BASE)

// Variable declarations for DMA_2 
uint8 DMA_2_Chan;
uint8 DMA_2_TD[1];

// Defines for DMA_3 
#define DMA_3_BYTES_PER_BURST 1
#define DMA_3_REQUEST_PER_BURST 1
#define DMA_3_SRC_BASE (CYDEV_SRAM_BASE)
#define DMA_3_DST_BASE (CYDEV_PERIPH_BASE)

// Variable declarations for DMA_3 
uint8 DMA_3_Chan;
uint8 DMA_3_TD[1];

// Defines for DMA_4 
#define DMA_4_BYTES_PER_BURST 1
#define DMA_4_REQUEST_PER_BURST 1
#define DMA_4_SRC_BASE (CYDEV_SRAM_BASE)
#define DMA_4_DST_BASE (CYDEV_PERIPH_BASE)

//Variable declarations for DMA_4
uint8 DMA_4_Chan;
uint8 DMA_4_TD[1];

// Misc.
unsigned char CurrentStateIndex = 0;
unsigned char PreviousStateIndex = 0;
unsigned char ManualModeFlag = 0;
STATES STATE = RUN;
unsigned char test_state = 0;
char stringA[6];
char stringB[6];
char stringC[6];
int32 RawCount = 0;
double Vdisplay = 0.0;
double Idisplay = 0.0;
double Vcon1 = 0.0;
double Vcon2 = 0.0;
double Ialarm = 0.0;
double duty_cycle = 0.0;
unsigned char TimeoutFlag;
TEST_RESULTS MyTestResults;
ANT_TEST_RESULTS MyAntTestResults;
unsigned long TIMEOUT_COUNTER = 0xFFFF;
unsigned char ButtonMode = 0;
double DUT_FtPerBin = 0.0;
double DUT_HzPerBin = 0.0;
unsigned int ADC_SAMPLE_FREQ = 0;
unsigned int RANGE_FFT_LENGTH = 0;
unsigned int TimeBinsPerPeriod = 0;
unsigned int TimeBinsToSearch = 0;
double TestRange = 0.0;
unsigned long ProcessorDetectDebounce = 0;
unsigned long AntennaDetectDebounce = 0;

// Variables associated with sine wave generation.
int pwm_period = 0;
int prev_pwm_period = 0xFF;
double DegreesPerStep = 10.0;
double PrevDegreesPerStep = 25.0;
unsigned int freq_counter;
unsigned int prev_freq_counter;
unsigned int frequencyHz = 0;
unsigned int prev_frequencyHz = 1000;
unsigned int amplitude_counter = AMPLITUDE_MAX;
unsigned int prev_amplitude_counter = 0;
double phase_counter = 0.0;
double prev_phase_counter = 100.0;
unsigned int prev_counter_kHz = 255; 
unsigned int range_counter = 0;
int angle_counter = 0;
TARGET MyTarget;
TARGET* pMyTarget = &MyTarget;
TARGET MyPrevTarget;
TARGET* pMyPrevTarget = &MyPrevTarget;
TARGET RxTarget;
int16 prev_PWM_Period = 0;
uint16 EdgeCounter = 0;
double prevTimeHigh = 0.0;
double prevTimeLow = 0.0;

// CAN 
unsigned char newCANdata_FromSensor = 0;
unsigned char newCANdata_NGFromSensor = 0;
unsigned char newCANdata_SrvcToolResponse = 0;
uint8 TxBuffer_SRVC_TOOL_REQUEST[8] = {0,0,0,0,0,0,0,0};    // CAN transmit buffer used when transmitting with the _SRVC_TOOL_REQUEST PGN.
uint8 TxBuffer_BENDIX_SPEED_MSG[8] = {0,0,0,0,0,0,0,0};     // CAN transmit buffer used when transmitting with the _BENDIX_SPEED_MSG PGN. 
uint8* pTxBufferSrvcTool = &TxBuffer_SRVC_TOOL_REQUEST[0];
uint8 RxBuffer_SRVC_TOOL_RESPONSE[8] = {0,0,0,0,0,0,0,0};   // CAN receive buffer used when receiving from the _SRVC_TOOL_RESPONSE PGN.
uint8 RxBuffer_FROM_SENSOR[8] = {0,0,0,0,0,0,0,0};          // CAN receive buffer used when receiving from the _FROM_SENSOR PGN.
uint8 RxBuffer_NG_FROM_SENSOR[8] = {0,0,0,0,0,0,0,0};       // CAN receive buffer used when receiving from the _NG_FROM_SENSOR PGN.
unsigned char CanFailFlag = 0;
int16 IQ_Buffer[1600];
int16 IQ_index;
unsigned char IQ_TestFlag = 0;

STATES ProcessorStateMachine[11] =
{ 
    WAIT,
    START_PROC_TEST,
    CAN_COMM_TEST,
    TARGET_SIM_TEST,
    IQ_TEST,
    REV_INPUT_TEST,   
    DISPLAY_PWR_TEST,
    ALARM_PWR_TEST,
    TARGET_DETECT_TEST,
    VOLTAGE_TEST,
    EXIT_PROCESSOR_TEST
};

STATES AntennaStateMachine[5] =
{ 
    WAIT,
    START_ANT_TEST,
    CAP_SENSE_TEST,
    ANT_FREQ_TEST,
    EXIT_ANTENNA_TEST
};

STATES IdleStateMachine[1] =
{
    WAIT
};

STATES* pProcessorStateMachine = &ProcessorStateMachine[0];
STATES* pAntennaStateMachine = &AntennaStateMachine[0];
STATES* pIdleStateMachine = &IdleStateMachine[0];
STATES* pCurrentStateMachine = &IdleStateMachine[0];
unsigned int StateMachineSize;
unsigned int NumberOfStates;  

unsigned char ProcessorIsPresent = 0;
unsigned char AntennaIsPresent = 0;

unsigned int rf_freq_reg;

int main()
{    
    // Enable global interrupts.
    CyGlobalIntEnable;
      
    LCD_Start();                     
    I2C_Start();  
    SPIM_ADF_Start();
    SPIM_BGT_Start();
    ADC_Start();
    AnalogMux_Start();
    QuadDecoder_Start();
    TestTimer_Start();

    if(!Init_IO_Expander())
    {
        LCD_ClearDisplay();
        LCD_Position(0, 1); 
        LCD_PrintString("Failed to setup");
        LCD_Position(1, 1);
        LCD_PrintString("IO Expander!");  
        while(1){};
    }
/*       
    if(!BGT_Init(TESTER))
    {
        LCD_ClearDisplay();
        LCD_Position(0, 1); 
        LCD_PrintString("Failed to setup");
        LCD_Position(1, 1);
        LCD_PrintString("BGT24MTR12 (radar)!");  
        while(1){};        
    }  
    
    unsigned int ADF_Result = ADF4158_Init(FRAC_INT_VAL_23000MHz, TESTER);
    if(ADF_Result == 0)
    {
        LCD_ClearDisplay();
        LCD_Position(0, 1); 
        LCD_PrintString("Failed to setup");
        LCD_Position(1, 1);
        LCD_PrintString("ADF4158 PLL!");  
        while(1){};        
    } 
    ADF_PowerDown(TESTER);
*/
    // Initialize the PWMs.
    PWM_DISPLAY_Start();
    PWM_DISPLAY_WriteCompare(0);
    PWM_ALARM_Start();
    PWM_ALARM_WriteCompare(0);

    // Initialize the CAN bus.
    CAN_Start();
    CAN_RXRegisterInit((uint32*)CAN_CanIP__RX0_AMR, (0x180000FF << 3)); // Set the CAN receive masks so the source address and message priority are not used.
    CAN_RXRegisterInit((uint32*)CAN_CanIP__RX1_AMR, (0x180000FF << 3)); // Shifted 3 because the most significant 29 bits make up the mask.
    CAN_RXRegisterInit((uint32*)CAN_CanIP__RX2_AMR, (0x180000FF << 3)); 
      
    // Setup the sine wave generation
    amplitude_counter = AMPLITUDE_MAX;
    GenerateSineWave1Table(amplitude_counter);
    GenerateSineWave2Table(amplitude_counter);
    GenerateSineWave3Table(amplitude_counter);
    GenerateSineWave4Table(amplitude_counter);
    VDAC8_1_Start();   
    VDAC8_2_Start();  
    VDAC8_3_Start();  
    VDAC8_4_Start();
    
    pSineWave1 = (void*)&SineWave1Table[0];
    pSineWave2 = (void*)&SineWave2Table[0];
    pSineWave3 = (void*)&SineWave3Table[0];
    pSineWave4 = (void*)&SineWave4Table[0];
  
    // DMA Configuration for DMA_1 
    DMA_1_Chan = DMA_1_DmaInitialize(DMA_1_BYTES_PER_BURST, DMA_1_REQUEST_PER_BURST, HI16(DMA_1_SRC_BASE), HI16(DMA_1_DST_BASE));
    DMA_1_TD[0] = CyDmaTdAllocate();
    CyDmaTdSetConfiguration(DMA_1_TD[0], MAX_TABLE_SIZE, DMA_1_TD[0], TD_INC_SRC_ADR );
    CyDmaTdSetAddress(DMA_1_TD[0], LO16((uint32)pSineWave1), LO16((uint32)VDAC8_1_Data_PTR));
    CyDmaChSetInitialTd(DMA_1_Chan, DMA_1_TD[0]);
    CyDmaChEnable(DMA_1_Chan, 1);

    // DMA Configuration for DMA_2 
    DMA_2_Chan = DMA_2_DmaInitialize(DMA_2_BYTES_PER_BURST, DMA_2_REQUEST_PER_BURST, HI16(DMA_2_SRC_BASE), HI16(DMA_2_DST_BASE));
    DMA_2_TD[0] = CyDmaTdAllocate();
    CyDmaTdSetConfiguration(DMA_2_TD[0], MAX_TABLE_SIZE, DMA_2_TD[0], TD_INC_SRC_ADR );
    CyDmaTdSetAddress(DMA_2_TD[0], LO16((uint32)pSineWave2), LO16((uint32)VDAC8_2_Data_PTR));
    CyDmaChSetInitialTd(DMA_2_Chan, DMA_2_TD[0]);
    CyDmaChEnable(DMA_2_Chan, 1); 

    // DMA Configuration for DMA_3 
    DMA_3_Chan = DMA_3_DmaInitialize(DMA_3_BYTES_PER_BURST, DMA_3_REQUEST_PER_BURST, HI16(DMA_3_SRC_BASE), HI16(DMA_3_DST_BASE));
    DMA_3_TD[0] = CyDmaTdAllocate();
    CyDmaTdSetConfiguration(DMA_3_TD[0], MAX_TABLE_SIZE, DMA_3_TD[0], TD_INC_SRC_ADR );
    CyDmaTdSetAddress(DMA_3_TD[0], LO16((uint32)pSineWave3), LO16((uint32)VDAC8_3_Data_PTR));
    CyDmaChSetInitialTd(DMA_3_Chan, DMA_3_TD[0]);
    CyDmaChEnable(DMA_3_Chan, 1);
    
    // DMA Configuration for DMA_4 
    DMA_4_Chan = DMA_4_DmaInitialize(DMA_4_BYTES_PER_BURST, DMA_4_REQUEST_PER_BURST, HI16(DMA_4_SRC_BASE), HI16(DMA_4_DST_BASE));
    DMA_4_TD[0] = CyDmaTdAllocate();
    CyDmaTdSetConfiguration(DMA_4_TD[0], MAX_TABLE_SIZE, DMA_4_TD[0], TD_INC_SRC_ADR );
    CyDmaTdSetAddress(DMA_4_TD[0], LO16((uint32)pSineWave4), LO16((uint32)VDAC8_4_Data_PTR));
    CyDmaChSetInitialTd(DMA_4_Chan, DMA_4_TD[0]);
    CyDmaChEnable(DMA_4_Chan, 1);   
    
    IQ_SEL_HIGH;
    MUX_EN_HIGH;
                 
    STATE = WAIT; 
    test_state = 0;
    
    while(1)
    {
        /*
        volatile uint8 status = 0;
        status = I2C_MasterStatus();
        //if( (status & 0xF8) != 0)
        if( status != 0 )
        {
            LCD_ClearDisplay();
            sprintf(stringA, "I2C Error: 0x%X", status);
            LCD_PrintString(stringA);
            while(1);
            //I2C_MasterClearStatus();
        }
        */
        
        if(IO_INT_Read())
        {
            CyDelay(500); // For debounce of button.
            Poll_IO_Expander();
        }
        
        double Vin = 0.0;
        
        switch(STATE)
        {
            case WAIT:
                  
                if(test_state == 0)
                {        
                    LED_GRN_OFF;
                    LED_RED_OFF;
                    
                    CAN_Start();
                    BGT_WriteReg(TX_OFF, TESTER);
                    
                    LCD_ClearDisplay();
                    LCD_Position(0, 1); 
                    LCD_PrintString("Preco Electronics");      
                    LCD_Position(1, 1); 
                    LCD_PrintString("    TL20575A     "); 
                    char version_string[4];
                    sprintf(version_string, "Firmware v%2.1f", FW_VERSION);
                    LCD_Position(2, 3);  
                    LCD_PrintString(version_string); 
                    
                    ProcessorIsPresent = 0;
                    AntennaIsPresent = 0;
                    
                    ProcessorDetectDebounce = 0;
                    AntennaDetectDebounce = 0;            
                    
                    CurrentStateIndex = 0;
                    test_state = 1;
                }
                else if(test_state == 1)
                {      
                    // Check the input voltage
                    Vin = GetInputVoltage();   
                    if(Vin < 8.9)
                    {
                        LCD_ClearDisplay();
                        LCD_Position(0, 0); 
                        LCD_PrintString("Input Voltage");      
                        LCD_Position(1, 0); 
                        LCD_PrintString("too low!"); 
                        test_state = 4;
                    }
                    
        
                    // Measure the current supplied to the DUT
                    if(GetProcessorCurrent() > 0.010 )
                    {
                        ProcessorDetectDebounce++;
                                               
                        if(ProcessorDetectDebounce > DEBOUNCE)
                        {
                            ProcessorDetectDebounce = DEBOUNCE+1;
                            
                            newCANdata_FromSensor = 0;
                            CyDelay(125); 
                            if(newCANdata_FromSensor)
                            {
                                newCANdata_FromSensor = 0;
                                ProcessorIsPresent = 1;  
                            }  
                        }
                    }
                    else
                    {
                        ProcessorDetectDebounce = 0;
                    }
                    
                    if(GetAntennaCurrent() > 0.010) 
                    {
                        AntennaDetectDebounce++;
                        if(AntennaDetectDebounce > DEBOUNCE)
                        { 
                            AntennaDetectDebounce = DEBOUNCE+1;
                            AntennaIsPresent = 1; 
                        }
                    }
                    else
                    {
                        AntennaDetectDebounce = 0;
                    }
                    
                    //if(ProcessorIsPresent & AntennaIsPresent)
                    if( (AntennaDetectDebounce > 0) && (ProcessorDetectDebounce > 0) )
                    {
                        test_state = 2;
                    }
                    else if(ProcessorIsPresent)
                    {
                        test_state = 0;
                        pCurrentStateMachine = pProcessorStateMachine;
                        STATE = *(pCurrentStateMachine+1);
                        NumberOfStates = sizeof(ProcessorStateMachine) - 1;                                
                    }
                    else if(AntennaIsPresent)
                    {
                        test_state = 0;
                        pCurrentStateMachine = pAntennaStateMachine;
                        STATE = *(pCurrentStateMachine+1);
                        NumberOfStates = sizeof(AntennaStateMachine) - 1; 
                    }
                }
                else if(test_state == 2)
                {
                    LCD_ClearDisplay();
                    LCD_Position(0, 0); 
                    LCD_PrintString("Two devices were");      
                    LCD_Position(1, 0); 
                    LCD_PrintString("detected!"); 
                    LCD_Position(2, 0); 
                    LCD_PrintString("Remove one."); 
                    test_state = 3;
                }
                else if(test_state == 3)
                {
                    // Measure the current supplied to the DUT
                    if(GetProcessorCurrent() < 0.010 )
                    {
                        ProcessorIsPresent = 0;
                        test_state = 0;
                    }
                    
                    if(GetAntennaCurrent() < 0.010) 
                    {
                        AntennaIsPresent = 0; 
                        test_state = 0;
                    }                  
                }
                else if(test_state == 4)
                {
                    Vin = GetInputVoltage();   
                    if(Vin >= 8.9)
                    {
                        test_state = 0;
                    }                    
                }
      
            break;
                
            case START_PROC_TEST:
                       
                // Inititialize the test results.
                MyTestResults.DUT_MaxCurrent = 0.0;
                sprintf(MyTestResults.Current_status, "PASS");
                MyTestResults.DUT_DeviceClass = 0;
                MyTestResults.CAN_NumRX = 0;
                sprintf(MyTestResults.CAN_status, "CAN Pending");
                sprintf(MyTestResults.REV_status, "REV Pending");
                MyTestResults.Vdisp_NO_LOAD = 0.0;
                MyTestResults.Idisp_TRIP = 0.0;
                sprintf(MyTestResults.DISP_status, "DISP Pending");
                MyTestResults.Ialarm_TRIP = 0.0;
                sprintf(MyTestResults.ALARM_status, "ALARM Pending");
                MyTestResults.Vsupply = 0.0;
                MyTestResults.Vdut = 0.0;
                MyTestResults.Vcore = 0.0;
                MyTestResults.Vovp = 0.0;
                MyTestResults.Vddr = 0.0;
                MyTestResults.Vddr_dl = 0.0;
                MyTestResults.Vanalog = 0.0;
                sprintf(MyTestResults.VOLT_status, "Volt Pending");
                sprintf(MyTestResults.DETECT_status, "Detect Pending");   
                MyTestResults.CH1I_max = 0;
                MyTestResults.CH1Q_max = 0;
                MyTestResults.CH2I_max = 0;
                MyTestResults.CH2Q_max = 0;
                MyTestResults.CH1Q_phase = -180;
                MyTestResults.CH2I_phase = -180;
                MyTestResults.CH2Q_phase = -180;
                sprintf(MyTestResults.IQ_status, "IQ Pending");
                MyTestResults.SingleWirePWM_TimeHigh = 0.0;
                MyTestResults.SingleWirePWM_TimeLow = 0.0;
                sprintf(MyTestResults.SingleWire_status, "Comm Pending");
                MyTestResults.TotalTestTime = 0;
                
                TestTimer_WriteCounter(0);
                        
                if(ManualModeFlag)
                {
                    CurrentStateIndex++;
                }
                
                test_state = 0;
                STATE = RUN;
        
            break;
                
            case START_ANT_TEST:
                
                MyAntTestResults.DUT_MaxCurrent = 0.0;
                sprintf(MyAntTestResults.Current_status, "PASS");
                MyAntTestResults.LowFreqLock = 0;
                MyAntTestResults.MidFreqLock = 0;
                MyAntTestResults.HighFreqLock = 0;
                sprintf(MyAntTestResults.PLL_status, "PLL Pending");
                sprintf(MyAntTestResults.TxPower_status, "Power Pending");
                MyAntTestResults.Revision = 0;                
                sprintf(MyAntTestResults.CapSenseTop_status, "CAP1 Pending");
                sprintf(MyAntTestResults.CapSenseBottom_status, "CAP2 Pending");
                MyAntTestResults.TotalTestTime = 0;
                
                TestTimer_WriteCounter(0);
                
                if(ManualModeFlag)
                {
                    CurrentStateIndex++;
                }
                          
                test_state = 0;
                STATE = RUN;
            
            break;
            
            case RUN:
             
                //#define SLOW
                
                if(test_state == 0)
                {
                    CAN_Start();
                    MUX_EN_HIGH;
                    REVERSE_LOW;                    // Set reverse input low.                  
                    PWM_ALARM_WriteCompare(0);      // Set the control voltage to 0 (current = 0).
                    PWM_DISPLAY_WriteCompare(0);    // Set the control voltage to 0 (current = 0).
                    test_state = 1;  
                } 
                else if(test_state == 1)
                {
                    if(ManualModeFlag == 0)
                    {
                        if(CurrentStateIndex < NumberOfStates)
                        {
                            test_state = 0;
                            CurrentStateIndex++;
                            STATE = *(pCurrentStateMachine + CurrentStateIndex);
                            if(ManualModeFlag == 0)
                            {
                                #ifdef SLOW
                                CyDelay(1000);
                                #endif
                            }
                        } 
                    }
                    else
                    {
                        if(CurrentStateIndex != PreviousStateIndex)
                        {
                            PreviousStateIndex = CurrentStateIndex;
                            test_state = 0;
                            STATE = *(pCurrentStateMachine + CurrentStateIndex);
                          
                            #ifdef SLOW
                            CyDelay(1000);   
                            #endif
                        }
                    }
                }
                       
                // Measure the current supplied to the DUT
                double temp_current;
                if(pCurrentStateMachine == pProcessorStateMachine)
                {
                    unsigned char ProcessorIsActive = 0;
                    if(CurrentStateIndex == 0)
                    {
                        ProcessorIsActive = 0;
                        newCANdata_FromSensor = 0;
                        CyDelay(250);
                        if(newCANdata_FromSensor)
                        {
                            newCANdata_FromSensor = 0;
                            ProcessorIsActive = 1;
                        }
                    }
                    else if(CurrentStateIndex == NumberOfStates)
                    {
                        ProcessorIsActive = 1;
                        newCANdata_FromSensor = 0;
                        CyDelay(250);
                        if(!newCANdata_FromSensor)
                        {
                            newCANdata_FromSensor = 0;
                            ProcessorIsActive = 0;
                        }                              
                    }
                    else
                    {
                        ProcessorIsActive = 1;
                    }
                    
                    temp_current = GetProcessorCurrent();
                    if( (temp_current < 0.010) || (ProcessorIsActive == 0) )
                    {
                        //ProcessorDetectDebounce++;
                        //if(ProcessorDetectDebounce > DEBOUNCE)
                        //{
                        //    AntennaDetectDebounce = DEBOUNCE+1;
                            ManualModeFlag = 0;
                            test_state = 0;
                            STATE = *pIdleStateMachine;
                        //}
                    }
                    else
                    {
                        ProcessorDetectDebounce = 0;   
                    }
                    
                    if(temp_current > MyTestResults.DUT_MaxCurrent)
                    {
                        MyTestResults.DUT_MaxCurrent = temp_current;
                        if(MyTestResults.DUT_MaxCurrent > MAX_PROC_CURRENT)
                        {
                            sprintf(MyTestResults.Current_status, "FAIL: Max Current");
                            test_state = 0;
                            STATE = *(pProcessorStateMachine + NumberOfStates);
                        }
                    }
                }
                else if(pCurrentStateMachine == pAntennaStateMachine)
                {
                    temp_current = GetAntennaCurrent();
                    if(temp_current < 0.010 )
                    {
                        AntennaDetectDebounce++;
                        if(AntennaDetectDebounce > DEBOUNCE)
                        {
                            AntennaDetectDebounce = DEBOUNCE+1;                            
                            ManualModeFlag = 0;
                            test_state = 0;
                            STATE = *pIdleStateMachine;
                        }
                    } 
                    else
                    {
                        AntennaDetectDebounce = 0;    
                    }
                    
                    if(temp_current > MyAntTestResults.DUT_MaxCurrent)
                    {
                        MyAntTestResults.DUT_MaxCurrent = temp_current;
                        if(MyAntTestResults.DUT_MaxCurrent > MAX_ANT_CURRENT)
                        {
                            sprintf(MyAntTestResults.Current_status, "FAIL: Max Current");
                            test_state = 0;
                            STATE = *(pCurrentStateMachine + NumberOfStates);
                        }
                    }                    
                }
    
            break;
   
            case CAN_COMM_TEST:
                  
                CanCommTest();          
            
            break;
                
            case REV_INPUT_TEST:
                
                RevInputTest();
                
            break;    
            
            case DISPLAY_PWR_TEST:
            
                DisplayPowerTest();
            
            break;
            
            case ALARM_PWR_TEST:
              
                AlarmPowerTest();
     
            break;
                
            case TARGET_DETECT_TEST:
                
                TargetDetectTest();
                
            break;
                
            case TARGET_SIM_TEST:
                
                TargetSimTest();
                
            break;
                
            case VOLTAGE_TEST:
                
                ProcessorVoltageTest();
                
            break;
                
            case IQ_TEST:
                
                IQ_Test();
                
            break;
                
            case SINGLE_WIRE_TEST:
                
                SingleWireCommTest();
                
            break;             
                
            case EXIT_PROCESSOR_TEST:
                
                ShowProcessorTestResults();
                
            break;
                
            case CAP_SENSE_TEST:
                
                CapSenseTest();
                
            break;
                
            case ANT_FREQ_TEST:
                
                AntennaFreqTest();
                
            break;
                
            case EXIT_ANTENNA_TEST:
                
                ShowAntennaTestResults();
                
            break;
 
            default:
                
                STATE = RUN;
                
            break;
        }        
    }
}

void AntennaFreqTest(void)
{
    if(test_state == 0)
    {  
        LCD_ClearDisplay(); 
        MyAntTestResults.LowFreqLock = 0;
        MyAntTestResults.MidFreqLock = 0;
        MyAntTestResults.HighFreqLock = 0;
        MyAntTestResults.LowFreqTxPower = 0.0;
        MyAntTestResults.MidFreqTxPower = 0.0;
        MyAntTestResults.HighFreqTxPower = 0.0;
        sprintf(MyAntTestResults.PLL_status, "FAIL: PLL Pending"); 
        sprintf(MyAntTestResults.TxPower_status, "FAIL: TX PWR Pending");  
         
        MyAntTestResults.Revision = GetAntennaRev();
        LCD_Position(0,0);
        sprintf(stringA, "Rev: %i", MyAntTestResults.Revision);
        LCD_PrintString(stringA);
        test_state = 1;
    }
    else if(test_state == 1)
    {        
        if(BGT_Init(DUT))
        {    
            BGT_WriteReg(TX_ON, DUT);    // Turn on the RF
            
            LCD_Position(1,0);
            LCD_PrintString("Freq: 23.000 GHz");
            LCD_Position(2,0);
            LCD_PrintString("Locked: No ");

            if(ADF4158_Init(FRAC_INT_VAL_23000MHz, DUT) == 1)
            { 
                MyAntTestResults.LowFreqLock = 1;
                LCD_Position(2,0);
                LCD_PrintString("Locked: Yes");
            }
            
            MyAntTestResults.LowFreqTxPower = GetTxPower(DUT);
            LCD_Position(3,0);
            sprintf(stringA, "Power: %1.3f", MyAntTestResults.LowFreqTxPower);
            LCD_PrintString(stringA);
                   
            CyDelay(500);
            
            BGT_WriteReg(TX_ON, DUT);    // Turn on the RF
            
            LCD_Position(1,0);
            LCD_PrintString("Freq: 24.000 GHz");
            LCD_Position(2,0);
            LCD_PrintString("Locked: No ");  
            if(ADF4158_Init(FRAC_INT_VAL_24000MHz, DUT) == 1)
            {   
                MyAntTestResults.MidFreqLock = 1;    
                LCD_Position(2,0);
                LCD_PrintString("Locked: Yes");
            }
            
            MyAntTestResults.MidFreqTxPower = GetTxPower(DUT);
            LCD_Position(3,0);
            sprintf(stringB, "Power: %1.3f", MyAntTestResults.MidFreqTxPower);
            LCD_PrintString(stringB);
            
            CyDelay(500);
            
            BGT_WriteReg(TX_ON, DUT);    // Turn on the RF
            
            LCD_Position(1,0);
            LCD_PrintString("Freq: 25.000 GHz");
            LCD_Position(2,0);
            LCD_PrintString("Locked: No ");
            if(ADF4158_Init(FRAC_INT_VAL_25000MHz, DUT) == 1)
            {
                MyAntTestResults.HighFreqLock = 1;
                LCD_Position(2,0);
                LCD_PrintString("Locked: Yes");
            }
            
            MyAntTestResults.HighFreqTxPower = GetTxPower(DUT);
            LCD_Position(3,0);
            sprintf(stringC, "Power: %1.3f", MyAntTestResults.HighFreqTxPower);
            LCD_PrintString(stringC);
            
            CyDelay(500);  
            
        }
        else
        {
            sprintf(MyAntTestResults.TxPower_status, "FAIL: BGT Init"); 
        }
        
        BGT_WriteReg(TX_OFF, DUT);    // Turn off the RF
        
        test_state = 2;
    }
    else if(test_state == 2)
    {
        if(!strncmp(MyAntTestResults.TxPower_status,"FAIL: BGT Init", 14))
        {
            LCD_Position(3, 0); 
            LCD_PrintString("FAIL: BGT Init");            
        }   
        else
        {
            sprintf(MyAntTestResults.PLL_status, "PASS");       // Assume they will pass.
            sprintf(MyAntTestResults.TxPower_status, "PASS");
            
            if((MyAntTestResults.LowFreqLock == 0) || (MyAntTestResults.MidFreqLock == 0) || (MyAntTestResults.HighFreqLock == 0))
            {
                sprintf(MyAntTestResults.PLL_status, "FAIL: PLL lock");
            } 
            else if((MyAntTestResults.LowFreqTxPower < TX_PWR_MIN) || (MyAntTestResults.MidFreqTxPower < TX_PWR_MIN) || (MyAntTestResults.HighFreqTxPower < TX_PWR_MIN))
            {
                sprintf(MyAntTestResults.TxPower_status, "FAIL: RF power");             
            }
             
           
            if(!strncmp(MyAntTestResults.PLL_status, "FAIL: PLL lock", 14))
            {
                LCD_Position(3, 0); 
                LCD_PrintString("FAIL: PLL Lock");
            } 
            else if(!strncmp(MyAntTestResults.TxPower_status, "FAIL: RF power", 14))
            {
                LCD_Position(3, 0); 
                LCD_PrintString("FAIL: RF power");              
            }
            else
            {
                LCD_Position(3, 0); 
                LCD_PrintString("Status: PASS");
            }
        }

        test_state = 3;
    }
    else
    {
        if(ManualModeFlag == 0)
        {
            STATE = RUN;
            test_state = 0;
        }       
    }   
}

void SingleWireCommTest(void)
{
    if(!MyTestResults.DUT_SingleWireComm)
    {
        STATE = ALARM_PWR_TEST;
    }
    else
    {
        if(test_state == 0)
        {
            LCD_ClearDisplay();
            LCD_Position(0,0);
            LCD_PrintString("Single Wire Comm");
                              
            // Generate Target
            MyTarget.amplitude = AMPLITUDE_MAX;
            MyTarget.range = 40;    // ft.
            MyTarget.angle = 0.0;   // degrees
            SetTarget(pMyTarget);
            
            sprintf(MyTestResults.SingleWire_status, "FAIL: Single Comm");
            MyTestResults.SingleWirePWM_TimeHigh = 0.0;
            MyTestResults.SingleWirePWM_TimeLow = 0.0;

            EdgeCounter = 0;
            prevTimeHigh = 100.0;
            prevTimeLow = 100.0;
      
            REVERSE_HIGH;   // Set reverse input high.
            
            MUX_EN_LOW;
            IQ_SEL_HIGH;
            
            SingleWireCommCounter_Start();
            comm_interrupt_StartEx(COMM_ISR);
            
            CyDelay(250);
         
            test_state = 1;
        }
        else if(test_state == 1)
        {
            // The measurement is made in the COMM_ISR
            TIMEOUT_COUNTER = 20000;
            while((TIMEOUT_COUNTER != 0)&&(test_state == 1))
            {
                TIMEOUT_COUNTER--;
            }       
            
            if(TIMEOUT_COUNTER == 0)
            {
                test_state = 2;
            }
        }
        else if(test_state == 2)
        {
            SingleWireCommCounter_Stop();
            comm_interrupt_Disable();
            
            // Show the results on the LCD.
            if(MyTestResults.SingleWirePWM_TimeHigh != prevTimeHigh)
            {
                prevTimeHigh = MyTestResults.SingleWirePWM_TimeHigh;
                LCD_Position(1,0);
                sprintf(stringA, "Time Hi: %2.1f ms", MyTestResults.SingleWirePWM_TimeHigh);
                LCD_PrintString(stringA);
                
            }
            
            if(MyTestResults.SingleWirePWM_TimeLow != prevTimeLow)
            {
                prevTimeLow = MyTestResults.SingleWirePWM_TimeLow;
                LCD_Position(2,0);
                sprintf(stringB, "Time Lo: %2.1f ms", MyTestResults.SingleWirePWM_TimeLow);
                LCD_PrintString(stringB);
                
            }
            
            // Determine PASS or FAIL.
            sprintf(MyTestResults.SingleWire_status, "PASS"); // Assume it's going to pass.
            double MAX = 29.4 + COMM_TOLERANCE;
            double MIN = 29.4 - COMM_TOLERANCE;
            if((MyTestResults.SingleWirePWM_TimeHigh > MAX) || (MyTestResults.SingleWirePWM_TimeHigh < MIN))
            {
                sprintf(MyTestResults.SingleWire_status, "FAIL: Single Comm");
            }
            
            MAX = 3.6 + COMM_TOLERANCE;
            MIN = 3.6 - COMM_TOLERANCE;
            if((MyTestResults.SingleWirePWM_TimeLow > MAX) || (MyTestResults.SingleWirePWM_TimeLow < MIN))
            {
                sprintf(MyTestResults.SingleWire_status, "FAIL: Single Comm");
            }
            
            if(!strncmp(MyTestResults.SingleWire_status, "PASS", 4))
            {
                LCD_Position(3,0);
                LCD_PrintString("Status: PASS");
            }
            else
            {
                LCD_Position(3,0);
                LCD_PrintString("Status: FAIL");                
            }
            
            CyDelay(500);
            
            test_state = 3;            
        }
        else
        {
            if(ManualModeFlag == 0)
            {
                STATE = RUN;
                test_state = 0;
            }   
        } 
           
    }  
}

CY_ISR(TIMEOUT_ISR)
{
    
    uint8 status = 0;
    status = I2C_MasterStatus();
    if( status != 0 )
    {
        while(1);
        //I2C_MasterClearStatus();
    }     
      
}

CY_ISR(COMM_ISR)
{
    if(!RX_Read())
    {                
        MyTestResults.SingleWirePWM_TimeHigh = (255.0 - SingleWireCommCounter_ReadCounter())*0.2;
    }
    else
    {
        MyTestResults.SingleWirePWM_TimeLow = (255.0 - SingleWireCommCounter_ReadCounter())*0.2;  
    }
    
    EdgeCounter++;
    if(EdgeCounter > 1)
    {
        test_state = 2;
        EdgeCounter = 0;
    }
   
    SingleWireCommCounter_WriteCounter(0);
    SingleWireCommCounter_ReadStatusRegister(); // Clear interrupt.
    
}

void IQ_Test(void)
{ 
    uint8 CanRxBuffer[8] = {0,0,0,0,0,0,0,0};
    uint8* pCanRxBuffer = &CanRxBuffer[0];
 
    int16* pCH1I = &IQ_Buffer[0];
    int16* pCH1Q = &IQ_Buffer[399];
    int16* pCH2I = &IQ_Buffer[799];
    int16* pCH2Q = &IQ_Buffer[1199];
    
    unsigned int index;
    
    if(test_state == 0)
    {     
        LCD_ClearDisplay();  
        LCD_Position(0, 0); 
        LCD_PrintString("IQ Test");
        
        MyTestResults.CH1I_max = 0;
        MyTestResults.CH1Q_max = 0;
        MyTestResults.CH2I_max = 0;
        MyTestResults.CH2Q_max = 0;
        MyTestResults.CH1I_phase = -180;
        MyTestResults.CH1Q_phase = -180;
        MyTestResults.CH2I_phase = -180;
        MyTestResults.CH2Q_phase = -180;
        
        int temp;
        for(temp = 0; temp < 1600; temp++)
        {
            IQ_Buffer[temp] = 0;
        }

        IQ_index = 0;
        
        sprintf(MyTestResults.IQ_status, "Started");
 
        IQ_SEL_HIGH;
        MUX_EN_LOW; 
        
        CAN_Start();
        PWM_DMA_Start();
        
        MyTarget.range = 11;
        MyTarget.angle = 0;
        MyTarget.amplitude = AMPLITUDE_MAX;
        SetTarget(pMyTarget);
        
        CyDelay(500);   // Allow the target to settle.
             
        LCD_Position(1, 0); 
        LCD_PrintString("Collecting data...");
         
        if(SendSrvcToolCmd(CMD_ENT_SERV, pCanRxBuffer))
        {
            if(SendSrvcToolCmd(CMD_ENT_FACT_CAL_MODE, pCanRxBuffer))
            {        
                IQ_index = 0;
                if(SendSrvcToolCmd(CMD_REQUEST_DATA_SNAPSHOT, pCanRxBuffer))
                {  
                    IQ_TestFlag = 1;
                    while(IQ_index < 800)
                    {
                        CyDelay(500);
                    }
             
                    test_state = 1;
                }
                else
                {
                    test_state = 2; // FAIL
                    sprintf(MyTestResults.IQ_status, "FAIL: CAN Timeout");
                }    
            }
            else
            {
                test_state = 2; // FAIL
                sprintf(MyTestResults.IQ_status, "FAIL: CAN Timeout");
            }
        }
        else
        {
            test_state = 2; // FAIL
            sprintf(MyTestResults.IQ_status, "FAIL: CAN Timeout");
        }   
                
        IQ_TestFlag = 0;
        test_state = 1;

    }
    else if(test_state == 1)
    {  
        LCD_Position(2, 0); 
        LCD_PrintString("Analyzing data...");

        // Find the maximum amplitudes.
        for(index = 0; index < 400; index++)
        {
            if(pCH1I[index] > MyTestResults.CH1I_max)
            {
                MyTestResults.CH1I_max = pCH1I[index];
            }       
        }

        for(index = 0; index < 400; index++)
        {
            if(pCH1Q[index] > MyTestResults.CH1Q_max)
            {
                MyTestResults.CH1Q_max = pCH1Q[index];
            }       
        }
        
        for(index = 0; index < 400; index++)
        {
            if(pCH2I[index] > MyTestResults.CH2I_max)
            {
                MyTestResults.CH2I_max = pCH2I[index];
            }       
        }
        
        for(index = 0; index < 400; index++)
        {
            if(pCH2Q[index] > MyTestResults.CH2Q_max)
            {
                MyTestResults.CH2Q_max = pCH2Q[index];
            }     
        }
        
        ////////////////////////////////////////////////////
        // Find the phase offsets relative to Ch1 I
        ////////////////////////////////////////////////////
        
        double SampleRate = 1.0/((double)ADC_SAMPLE_FREQ);
        double OnePeriod = 1.0/MyTarget.frequency;
        TimeBinsPerPeriod = OnePeriod/SampleRate;
        TimeBinsToSearch = TimeBinsPerPeriod/2;
        
        // Find the minimum point between the middle of the data and one period.
        POINT CH1I_min;
        POINT CH1Q_min;
        POINT CH2I_min;
        POINT CH2Q_min;
        CH1I_min.X = 0;
        CH1I_min.Y = 0;
        CH1Q_min.X = 0;
        CH1Q_min.Y = 0;
        CH2I_min.X = 0;
        CH2I_min.Y = 0;
        CH2Q_min.X = 0;
        CH2Q_min.Y = 0;
        
        for(index = 200; index < 200+TimeBinsPerPeriod; index++)
        {
            if(pCH1I[index] < CH1I_min.Y)
            {
                CH1I_min.Y = pCH1I[index];
                CH1I_min.X = index;
            }       
        }

        for(index = CH1I_min.X ; index > CH1I_min.X-TimeBinsPerPeriod; index--)
        {
            if(pCH1Q[index] < CH1Q_min.Y)
            {
                CH1Q_min.Y = pCH1Q[index];
                CH1Q_min.X = index;
            }       
        }
        
        for(index = 200; index < 200+TimeBinsPerPeriod; index++)
        {
            if(pCH2I[index] < CH2I_min.Y)
            {
                CH2I_min.Y = pCH2I[index];
                CH2I_min.X = index;
            }       
        }
        
        for(index = CH2I_min.X ; index > CH2I_min.X-TimeBinsPerPeriod; index--)
        {
            if(pCH2Q[index] < CH2Q_min.Y)
            {
                CH2Q_min.Y = pCH2Q[index];
                CH2Q_min.X = index;
            }     
        }

        // Find the maximum point between the middle of the data and one period.
        POINT CH1I_max;
        POINT CH1Q_max;
        POINT CH2I_max;
        POINT CH2Q_max;
        CH1I_max.X = 0;
        CH1I_max.Y = 0;
        CH1Q_max.X = 0;
        CH1Q_max.Y = 0;
        CH2I_max.X = 0;
        CH2I_max.Y = 0;
        CH2Q_max.X = 0;
        CH2Q_max.Y = 0;
        
        for(index = 200; index < 200+TimeBinsPerPeriod; index++)
        {
            if(pCH1I[index] > CH1I_max.Y)
            {
                CH1I_max.Y = pCH1I[index];
                CH1I_max.X = index;
            }       
        }

        for(index = CH1I_max.X ; index > CH1I_max.X-TimeBinsPerPeriod; index--)
        {
            if(pCH1Q[index] > CH1Q_max.Y)
            {
                CH1Q_max.Y = pCH1Q[index];
                CH1Q_max.X = index;
            }       
        }
        
        for(index = 200; index < 200+TimeBinsPerPeriod; index++)
        {
            if(pCH2I[index] > CH2I_max.Y)
            {
                CH2I_max.Y = pCH2I[index];
                CH2I_max.X = index;
            }       
        }
        
        for(index = CH2I_max.X ; index > CH2I_max.X-TimeBinsPerPeriod; index--)
        {
            if(pCH2Q[index] > CH2Q_max.Y)
            {
                CH2Q_max.Y = pCH2Q[index];
                CH2Q_max.X = index;
            }     
        }
        
        double CH1I_slope = 0.0;
        double CH1Q_slope = 0.0;
        double CH2I_slope = 0.0;
        double CH2Q_slope = 0.0;
        CH1I_slope = (double)(CH1I_max.Y - CH1I_min.Y) / (double)(CH1I_max.X - CH1I_min.X);
        CH1Q_slope = (double)(CH1Q_max.Y - CH1Q_min.Y) / (double)(CH1Q_max.X - CH1Q_min.X);
        CH2I_slope = (double)(CH2I_max.Y - CH2I_min.Y) / (double)(CH2I_max.X - CH2I_min.X);
        CH2Q_slope = (double)(CH2Q_max.Y - CH2Q_min.Y) / (double)(CH2Q_max.X - CH2Q_min.X);
        
        // Find the region of interest (the positive slope).
        uint16 CH1I_ROI_start = 200;
        uint16 CH1I_ROI_end = 200+TimeBinsPerPeriod;
        uint16 CH1Q_ROI_start = 200;
        uint16 CH1Q_ROI_end = 200+TimeBinsPerPeriod;
        uint16 CH2I_ROI_start = 200;
        uint16 CH2I_ROI_end = 200+TimeBinsPerPeriod;
        uint16 CH2Q_ROI_start = 200;
        uint16 CH2Q_ROI_end = 200+TimeBinsPerPeriod;
        
        if(CH1I_slope > 0)
        {
            CH1I_ROI_start = CH1I_min.X;
            CH1I_ROI_end = CH1I_max.X;
        }
        else
        {
            CH1I_ROI_start = CH1I_max.X;
            CH1I_ROI_end = CH1I_min.X;      
        }
        
        if(CH1Q_slope > 0)
        {
            CH1Q_ROI_start = CH1Q_min.X;
            CH1Q_ROI_end = CH1Q_max.X;
        }
        else
        {
            CH1Q_ROI_start = CH1Q_max.X;
            CH1Q_ROI_end = CH1Q_min.X;      
        }
        
        if(CH2I_slope > 0)
        {
            CH2I_ROI_start = CH2I_min.X;
            CH2I_ROI_end = CH2I_max.X;
        }
        else
        {
            CH2I_ROI_start = CH2I_max.X;
            CH2I_ROI_end = CH2I_min.X;      
        }
        
        if(CH2Q_slope > 0)
        {
            CH2Q_ROI_start = CH2Q_min.X;
            CH2Q_ROI_end = CH2Q_max.X;
        }
        else
        {
            CH2Q_ROI_start = CH2Q_max.X;
            CH2Q_ROI_end = CH2Q_min.X;      
        }
         
        ////////////////////////////////////////////////////////////////////////////////
        // 1) Find the zero crossing. 
        ////////////////////////////////////////////////////////////////////////////////
        
        POINT PointA;
        POINT PointB;
        POINT ZeroPoint;
        double slope;
          
        PointA.X = 0;
        PointA.Y = IQ_AMPLITUDE_MAX;
        PointB.X = 0;
        PointB.Y = -1*IQ_AMPLITUDE_MAX;
        
        // Find the point closest to zero above the x-axis.
        for(index = CH1I_ROI_start; index < CH1I_ROI_end; index++)
        {  
            if( (pCH1I[index] < PointA.Y) && (pCH1I[index] > 0) )
            {
                PointA.X = index;
                PointA.Y = pCH1I[index];
            } 
        }
        
        // Look on either side of PointA for the first point that goes below zero.
        for(index = PointA.X; index < PointA.X + 10; index++)
        {
            if( pCH1I[index] < 0 )   
            {
                PointB.X = index;
                PointB.Y = pCH1I[index];
                break;
            }
        }
        
        for(index = PointA.X; index > PointA.X - 10; index--)
        {
            if( pCH1I[index] < 0 )   
            {
                PointB.X = index;
                PointB.Y = pCH1I[index];
                break;
            }
        }
        
        // Derive a linear equation based on PointA and PointB and extrapolate the zero crossing.
        slope = (double)(PointB.Y - PointA.Y) / (double)(PointB.X - PointA.X);
        ZeroPoint.Y = 0.0;
        ZeroPoint.X = (ZeroPoint.Y + slope*PointA.X - PointA.Y)/slope;
        MyTestResults.CH1I_phase = ZeroPoint.X;
           
        ////////////////////////////////////////////////////////////////////////////////
        // 2) Find the index of the CH1Q zero crossing within 1/2 period of CH1I_index
        ////////////////////////////////////////////////////////////////////////////////
        
        PointA.X = 0;
        PointA.Y = IQ_AMPLITUDE_MAX;
        PointB.X = 0;
        PointB.Y = -1*IQ_AMPLITUDE_MAX;
        
        // Find the point closest to zero above the x-axis.
        for(index = CH1Q_ROI_start; index < CH1Q_ROI_end; index++)
        {  
            if( (pCH1Q[index] < PointA.Y) && (pCH1Q[index] > 0) )
            {
                PointA.X = index;
                PointA.Y = pCH1Q[index];
            } 
        }
        
        // Look on either side of PointA for the first point that goes below zero.
        for(index = PointA.X; index < PointA.X + 10; index++)
        {
            if( pCH1Q[index] < 0 )   
            {
                PointB.X = index;
                PointB.Y = pCH1Q[index];
                break;
            }
        }
        
        for(index = PointA.X; index > PointA.X - 10; index--)
        {
            if( pCH1Q[index] < 0 )   
            {
                PointB.X = index;
                PointB.Y = pCH1Q[index];
                break;
            }
        }

        // Derive a linear equation based on PointA and PointB and extrapolate the zero crossing.
        slope = (double)(PointB.Y - PointA.Y) / (double)(PointB.X - PointA.X);
        ZeroPoint.Y = 0.0;
        ZeroPoint.X = (ZeroPoint.Y + slope*PointA.X - PointA.Y)/slope;
        MyTestResults.CH1Q_phase = ZeroPoint.X;
        
        ////////////////////////////////////////////////////////////////////////////////
        // 3) Find a zero crossing of CH2I somewhere near the middle of the data. 
        ////////////////////////////////////////////////////////////////////////////////
        
        PointA.X = 0;
        PointA.Y = IQ_AMPLITUDE_MAX;
        PointB.X = 0;
        PointB.Y = -1*IQ_AMPLITUDE_MAX;
        
        // Find the point closest to zero above the x-axis.
        for(index = CH2I_ROI_start; index < CH2I_ROI_end; index++)
        {  
            if( (pCH2I[index] < PointA.Y) && (pCH2I[index] > 0) )
            {
                PointA.X = index;
                PointA.Y = pCH2I[index];
            } 
        }
        
        // Look on either side of PointA for the first point that goes below zero.
        for(index = PointA.X; index < PointA.X + 10; index++)
        {
            if( pCH2I[index] < 0 )   
            {
                PointB.X = index;
                PointB.Y = pCH2I[index];
                break;
            }
        }
 
        for(index = PointA.X; index > PointA.X - 10; index--)
        {
            if( pCH2I[index] < 0 )   
            {
                PointB.X = index;
                PointB.Y = pCH2I[index];
                break;
            }
        }
        
        // Derive a linear equation based on PointA and PointB and extrapolate the zero crossing.
        slope = (double)(PointB.Y - PointA.Y) / (double)(PointB.X - PointA.X);
        ZeroPoint.Y = 0.0;
        ZeroPoint.X = (ZeroPoint.Y + slope*PointA.X - PointA.Y)/slope;
        MyTestResults.CH2I_phase = ZeroPoint.X;
        
        ////////////////////////////////////////////////////////////////////////////////
        // 4) Find the index of the CH2Q zero crossing within 1/2 period of CH2I_index
        ////////////////////////////////////////////////////////////////////////////////
        
        PointA.X = 0;
        PointA.Y = IQ_AMPLITUDE_MAX;
        PointB.X = 0;
        PointB.Y = -1*IQ_AMPLITUDE_MAX;
        
        // Find the point closest to zero above the x-axis.
        for(index = CH2Q_ROI_start; index < CH2Q_ROI_end; index++)
        {  
            if( (pCH2Q[index] < PointA.Y) && (pCH2Q[index] > 0) )
            {
                PointA.X = index;
                PointA.Y = pCH2Q[index];
            } 
        }
        
        // Look on either side of PointA for the first point that goes below zero.
        for(index = PointA.X; index < PointA.X + 10; index++)
        {
            if( pCH2Q[index] < 0 )   
            {
                PointB.X = index;
                PointB.Y = pCH2Q[index];
                break;
            }
        }
        
        for(index = PointA.X; index > PointA.X - 10; index--)
        {
            if( pCH2Q[index] < 0 )   
            {
                PointB.X = index;
                PointB.Y = pCH2Q[index];
                break;
            }
        }

        // Derive a linear equation based on PointA and PointB and extrapolate the zero crossing.
        slope = (double)(PointB.Y - PointA.Y) / (double)(PointB.X - PointA.X);
        ZeroPoint.Y = 0.0;
        ZeroPoint.X = (ZeroPoint.Y + slope*PointA.X - PointA.Y)/slope;
        MyTestResults.CH2Q_phase = ZeroPoint.X;
                    
        sprintf(MyTestResults.IQ_status, "PASS"); // Assume it's going to pass.
        
        // Check the amplitude results
        if((MyTestResults.CH1I_max < IQ_AMPLITUDE_MIN) || (MyTestResults.CH1I_max > IQ_AMPLITUDE_MAX))
        {
            sprintf(MyTestResults.IQ_status, "FAIL: CH1I Amplitude");
        }   
        else if((MyTestResults.CH1Q_max < IQ_AMPLITUDE_MIN) || (MyTestResults.CH1Q_max > IQ_AMPLITUDE_MAX))
        {
            sprintf(MyTestResults.IQ_status, "FAIL: CH1Q Amplitude");
        }
        else if((MyTestResults.CH2I_max < IQ_AMPLITUDE_MIN) || (MyTestResults.CH2I_max > IQ_AMPLITUDE_MAX))
        {
            sprintf(MyTestResults.IQ_status, "FAIL: CH2I Amplitude");
        }
        else if((MyTestResults.CH2Q_max < IQ_AMPLITUDE_MIN) || (MyTestResults.CH2Q_max > IQ_AMPLITUDE_MAX))
        {
            sprintf(MyTestResults.IQ_status, "FAIL: CH2Q Amplitude");
        }
        
        // Check the phase results.
        //double DegreesPerBin = 360.0/(double)TimeBinsPerPeriod;
        //int BinTolerance = PHASE_TOLERANCE / DegreesPerBin;
        int NinetyDegreesFromI1 = MyTestResults.CH1I_phase - TimeBinsPerPeriod/4;
        
        int MAX = MyTestResults.CH1I_phase + PHASE_TOLERANCE;
        int MIN = MyTestResults.CH1I_phase - PHASE_TOLERANCE;
        
        // CH1I and CH2I should be in phase.
        if( (MyTestResults.CH2I_phase > MAX) || (MyTestResults.CH2I_phase < MIN) )
        {
            sprintf(MyTestResults.IQ_status, "FAIL: CH2I phase");
        }
        else
        {
            MAX = NinetyDegreesFromI1 + PHASE_TOLERANCE;
            MIN = NinetyDegreesFromI1 - PHASE_TOLERANCE;
            
            // CH1I and CH1Q should be 90 degrees out of phase.
            if( (MyTestResults.CH1Q_phase > MAX) || (MyTestResults.CH1Q_phase < MIN) )
            {
                sprintf(MyTestResults.IQ_status, "FAIL: CH1Q phase");
            }   
            else
            {              
                // CH1I and CH2Q should be 90 degrees out of phase.
                if( (MyTestResults.CH2Q_phase > MAX) || (MyTestResults.CH2Q_phase < MIN) )
                {
                    sprintf(MyTestResults.IQ_status, "FAIL: CH2Q phase");
                } 
            }
        }
     
        test_state = 2;
        
    }
    else if(test_state == 2)
    {
        IQ_TestFlag = 0;
        if(!strncmp(MyTestResults.IQ_status, "FAIL: CAN Timeout", 18))
        {
            LCD_Position(3, 0); 
            LCD_PrintString("FAIL:CAN Timeout"); 
            CyDelay(1000);
        }
        else if(!strncmp(MyTestResults.IQ_status, "FAIL: CH1I Amplitude",20))
        {
            LCD_Position(3, 0); 
            LCD_PrintString("FAIL:CH1I Amp Low"); 
            CyDelay(1000);
        }
        else if(!strncmp(MyTestResults.IQ_status, "FAIL: CH1Q Amplitude",20))
        {
            LCD_Position(3, 0); 
            LCD_PrintString("FAIL:CH1Q Amp Low"); 
            CyDelay(1000);
        }
        else if(!strncmp(MyTestResults.IQ_status, "FAIL: CH2I Amplitude",20))
        {
            LCD_Position(3, 0); 
            LCD_PrintString("FAIL:CH2I Amp Low");
            CyDelay(1000);
        }
        else if(!strncmp(MyTestResults.IQ_status, "FAIL: CH2Q Amplitude",20))
        {
            LCD_Position(3, 0); 
            LCD_PrintString("FAIL:CH2Q Amp Low");
            CyDelay(1000);
        } 
        else if(!strncmp(MyTestResults.IQ_status, "FAIL: CH2I phase",17))
        {
            LCD_Position(3, 0); 
            LCD_PrintString("FAIL:CH2I Phase");  
            CyDelay(1000);
        }
        else if(!strncmp(MyTestResults.IQ_status, "FAIL: CH1Q phase",17))
        {
            LCD_Position(3, 0); 
            LCD_PrintString("FAIL:CH1Q Phase"); 
            CyDelay(1000);
        }
        else if(!strncmp(MyTestResults.IQ_status, "FAIL: CH2Q phase",17))
        {
            LCD_Position(3, 0); 
            LCD_PrintString("FAIL:CH2Q Phase");   
            CyDelay(1000);
        }
        else
        {
            LCD_Position(3, 0); 
            LCD_PrintString("Status: PASS");  
            CyDelay(500);
        }
              
        test_state = 3;
    }
    else
    {
        if(ManualModeFlag == 0)
        {
            STATE = RUN;
            test_state = 0;
        }        
    }   
}

void RevInputTest(void)
{
    unsigned char rev_status = 0xFF;

    if(test_state == 0)
    {           
        LCD_ClearDisplay();
        LCD_Position(0, 0); 
        LCD_PrintString("Reverse Input Test");    
        
        CAN_Start();
        CyDelay(100);
        
        sprintf(MyTestResults.REV_status, "Started");
        
        test_state = 1;
    }
    else if(test_state == 1)
    {      
        // Set reverse input low.
        REVERSE_LOW;
        
        // Check the reverse status byte of the CAN message.
        TIMEOUT_COUNTER = 1000000;
        while((TIMEOUT_COUNTER != 0) && (rev_status != 0))
        {
            TIMEOUT_COUNTER--;
            if(newCANdata_FromSensor)
            {
                newCANdata_FromSensor = 0;
                rev_status = RxBuffer_FROM_SENSOR[3];         
            }
        }
        
        if(TIMEOUT_COUNTER == 0)
        {
            test_state = 4;   
        }
        else
        {
            test_state = 2;
        }
    }
    else if(test_state == 2)
    {
        // Set reverse input high.
        REVERSE_HIGH;
        
        // Check the reverse status byte of the CAN message.
        TIMEOUT_COUNTER = 1000000;
        while((TIMEOUT_COUNTER != 0) && (rev_status != 1))
        {
            TIMEOUT_COUNTER--;
            if(newCANdata_FromSensor)
            {
                newCANdata_FromSensor = 0;
                rev_status = RxBuffer_FROM_SENSOR[3];         
            }
        }
        
        if(TIMEOUT_COUNTER == 0)
        {
            test_state = 4;   
        }
        else
        {
            test_state = 3;
        }        
    }
    else if(test_state == 3)
    {
        // Set reverse input low.
        REVERSE_LOW;
        
        // Check the reverse status byte of the CAN message.
        TIMEOUT_COUNTER = 1000000;
        while((TIMEOUT_COUNTER != 0) && (rev_status != 0))
        {
            TIMEOUT_COUNTER--;
            if(newCANdata_FromSensor)
            {
                newCANdata_FromSensor = 0;
                rev_status = RxBuffer_FROM_SENSOR[3];         
            }
        }
        
        if(TIMEOUT_COUNTER == 0)
        {
            test_state = 4;   
        }
        else
        {
            test_state = 4;
        }               
    }
    else if(test_state == 4)
    {
        CAN_Stop();
        
        if(TIMEOUT_COUNTER == 0)
        {
            LCD_Position(1, 0); 
            LCD_PrintString("Status: FAIL");
            sprintf(MyTestResults.REV_status, "FAIL: Rev Input");
        }
        else
        {
            LCD_Position(1, 0); 
            LCD_PrintString("Status: PASS"); 
            sprintf(MyTestResults.REV_status, "PASS");
        }
    
        CyDelay(500);
        
        test_state = 5;   
    }
    else
    {
        if(ManualModeFlag == 0)
        {
            STATE = RUN;
            test_state = 0;
        }
    }   
}

void CanCommTest(void)
{ 
    uint8 CanRxBuffer[8] = {0,0,0,0,0,0,0,0};
    uint8* pCanRxBuffer = &CanRxBuffer[0];
    
    if(test_state == 0)
    {        
        MUX_EN_HIGH;
        
        LCD_ClearDisplay();    
        
        MyTestResults.DUT_DeviceClass = 0;
        MyTestResults.CAN_NumRX = 0;
        DUT_FtPerBin = 0.0;
        DUT_HzPerBin = 0.0;
        
        sprintf(MyTestResults.CAN_status, "FAIL: CAN"); // Assume it's going to fail.
        
        CAN_Start();
        CyDelay(100);
           
        test_state = 2; // Assume it's going to fail.
        CanFailFlag = 1;
        
        if(SendSrvcToolCmd(CMD_ENT_SERV, pCanRxBuffer)) // Put the DUT into service mode.
        {
            CyDelay(500);
            if(SendSrvcToolCmd(CMD_READ_DEVICE_CLASS, pCanRxBuffer)) // Read the device class.
            {
                MyTestResults.DUT_DeviceClass = RxBuffer_SRVC_TOOL_RESPONSE[2];  
                LCD_Position(0, 0); 
                sprintf(stringA, "Class:%u", MyTestResults.DUT_DeviceClass);
                LCD_PrintString(stringA);
                 
                if(SendSrvcToolCmd(CMD_ENT_FACT_CAL_MODE, pCanRxBuffer)) // Enter Factory Cal. mode.
                {
                    if(SendSrvcToolCmd(CMD_GET_RANGE_RESOLUTION, pCanRxBuffer)) // Get Range resolution.
                    {
                        unsigned int temp = 0;
                        temp = temp | pCanRxBuffer[2];
                        temp = temp << 8;
                        temp |= pCanRxBuffer[1];    
                        DUT_FtPerBin = temp / 1000.0;    // ft/bin
                                                        
                        temp = 0;
                        temp = temp | pCanRxBuffer[4];
                        temp = temp << 8;
                        temp |= pCanRxBuffer[3];    
                        ADC_SAMPLE_FREQ = temp*1000;    
                        
                        temp = 0;
                        temp = temp | pCanRxBuffer[6];
                        temp = temp << 8;
                        temp |= pCanRxBuffer[5];    
                        RANGE_FFT_LENGTH = temp*1000;  
                        
                        DUT_HzPerBin = ((double)ADC_SAMPLE_FREQ*1000.0) / (double)RANGE_FFT_LENGTH;    
                        
                        LCD_Position(1, 0); 
                        sprintf(stringB, "ft/Bin: %3.3f", DUT_FtPerBin);
                        LCD_PrintString(stringB);
                        
                        LCD_Position(2, 0); 
                        sprintf(stringC, "Hz/Bin: %3.3f", DUT_HzPerBin);
                        LCD_PrintString(stringC);
                        
                        if(SendSrvcToolCmd(CMD_GET_PRE_PROC_SETTNGS, pCanRxBuffer))
                        {
                            PreProcRangeType = pCanRxBuffer[1]; // Pre-processing range type.
                            PreProcPhaseType = pCanRxBuffer[2]; // Pre-processing phase type.  
                            NumScans = pCanRxBuffer[3];         // # of scans 
                            WindowType = pCanRxBuffer[5];       // Window type  
                            
                            if(SendSrvcToolCmd(CMD_SET_PRE_PROC_SETTNGS, pCanRxBuffer))
                            {                       
                                if(SendSrvcToolCmd(CMD_ENT_SERV, pCanRxBuffer)) // Enter service mode again.
                                {
                                    if(SendSrvcToolCmd(CMD_WR_NEW_PVS_RNG, pCanRxBuffer)) // Set the range to 200 ft.
                                    {
                                        if(SendSrvcToolCmd(CMD_ALM_ZONE, pCanRxBuffer)) // Set the trigger range to 200 ft.
                                        {  
                                            LCD_Position(0, 10); 
                                            if(MyTestResults.DUT_DeviceClass == 16)
                                            {
                                                LCD_PrintString("Rng:28ft"); 
                                            }
                                            else
                                            {
                                                LCD_PrintString("Rng:200ft"); 
                                            }
                                            test_state = 1;
                                            CanFailFlag = 0;
                                            
                                            if(SendSrvcToolCmd(READ_CONTR_CLASS_REV, pCanRxBuffer))
                                            {
                                                MyTestResults.DUT_SingleWireComm = pCanRxBuffer[6];
                                                
                                                if(!SendSrvcToolCmd(CMD_EXIT_SERV, pCanRxBuffer)) // Releases Alarm latch if already latched.
                                                {
                                                    CanFailFlag = 1;
                                                    test_state = 2;
                                                }  
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
        
    }    
    else if( test_state == 1)
    {
        TIMEOUT_COUNTER = 10000000;
        while(TIMEOUT_COUNTER != 0)
        {
            TIMEOUT_COUNTER--;
             
            if(newCANdata_FromSensor)
            {
                TIMEOUT_COUNTER = 10000000;
                newCANdata_FromSensor = 0;
                MyTestResults.CAN_NumRX++; 
                
                LCD_Position(3, 0); 
                sprintf(stringA, "RX: %u", MyTestResults.CAN_NumRX);
                LCD_PrintString(stringA); 
                
                if(MyTestResults.CAN_NumRX >= 10)
                {
                    test_state = 2;
                    break;
                }
                
            } 
        }
        
        if(TIMEOUT_COUNTER == 0)
        {    
            CanFailFlag = 2;    
        }

        test_state = 2;
       
    }
    else if(test_state == 2)
    {
        CAN_Stop();
     
        if(CanFailFlag == 1)
        {
            LCD_Position(0, 0); 
            LCD_PrintString("Class: 0");
            
            LCD_Position(0, 10); 
            LCD_PrintString("Rng:0ft"); 
            
            LCD_Position(1, 0); 
            LCD_PrintString("ft/Bin: 0");
            
            LCD_Position(2, 0);
            LCD_PrintString("Hz/Bin: 0");
                        
            LCD_Position(3, 0); 
            LCD_PrintString("Status: CAN Fail");
            
            sprintf(MyTestResults.CAN_status, "FAIL: CAN Srvc Mode");
        }
        else if(CanFailFlag == 2)
        {
            LCD_Position(3, 0); 
            LCD_PrintString("Status: RX Fail");  
            
            sprintf(MyTestResults.CAN_status, "FAIL: CAN RX");    
        }
        else
        {
            LCD_Position(3, 10); 
            LCD_PrintString("PASS");  
            
            sprintf(MyTestResults.CAN_status, "PASS");
        }
        
        test_state = 3;
    }
    else
    {
        if(ManualModeFlag == 0)
        {
            STATE = RUN;
            test_state = 0;
        }
    }   
}

void AlarmPowerTest(void)
{
    if(MyTestResults.DUT_SingleWireComm)
    {
        STATE = SINGLE_WIRE_TEST;
    }
    else
    {
        if(test_state == 0)
        {
            //CAN_Stop();
            
            MUX_EN_LOW;
            IQ_SEL_HIGH;
            
            // Generate Target
            MyTarget.amplitude = AMPLITUDE_MAX;
            MyTarget.range = 20;    // ft.
            MyTarget.angle = 0.0;   // degrees
            SetTarget(pMyTarget);
            
            test_state = 1;
            LCD_ClearDisplay();
            LCD_Position(0, 0); 
            LCD_PrintString("Alarm Power Test");
            Ialarm = 0.0;
            MyTestResults.Ialarm_TRIP = 0.0;   
            Vcon2 = 0.500;  // Ialarm =  0.45*Vcon2 
            
            sprintf(MyTestResults.ALARM_status, "FAIL: Alarm"); // Assume it's going to fail.
            
            REVERSE_HIGH;   // Set reverse input high.
                  
            test_state = 1;
        }   
        else if(test_state == 1)
        {
       
            LCD_Position(2, 0); 
            sprintf(stringA, "Vcon2: %2.3f", Vcon2);
            LCD_PrintString(stringA);
            
            duty_cycle = (double)Vcon2/3.3;
            PWM_ALARM_WriteCompare((uint8)(duty_cycle*255));  
            
            // Allow the current to settle.  
            CyDelay(500);
            
            TIMEOUT_COUNTER = 0;
            do
            {
                // Measure the voltage
                AnalogMux_FastSelect(Ialarm_Chan);
                ADC_StartConvert();
                while(!ADC_IsEndConversion(ADC_RETURN_STATUS));
                RawCount = ADC_GetResult32();
                if(RawCount < 0)
                {
                    RawCount = 0;
                }
                Ialarm = (double)RawCount*ADC_RESOLUTION/(2.0); 
                
                LCD_Position(1, 0); 
                sprintf(stringB, "Ialarm: %2.3f", Ialarm);
                LCD_PrintString(stringB); 
                
                TIMEOUT_COUNTER++;
                
                CyDelay(100);
                
            } while( (TIMEOUT_COUNTER < 100) && (Ialarm < 0.01) );
            
     
            MyTestResults.Ialarm_TRIP = Ialarm;
            
            if(Ialarm >= 0.03) // Expecting approx 0.045A
            {
                // Continue the test.
                //sprintf(MyTestResults.ALARM_status, "Running");
                Vcon2 = 2.0;
                test_state = 2;
            }
            else
            {
                sprintf(MyTestResults.ALARM_status, "FAIL: Alarm current"); 
                test_state = 3;
            }
        }
        else if(test_state == 2)
        {
             // Increase the load current
            Vcon2 = Vcon2 + .10;
            if(Vcon2 >= 3.3)
            {
                MyTestResults.Ialarm_TRIP = 1000000.0;
                sprintf(MyTestResults.ALARM_status, "FAIL: Alarm trip");
                test_state = 3; // Limit the current to 1.485 A max.
            }
           
            LCD_Position(2, 0); 
            sprintf(stringA, "Vcon2: %2.2f", Vcon2);
            LCD_PrintString(stringA);
            
            duty_cycle = (double)Vcon2/3.3;
            PWM_ALARM_WriteCompare((uint8)(duty_cycle*255));  
            
            CyDelay(250);
            
            // Measure the voltage
            AnalogMux_FastSelect(Ialarm_Chan);
            ADC_StartConvert();
            while(!ADC_IsEndConversion(ADC_RETURN_STATUS));
            RawCount = ADC_GetResult32();
            if(RawCount < 0)
            {
                RawCount = 0;
            }
            Ialarm = (double)RawCount*ADC_RESOLUTION/(2.0); 
            
            LCD_Position(1, 0); 
            sprintf(stringB, "Ialarm: %2.3f", Ialarm);
            LCD_PrintString(stringB);  
            
            if(Ialarm > MyTestResults.Ialarm_TRIP)
            {
                MyTestResults.Ialarm_TRIP = Ialarm;
            }
            
            if(Ialarm < 0.1)
            {
                //sprintf(MyTestResults.ALARM_status, "Alarm tripped"); 
                test_state = 3;
            }    
        }
        else if(test_state == 3)
        {
            LCD_Position(2, 0); 
            sprintf(stringA, "Itrip: %2.2f", MyTestResults.Ialarm_TRIP);
            LCD_PrintString(stringA);
     
            if((MyTestResults.Ialarm_TRIP < ALARM_ITRIP_MAX) && (MyTestResults.Ialarm_TRIP > ALARM_ITRIP_MIN))
            {
                LCD_Position(3, 0); 
                LCD_PrintString("Status: PASS"); 
                sprintf(MyTestResults.ALARM_status, "PASS");
            }
            else if ( !strncmp(MyTestResults.ALARM_status, "FAIL: Alarm current", 19))
            {          
                LCD_Position(3, 0); 
                LCD_PrintString("Status: FAIL");    
                CyDelay(1000);
            }
            else
            {
                LCD_Position(3, 0); 
                LCD_PrintString("Status: FAIL"); 
                sprintf(MyTestResults.ALARM_status, "FAIL: Alarm");
                CyDelay(1000);
            }
       
            test_state = 4;
        }
        else
        {
            if(ManualModeFlag == 0)
            {
                STATE = RUN;
                test_state = 0;
            }
        }      
    }
}

void DisplayPowerTest(void)
{
    unsigned char NoLoadVolatageFailFlag = 0;
    unsigned char TripCurrentFailFlag = 0;
    
    if(test_state == 0)
    {        
        MUX_EN_HIGH;
        
        test_state = 1;
        LCD_ClearDisplay();
        LCD_Position(0, 0); 
        LCD_PrintString("Display Power Test");
        Vdisplay = 0.0;
        Idisplay = 0.0;
        Vcon1 = 0.25;
        MyTestResults.Idisp_TRIP = 0.0;
        MyTestResults.Vdisp_NO_LOAD = 0.0;

        PWM_DISPLAY_WriteCompare(0);    // Set the control voltage to 0 (current = 0).            
        CyDelay(250);                   // Allow the current to settle.
        
        sprintf(MyTestResults.DISP_status, "FAIL: Display PWR");
        
        // Read the no load voltage
        AnalogMux_FastSelect(Vdisp_Chan);
        ADC_StartConvert();
        while(!ADC_IsEndConversion(ADC_RETURN_STATUS));
        RawCount = ADC_GetResult16();
        RawCount = RawCount & 0x0000FFFF;
        MyTestResults.Vdisp_NO_LOAD = (double)RawCount*ADC_RESOLUTION*(11.0);   
        
        if(MyTestResults.Vdisp_NO_LOAD < DISP_VOLT_MIN)
        {
            NoLoadVolatageFailFlag = 1;
            test_state = 2; // Skip the current test if the minimum voltage is not met.
        }   
    }
    else if(test_state == 1)
    {       
        // Increase the load current
        Vcon1 = Vcon1 + .01;
        if(Vcon1 > 1.0)
        {
            test_state = 2; // Limit the current to 1.0 A max.
        }
       
        LCD_Position(3, 0); 
        sprintf(stringC, "Vcon1: %2.3f", Vcon1);
        LCD_PrintString(stringC);
        
        duty_cycle = (double)Vcon1/3.3;
        PWM_DISPLAY_WriteCompare((uint8)(duty_cycle*255));  
        
        CyDelay(250);   // Allow the current to settle.
        
        // Measure the voltage
        AnalogMux_FastSelect(Vdisp_Chan);
        ADC_StartConvert();
        while(!ADC_IsEndConversion(ADC_RETURN_STATUS));
        RawCount = ADC_GetResult16();
        RawCount = RawCount & 0x0000FFFF;
        Vdisplay = (double)RawCount*ADC_RESOLUTION*(11.0); 
        
        LCD_Position(1, 0); 
        sprintf(stringA, "Vdisp: %2.2f", Vdisplay);
        LCD_PrintString(stringA);
        
        if(Vdisplay < 0.5)
        {
            MyTestResults.Idisp_TRIP = Idisplay;
            test_state = 2;
        } 
        else
        {   
            // Measure the current             
            AnalogMux_FastSelect(Idisp_Chan);
            ADC_StartConvert();
            while(!ADC_IsEndConversion(ADC_RETURN_STATUS));
            RawCount = ADC_GetResult16();
            Idisplay = (double)(RawCount*ADC_RESOLUTION)/2;          
        }
        
        LCD_Position(2, 0); 
        sprintf(stringB, "Itrip: %2.3f", Idisplay);
        LCD_PrintString(stringB);

    }      
    else if(test_state == 2)
    {
        PWM_DISPLAY_WriteCompare(0); // Turn off the current load.
         
        CyDelay(500);   // Allow the voltage to settle.
        
        // Measure the no load voltage again.
        AnalogMux_FastSelect(Vdisp_Chan);
        ADC_StartConvert();
        while(!ADC_IsEndConversion(ADC_RETURN_STATUS));
        RawCount = ADC_GetResult16();
        RawCount = RawCount & 0x0000FFFF;
        MyTestResults.Vdisp_NO_LOAD = (double)RawCount*ADC_RESOLUTION*(11.0); 
        
        if(MyTestResults.Vdisp_NO_LOAD < DISP_VOLT_MIN)
        {
            NoLoadVolatageFailFlag = 1;    
        }                    
        
        if( MyTestResults.Idisp_TRIP > DISP_ITRIP_MAX )
        {
            TripCurrentFailFlag = 1;
        }
        
        if( MyTestResults.Idisp_TRIP < DISP_ITRIP_MIN )
        {
            TripCurrentFailFlag = 2;
        }
        
        LCD_Position(1, 0); 
        sprintf(stringA, "Vdisp: %2.2f", MyTestResults.Vdisp_NO_LOAD);
        LCD_PrintString(stringA);
        
        LCD_Position(2, 0); 
        sprintf(stringB, "Itrip: %2.3f", MyTestResults.Idisp_TRIP);
        LCD_PrintString(stringB);
        
        LCD_Position(3, 0); 
        if(NoLoadVolatageFailFlag == 1)
        {
            LCD_PrintString("Status: Vdisp Fail");
            sprintf(MyTestResults.DISP_status, "FAIL: Vdisp");
        }
        else if(TripCurrentFailFlag == 1)
        {
            LCD_PrintString("Status: Itrip Low!");
            sprintf(MyTestResults.DISP_status, "FAIL: Itrip low");
        }
        else if(TripCurrentFailFlag == 2)
        {
            LCD_PrintString("Status: Itrip High!");
            sprintf(MyTestResults.DISP_status, "FAIL: Itrip high");
        }
        else
        {
            LCD_PrintString("Status: PASS");
            sprintf(MyTestResults.DISP_status, "PASS");
        }
         
        test_state = 3;         
    }
    else
    {
        if(ManualModeFlag == 0)
        {
            STATE = RUN;
            test_state = 0;
        }
    }    
}

void TargetDetectTest(void)
{
    if(test_state == 0)
    {
        LCD_ClearDisplay();
        LCD_Position(0, 4); 
        LCD_PrintString("Range");
        LCD_Position(0,12);
        LCD_PrintString("Angle");
        
        LCD_Position(1,0);
        LCD_PrintString("TX: ");
        
        LCD_Position(2,0);
        LCD_PrintString("RX: ");
        
        sprintf(MyTestResults.DETECT_status, "FAIL: Target"); // Assume it's going to fail.
        
        CAN_Start();
        PWM_DMA_Start();
        
        IQ_SEL_HIGH;
        MUX_EN_LOW;
        
        prev_freq_counter = 0;
        
        MyPrevTarget.range = 0;
        MyPrevTarget.amplitude = 0;
        MyPrevTarget.angle = 0;
        
        TestRange = 0.0;
        MyTarget.range = TestRange;
        MyTarget.amplitude = AMPLITUDE_MAX;
        MyTarget.angle = -45.0; 
        
        //ResetAllDMAs();
        //CyDelay(500);
        
        test_state = 1;
    }
    else if(test_state == 1)
    { 
        TestRange = TestRange + 50.0;
        MyTarget.range = TestRange;
        
        if(TestRange == 100.0)
        {
            test_state = 2;
        }
        
        if((MyTarget.range != MyPrevTarget.range)||(MyTarget.angle != MyPrevTarget.angle))
        {
            MyPrevTarget.range = MyTarget.range;
            MyPrevTarget.angle = MyTarget.angle;
                          
            SetTarget(pMyTarget);
            CyDelay(500);
            
            if(newCANdata_NGFromSensor)
            {
                newCANdata_NGFromSensor = 0;
                
                RxTarget.range = (double)RxBuffer_NG_FROM_SENSOR[0];
                RxTarget.angle = (int8)RxBuffer_NG_FROM_SENSOR[2];
                
                double MIN;
                double MAX;
                MIN = MyTarget.range - RANGE_TOLERANCE;
                MAX = MyTarget.range + RANGE_TOLERANCE;
                if( (RxTarget.range < MIN) || (RxTarget.range > MAX) )
                {
                    sprintf(MyTestResults.DETECT_status, "FAIL: Range");
                    test_state = 4;
                }
                
                MIN = MyTarget.angle - ANGLE_TOLERANCE;
                MAX = MyTarget.angle + ANGLE_TOLERANCE;                
                if( (RxTarget.angle < MIN) || (RxTarget.angle > MAX) )
                {
                    sprintf(MyTestResults.DETECT_status, "FAIL: Angle");
                    test_state = 4;
                }
            } 
            else
            {
                sprintf(MyTestResults.DETECT_status, "FAIL: CAN Timeout");
                test_state = 4;
            } 
            
            LCD_Position(1,4);
            LCD_PrintString("      ");
            LCD_Position(1,4);
            sprintf( stringA, "%3.1f", MyTarget.range);
            LCD_PrintString(stringA);
            
            LCD_Position(1,12);
            LCD_PrintString("     ");
            LCD_Position(1,12);
            sprintf( stringB, "%2.0f", MyTarget.angle);
            LCD_PrintString(stringB);            
            
            LCD_Position(2,4);
            LCD_PrintString("      ");
            LCD_Position(2,4);
            sprintf( stringC, "%3.1f", RxTarget.range);
            LCD_PrintString(stringC); 
            
            LCD_Position(2,12);
            LCD_PrintString("     ");
            LCD_Position(2,12);
            sprintf( stringA, "%2.0f", RxTarget.angle);
            LCD_PrintString(stringA);  
                   
        } 
    }
    else if(test_state == 2)
    {
        TestRange = 0.0;
        MyTarget.range = TestRange;
        MyTarget.amplitude = AMPLITUDE_MAX;
        MyTarget.angle = 45;  
        test_state = 3;
    }
    else if(test_state == 3)
    {        
        TestRange = TestRange + 50.0;
        MyTarget.range = TestRange;
        
        if(TestRange == 100.0)
        {
            sprintf(MyTestResults.DETECT_status, "PASS");
            test_state = 4;
        }
          
        if((MyTarget.range != MyPrevTarget.range)||(MyTarget.angle != MyPrevTarget.angle))
        {
            MyPrevTarget.range = MyTarget.range;
            MyPrevTarget.angle = MyTarget.angle;
                                 
            SetTarget(pMyTarget);
            CyDelay(500);
            
            if(newCANdata_NGFromSensor)
            {
                newCANdata_NGFromSensor = 0;
                
                RxTarget.range = (double)RxBuffer_NG_FROM_SENSOR[0];
                RxTarget.angle = (int8)RxBuffer_NG_FROM_SENSOR[2];
                
                double MIN;
                double MAX;
                MIN = MyTarget.range - RANGE_TOLERANCE;
                MAX = MyTarget.range + RANGE_TOLERANCE;
                if( (RxTarget.range < MIN) || (RxTarget.range > MAX) )
                {
                    sprintf(MyTestResults.DETECT_status, "FAIL: Range");
                    test_state = 4;
                }
                
                MIN = MyTarget.angle - ANGLE_TOLERANCE;
                MAX = MyTarget.angle + ANGLE_TOLERANCE;                
                if( (RxTarget.angle < MIN) || (RxTarget.angle > MAX) )
                {
                    sprintf(MyTestResults.DETECT_status, "FAIL: Angle");
                    test_state = 4;
                }
            } 
            else
            {
                sprintf(MyTestResults.DETECT_status, "FAIL: CAN Timeout");
                test_state = 4;
            } 
            
            LCD_Position(1,4);
            LCD_PrintString("      ");
            LCD_Position(1,4);
            sprintf( stringA, "%3.1f", MyTarget.range);
            LCD_PrintString(stringA);
            
            LCD_Position(1,12);
            LCD_PrintString("     ");
            LCD_Position(1,12);
            sprintf( stringB, "%2.0f", MyTarget.angle);
            LCD_PrintString(stringB);
            
            LCD_Position(2,4);
            LCD_PrintString("      ");
            LCD_Position(2,4);
            sprintf( stringC, "%3.1f", RxTarget.range);
            LCD_PrintString(stringC); 
            
            LCD_Position(2,12);
            LCD_PrintString("     ");
            LCD_Position(2,12);
            sprintf( stringA, "%2.0f", RxTarget.angle);
            LCD_PrintString(stringA);                       
        }       
    }
    else if(test_state == 4)
    {
        if(strncmp(MyTestResults.DETECT_status, "PASS", 4))
        {
            LCD_Position(3,0); 
            LCD_PrintString(MyTestResults.DETECT_status);      
            CyDelay(1000);
        }
        else
        {
            LCD_Position(3,0); 
            LCD_PrintString("Status: PASS"); 
        }
        
        test_state = 5;          
    }
    else
    {
        if(ManualModeFlag == 0)
        {
            STATE = RUN;
            test_state = 0;
        }            
    }

}

void TargetSimTest(void)
{
    if(ManualModeFlag == 0)
    {
        test_state = 3;
    }
        
    if(test_state == 0)
    {
        CAN_Stop();

        LCD_ClearDisplay();
        LCD_Position(0, 0); 
        LCD_PrintString("Target Simulation");  
  
        ButtonMode = 0;
        range_counter = 40;
        angle_counter = 0;
        amplitude_counter = AMPLITUDE_MAX;
        
        QuadDecoder_SetCounter(range_counter);

        prev_freq_counter = 0;
        prev_phase_counter = 180;
        prev_amplitude_counter = 0;
     
        IQ_SEL_HIGH;
        MUX_EN_LOW;   
              
        // The CAN test gets DUT_HzPerBin and DUT_FtPerBin.
        // They are required to run this test.
        if(!strncmp(MyTestResults.CAN_status, "PASS", 4))
        {
            test_state = 1;
        }
        else
        {
            test_state = 2;
        }  
        
    }
    else if(test_state == 1)
    {
        if(ButtonMode == 0)
        {
            range_counter = QuadDecoder_GetCounter();  
            if(range_counter < 1)
            {
                range_counter = 1; 
                QuadDecoder_SetCounter(range_counter);
            }
            if(range_counter > 140)
            {
                range_counter = 140; 
                QuadDecoder_SetCounter(range_counter);
            }
        }
  
        if(ButtonMode == 1)
        {
            angle_counter = QuadDecoder_GetCounter();
            if(angle_counter < -90)
            {
                angle_counter = -90;
                QuadDecoder_SetCounter(angle_counter);
            }
            if(angle_counter > 90)
            {
                angle_counter = 90;
                QuadDecoder_SetCounter(angle_counter);
            }
        }
        
        if(ButtonMode == 2)
        {
            amplitude_counter = QuadDecoder_GetCounter();
            if(amplitude_counter < 1)
            {
                amplitude_counter = 1;
                QuadDecoder_SetCounter(amplitude_counter);
            }
            if(amplitude_counter > AMPLITUDE_MAX)
            {
                amplitude_counter = AMPLITUDE_MAX;
                QuadDecoder_SetCounter(amplitude_counter);
            }
        }

        // Initialize a target.        
        MyTarget.range = range_counter;
        MyTarget.angle = angle_counter;
        MyTarget.amplitude = amplitude_counter;
        SetTarget(pMyTarget);    
    }
    else if(test_state == 2)
    {
        LCD_Position(1, 0); 
        LCD_PrintString("The CAN test must");
        LCD_Position(2, 0); 
        LCD_PrintString("be run first!");         
    }
    else
    {
        if(ManualModeFlag == 0)
        {
            STATE = RUN;
            test_state = 0;
        }              
    }
}   


void ProcessorVoltageTest(void)
{
    if(test_state == 0)
    {
        CAN_Stop();

        MUX1_HIGH;
        MUX2_HIGH;
        
        LCD_ClearDisplay();
                
        MyTestResults.Vsupply = 0.0;
        MyTestResults.Vdut = 0.0;
        MyTestResults.Vcore = 0.0;
        MyTestResults.Vovp = 0.0;
        MyTestResults.Vddr = 0.0;
        MyTestResults.Vddr_dl = 0.0;
        MyTestResults.Vanalog = 0.0;
        sprintf(MyTestResults.VOLT_status , "FAIL: Voltage");   // Assume it's going to fail.
        
        test_state = 1;
    }
    else if(test_state == 1)
    {    
        // Measure Vsupply
        AnalogMux_FastSelect(V0_Chan);
        ADC_StartConvert();
        while(!ADC_IsEndConversion(ADC_RETURN_STATUS));
        RawCount = ADC_GetResult32();
        if(RawCount > 0)
        {
            MyTestResults.Vsupply = (double)RawCount*ADC_RESOLUTION*(4.03); 
        }
        
        // Measure Vdut
        AnalogMux_FastSelect(V1_Chan);
        ADC_StartConvert();
        while(!ADC_IsEndConversion(ADC_RETURN_STATUS));
        RawCount = ADC_GetResult32();
        if(RawCount > 0)
        {
            MyTestResults.Vdut = (double)RawCount*ADC_RESOLUTION*(1.1);
        }
        
        // Measure Vcore
        AnalogMux_FastSelect(V2_Chan);
        ADC_StartConvert();
        while(!ADC_IsEndConversion(ADC_RETURN_STATUS));
        RawCount = ADC_GetResult32();
        if(RawCount > 0)
        {
            MyTestResults.Vcore = (double)RawCount*ADC_RESOLUTION*(1.1); 
        }
        
        // Measure Vovp
        AnalogMux_FastSelect(V3_Chan);
        ADC_StartConvert();
        while(!ADC_IsEndConversion(ADC_RETURN_STATUS));
        RawCount = ADC_GetResult32();
        if(RawCount > 0)
        {
            MyTestResults.Vovp = (double)RawCount*ADC_RESOLUTION*(11); 
        }
        
        // Measure Vddr
        AnalogMux_FastSelect(V4_Chan);
        ADC_StartConvert();
        while(!ADC_IsEndConversion(ADC_RETURN_STATUS));
        RawCount = ADC_GetResult32();
        if(RawCount > 0)
        {
            MyTestResults.Vddr = (double)RawCount*ADC_RESOLUTION;
        }
        
        // Measure Vddr_dl
        AnalogMux_FastSelect(V5_Chan);
        ADC_StartConvert();
        while(!ADC_IsEndConversion(ADC_RETURN_STATUS));
        RawCount = ADC_GetResult32();
        if(RawCount > 0)
        {
            MyTestResults.Vddr_dl = (double)RawCount*ADC_RESOLUTION;
        }

        // Measure Vcore
        AnalogMux_FastSelect(V6_Chan);
        ADC_StartConvert();
        while(!ADC_IsEndConversion(ADC_RETURN_STATUS));
        RawCount = ADC_GetResult32();
        if(RawCount > 0)
        {
            MyTestResults.Vanalog = (double)RawCount*ADC_RESOLUTION*(1.1);
        }
        
        test_state = 2;    
    }
    else if(test_state == 2)
    {
        // Determine PASS/FAIL
        sprintf(MyTestResults.VOLT_status , "PASS");
        if(MyTestResults.Vsupply < VSUP_MIN)
        {
            //sprintf(MyTestResults.VOLT_status, "FAIL: Vsupply low");
            // Uncomment the line above when a Vsupply test pin has been added to the test fixture.
        }
        else if( MyTestResults.Vsupply > VSUP_MAX)
        {
            sprintf(MyTestResults.VOLT_status, "FAIL: Vsupply high");  
        }
        else if( MyTestResults.Vdut < VDUT_MIN)
        {
            sprintf(MyTestResults.VOLT_status, "FAIL: Vdut low");  
        }       
        else if( MyTestResults.Vdut > VDUT_MAX)
        {
            sprintf(MyTestResults.VOLT_status, "FAIL: Vdut high");  
        }        
        else if( MyTestResults.Vcore < VCORE_MIN)
        {
            sprintf(MyTestResults.VOLT_status, "FAIL: Vcore low");  
        }       
        else if( MyTestResults.Vcore > VCORE_MAX)
        {
            sprintf(MyTestResults.VOLT_status, "FAIL: Vcore high");  
        }
        else if( MyTestResults.Vddr < VDDR_MIN)
        {
            sprintf(MyTestResults.VOLT_status, "FAIL: Vddr low");  
        }       
        else if( MyTestResults.Vddr > VDDR_MAX)
        {
            sprintf(MyTestResults.VOLT_status, "FAIL: Vddr high");  
        }
        else if( MyTestResults.Vddr_dl < VDL_MIN)
        {
            sprintf(MyTestResults.VOLT_status, "FAIL: Vdl low");  
        }       
        else if( MyTestResults.Vddr > VDL_MAX)
        {
            sprintf(MyTestResults.VOLT_status, "FAIL: Vdl high");  
        }   
        else if( MyTestResults.Vanalog < VANA_MIN)
        {
            sprintf(MyTestResults.VOLT_status, "FAIL: Vana low");  
        }       
        else if( MyTestResults.Vanalog > VANA_MAX)
        {
            sprintf(MyTestResults.VOLT_status, "FAIL: Vana high");  
        }
        else if( MyTestResults.Vovp < VOVP_MIN)
        {
            sprintf(MyTestResults.VOLT_status, "FAIL: Vovp low");  
        }       
        else if( MyTestResults.Vovp > VOVP_MAX)
        {
            sprintf(MyTestResults.VOLT_status, "FAIL: Vovp high");  
        }  
                
        // Output the results
        LCD_Position(0, 0);
        sprintf(stringA, " Vsup:%1.1f Vdut:%1.1f", MyTestResults.Vsupply, MyTestResults.Vdut);
        LCD_PrintString(stringA);  
        
        LCD_Position(1, 0);
        sprintf(stringB, "Vcore:%1.1f Vddr:%1.1f", MyTestResults.Vcore, MyTestResults.Vddr);
        LCD_PrintString(stringB);
        
        LCD_Position(2, 0);
        sprintf(stringC, "  Vdl:%2.1f Vana:%2.1f", MyTestResults.Vddr_dl, MyTestResults.Vanalog);
        LCD_PrintString(stringC);
        
        if(!strncmp(MyTestResults.VOLT_status, "PASS", 4))
        {
            LCD_Position(3, 0);
            sprintf(stringC, " Vovp:%2.1f PASS", MyTestResults.Vovp);
            LCD_PrintString(stringC);           
        }
        else
        {
            LCD_Position(3, 0);
            sprintf(stringC, " Vovp:%2.1f FAIL", MyTestResults.Vovp);
            LCD_PrintString(stringC);                      
        }          
       test_state = 3;
    }
    else
    {
        if(ManualModeFlag == 0)
        {
            STATE = RUN;
            test_state = 0;
        }
    }        
}

void SetTarget(TARGET* pTarget)
{     
    unsigned char SomethingChanged = 0;
    unsigned int frequencykHz = 0;
       
    double temp = 0.0;
    temp = (pTarget->range)*(1/DUT_FtPerBin);   // bin
    temp = temp*DUT_HzPerBin;                   // Hz.
    frequencykHz = (unsigned int)temp/1000; 
      
    // Adjust the DegreesPerStep as needed to produce nice signals.
    if(frequencykHz < 89)
    {
        DegreesPerStep = 10;
    }
    else if(frequencykHz < 179)
    {
        DegreesPerStep = 20;
    }
    else if(frequencykHz < 319)
    {
        DegreesPerStep = 40;   
    }
    else
    { 
        DegreesPerStep = 60;
    }

    // If the DegreesPerStep changes then the since wave table need to be re-calculated.
    if(PrevDegreesPerStep != DegreesPerStep)
    {
        PrevDegreesPerStep = DegreesPerStep;  
             
        GenerateSineWave1Table(amplitude_counter);
        GenerateSineWave2Table(amplitude_counter);
        GenerateSineWave3Table(amplitude_counter);
        GenerateSineWave4Table(amplitude_counter); 
        
        SomethingChanged = 1;
    }    
    
     // If the desired frequency isn't already being output then update the PWM.
    freq_counter = frequencykHz;
    if(freq_counter != prev_freq_counter )
    {    
        prev_freq_counter = freq_counter;         
        
        pwm_period = CalculatePwmPeriod();
        PWM_DMA_WritePeriod(pwm_period);
        PWM_DMA_WriteCompare(pwm_period/2); 
        
        unsigned int frequencyHz = 0;
        frequencyHz = CalculateFrequency(); 
        pTarget->frequency = frequencyHz;   // Update the target frequency.
        
        double actual_range = 0.0;
        actual_range = frequencyHz*(1/DUT_HzPerBin);    // bin
        actual_range = actual_range*DUT_FtPerBin;       // feet
        pTarget->range = actual_range;  // Update the range.      
        
        if(STATE == TARGET_SIM_TEST)
        {
            LCD_Position(1, 0);
            LCD_PrintString("                    "); 
            
            LCD_Position(1, 0);        
            sprintf(stringA, "Rng:%uft", (unsigned int)actual_range);    
            LCD_PrintString(stringA);
            
            LCD_Position(1, 10);        
            sprintf(stringB, "f:%uHz", (unsigned int)frequencyHz);    
            LCD_PrintString(stringB);      
        } 
        
        SomethingChanged = 1;
    }   
 
    double radians = 0.0174533*(pTarget->angle);
    phase_counter = (3.14159)*sin(radians);         // Radians
    phase_counter = (360.0/6.28318)*phase_counter;  // Degrees
    phase_counter = phase_counter*-1;               // To make my sign match Cole's.
    pTarget->phase = phase_counter;
    if(phase_counter != prev_phase_counter)
    {     
        prev_phase_counter = phase_counter;       
                      
        GenerateSineWave3Table(amplitude_counter);
        GenerateSineWave4Table(amplitude_counter);   
        
        if(STATE == TARGET_SIM_TEST)
        {
            LCD_Position(2, 0); 
            LCD_PrintString("                    "); 
        
            LCD_Position(2, 0);
            sprintf(stringA, "Ang:%i", (int)pTarget->angle); 
            LCD_PrintString(stringA); 
            
            LCD_Position(2, 10);
            sprintf(stringB, "Phz:%i", (int)phase_counter*-1); 
            LCD_PrintString(stringB); 
        } 
        
        SomethingChanged = 1;
    }
    
    if(pTarget->amplitude > AMPLITUDE_MAX)
    {
        pTarget->amplitude = AMPLITUDE_MAX;
    }

    double amplitude_voltage = (0.809)*amplitude_counter;

    if(amplitude_counter != prev_amplitude_counter)
    {      
        prev_amplitude_counter = amplitude_counter;
     
        GenerateSineWave1Table(amplitude_counter);
        GenerateSineWave2Table(amplitude_counter);
        GenerateSineWave3Table(amplitude_counter);
        GenerateSineWave4Table(amplitude_counter);  
        
        if(STATE == TARGET_SIM_TEST)
        {
            LCD_Position(3, 0); 
            LCD_PrintString("                    "); 
            
            LCD_Position(3, 0);
            double temp = ((double)amplitude_counter/AMPLITUDE_MAX)*100.0;
            sprintf(stringA, "Amp:%u%%", (unsigned int)temp); 
            LCD_PrintString(stringA);
            
            LCD_Position(3, 10); 
            sprintf(stringB, "Amp:%umV", (unsigned int)amplitude_voltage); 
            LCD_PrintString(stringB);
        } 
        
        SomethingChanged = 1;
    } 
    
    if(SomethingChanged)
    {
        ResetAllDMAs();
    }
    
}

void GenerateSineWave1Table(unsigned int Amplitude)
{     
    double Degrees;
    
    unsigned int index = 0; 
    for(index = 0; index < MAX_TABLE_SIZE; index++)
    {
        Degrees = index*DegreesPerStep;
        double radians = 0.0174533*Degrees;
        SineWave1Table[index] = (unsigned int)(Amplitude/2 + (Amplitude/2)*sin(radians));
    }  
}

void GenerateSineWave2Table(unsigned int Amplitude)
{
    double Degrees;
    
    unsigned int index = 0; 
    for(index = 0; index < MAX_TABLE_SIZE; index++)
    {
        Degrees = index*DegreesPerStep;
        double radians = (0.0174533*Degrees)+(3.14159/2);
        double temp = ((double)Amplitude/2.0 + ((double)Amplitude/2.0)*sin(radians));
        SineWave2Table[index] = (unsigned int)temp;
    }          
}

void GenerateSineWave3Table(unsigned int Amplitude)
{    
    Amplitude = Amplitude*0.698412; // The I1_DAC and Q1_DAC signals have twice the electrical load as the I2_DAC and Q2_DAC signals.
                                    // Therefore, the output voltage of I1 & Q1 are slightly lower then I2 & Q2.
                                    // The amplitude is scaled here to compensate.
                                    // TO DO: Route the I/Q DAC outputs through the internal Op Amp to buffer th DAC output.
    
    double Degrees;
    
    unsigned int index = 0; 
    for(index = 0; index < MAX_TABLE_SIZE; index++)
    {
        Degrees = index*DegreesPerStep;
        double radians = 0.0174533*(Degrees-180-phase_counter);
        double temp = ((double)Amplitude/2.0 + ((double)Amplitude/2.0)*sin(radians));
        SineWave3Table[index] = (unsigned int)temp;
    }  
}

void GenerateSineWave4Table(unsigned int Amplitude)
{    
    Amplitude = Amplitude*0.625000; // The I1_DAC and Q1_DAC signals have twice the electrical load as the I2_DAC and Q2_DAC signals.
                                    // Therefore, the output voltage of I1 & Q1 are slightly lower then I2 & Q2.
                                    // The amplitude is scaled here to compensate.
                                    // TO DO: Route the I/Q DAC outputs through the internal Op Amp to buffer th DAC output.
    
    double Degrees;
    
    unsigned int index = 0; 
    for(index = 0; index < MAX_TABLE_SIZE; index++)
    {
        Degrees = index*DegreesPerStep;
        double radians = 0.0174533*(Degrees-180-phase_counter)+(3.14159/2);
        SineWave4Table[index] = (unsigned int)(Amplitude/2 + (Amplitude/2)*sin(radians));
    }  
}

unsigned int CalculateFrequency(void)
{
    double temp;
    double freqKHz;
    int period_count;
    
    period_count = PWM_DMA_ReadPeriod();
    temp = (period_count+1)*0.0000000125;
    temp = temp*360;
    freqKHz = 1.0/temp;
    freqKHz = freqKHz*DegreesPerStep;
     
    unsigned int frequency_temp;
    frequency_temp = (unsigned int)freqKHz;
    
    return frequency_temp;
}

unsigned int CalculatePwmPeriod(void)
{
    unsigned int period_count;   
    period_count = PwmPeriodTable[freq_counter];
    return period_count;
}

void ResetAllDMAs(void)
{
    CAN_Stop();
    PWM_DMA_Stop();
     
    //uint8 dma_error = CyDmacError();
    //CyDmacClearError(dma_error);

#define METHOD1
#ifdef METHOD1
    
    CyDmaChSetRequest(DMA_1_Chan, CY_DMA_CPU_TERM_CHAIN); // Terminate the entire chain of TD's
    CyDelay(100);
    //while(CyDmaChGetRequest(DMA_1_Chan));                 // Wait for the request to be processed.
    //CyDmaChSetInitialTd(DMA_1_Chan, DMA_1_TD[0]);         // Set the initial TD.
    CyDmaChEnable(DMA_1_Chan, 1);                         // Re-enable the DMA channel. 
    
    CyDmaChSetRequest(DMA_2_Chan, CY_DMA_CPU_TERM_CHAIN); // Terminate the entire chain of TD's
    CyDelay(100);
    //while(CyDmaChGetRequest(DMA_2_Chan));                 // Wait for the request to be processed.
    //CyDmaChSetInitialTd(DMA_2_Chan, DMA_2_TD[0]);         // Set the initial TD.
    CyDmaChEnable(DMA_2_Chan, 1);                         // Re-enable the DMA channel.
    
    CyDmaChSetRequest(DMA_3_Chan, CY_DMA_CPU_TERM_CHAIN); // Terminate the entire chain of TD's
    CyDelay(100);
    //while(CyDmaChGetRequest(DMA_3_Chan));                 // Wait for the request to be processed.
    //CyDmaChSetInitialTd(DMA_3_Chan, DMA_3_TD[0]);         // Set the initial TD.
    CyDmaChEnable(DMA_3_Chan, 1);                         // Re-enable the DMA channel.
    
    CyDmaChSetRequest(DMA_4_Chan, CY_DMA_CPU_TERM_CHAIN); // Terminate the entire chain of TD's
    CyDelay(100);
    //while(CyDmaChGetRequest(DMA_4_Chan));                 // Wait for the request to be processed.
    //CyDmaChSetInitialTd(DMA_4_Chan, DMA_4_TD[0]);         // Set the initial TD.
    CyDmaChEnable(DMA_4_Chan, 1);                         // Re-enable the DMA channel.
   
#else
    
    // DMA Configuration for DMA_1 
    DMA_1_Chan = DMA_1_DmaInitialize(DMA_1_BYTES_PER_BURST, DMA_1_REQUEST_PER_BURST, HI16(DMA_1_SRC_BASE), HI16(DMA_1_DST_BASE));
    DMA_1_TD[0] = CyDmaTdAllocate();
    CyDmaTdSetConfiguration(DMA_1_TD[0], MAX_TABLE_SIZE, DMA_1_TD[0], TD_INC_SRC_ADR | DMA_1__TD_TERMOUT_EN);
    CyDmaTdSetAddress(DMA_1_TD[0], LO16((uint32)pSineWave1), LO16((uint32)VDAC8_1_Data_PTR));
    CyDmaChSetInitialTd(DMA_1_Chan, DMA_1_TD[0]);
    CyDmaChEnable(DMA_1_Chan, 1);

    // DMA Configuration for DMA_2 
    DMA_2_Chan = DMA_2_DmaInitialize(DMA_2_BYTES_PER_BURST, DMA_2_REQUEST_PER_BURST, HI16(DMA_2_SRC_BASE), HI16(DMA_2_DST_BASE));
    DMA_2_TD[0] = CyDmaTdAllocate();
    CyDmaTdSetConfiguration(DMA_2_TD[0], MAX_TABLE_SIZE, DMA_2_TD[0], TD_INC_SRC_ADR | DMA_2__TD_TERMOUT_EN);
    CyDmaTdSetAddress(DMA_2_TD[0], LO16((uint32)pSineWave2), LO16((uint32)VDAC8_2_Data_PTR));
    CyDmaChSetInitialTd(DMA_2_Chan, DMA_2_TD[0]);
    CyDmaChEnable(DMA_2_Chan, 1); 

    // DMA Configuration for DMA_3 
    DMA_3_Chan = DMA_3_DmaInitialize(DMA_3_BYTES_PER_BURST, DMA_3_REQUEST_PER_BURST, HI16(DMA_3_SRC_BASE), HI16(DMA_3_DST_BASE));
    DMA_3_TD[0] = CyDmaTdAllocate();
    CyDmaTdSetConfiguration(DMA_3_TD[0], MAX_TABLE_SIZE, DMA_3_TD[0], TD_INC_SRC_ADR | DMA_3__TD_TERMOUT_EN);
    CyDmaTdSetAddress(DMA_3_TD[0], LO16((uint32)pSineWave3), LO16((uint32)VDAC8_3_Data_PTR));
    CyDmaChSetInitialTd(DMA_3_Chan, DMA_3_TD[0]);
    CyDmaChEnable(DMA_3_Chan, 1);
    
    // DMA Configuration for DMA_4 
    DMA_4_Chan = DMA_4_DmaInitialize(DMA_4_BYTES_PER_BURST, DMA_4_REQUEST_PER_BURST, HI16(DMA_4_SRC_BASE), HI16(DMA_4_DST_BASE));
    DMA_4_TD[0] = CyDmaTdAllocate();
    CyDmaTdSetConfiguration(DMA_4_TD[0], MAX_TABLE_SIZE, DMA_4_TD[0], TD_INC_SRC_ADR | DMA_4__TD_TERMOUT_EN);
    CyDmaTdSetAddress(DMA_4_TD[0], LO16((uint32)pSineWave4), LO16((uint32)VDAC8_4_Data_PTR));
    CyDmaChSetInitialTd(DMA_4_Chan, DMA_4_TD[0]);
    CyDmaChEnable(DMA_4_Chan, 1); 
    
#endif
 
    PWM_DMA_Start();
    CAN_Start();
}

void RevertToFactoryDefaults(void)
{
    CAN_Start();
    
    uint8 CanRxBuffer[8] = {0,0,0,0,0,0,0,0};
    uint8* pCanRxBuffer = &CanRxBuffer[0];
    SendSrvcToolCmd(CMD_ENT_FACT_CAL_MODE, pCanRxBuffer);       // Enter Factory Cal. mode.
    SendSrvcToolCmd(CMD_REVERT_FACTORY_DEFAULTS, pCanRxBuffer); // Revert to factory defaults.
    
    CAN_Stop();
}


double GetInputVoltage(void)
{   
    volatile double voltage = 0.0;
    
    AnalogMux_FastSelect(Vin_Chan);
    ADC_StartConvert();
    while(!ADC_IsEndConversion(ADC_RETURN_STATUS));
    RawCount = ADC_GetResult16();
    voltage = (double)RawCount*ADC_RESOLUTION*16;   
    
    return voltage;
}

double GetProcessorCurrent(void)
{   
    volatile double current = 0.0;
    
    AnalogMux_FastSelect(Idut_Chan);
    ADC_StartConvert();
    while(!ADC_IsEndConversion(ADC_RETURN_STATUS));
    RawCount = ADC_GetResult16();
    current = (double)RawCount*ADC_RESOLUTION/(1.8);   
    
    return current;
}

double GetAntennaCurrent(void)
{   
    volatile double current = 0.0;
    
    AnalogMux_FastSelect(Iant_Chan);
    ADC_StartConvert();
    while(!ADC_IsEndConversion(ADC_RETURN_STATUS));
    RawCount = ADC_GetResult16();
    current = (double)RawCount*ADC_RESOLUTION/(2.0);   
    
    return current;
}

void ShowAntennaTestResults(void)
{ 
    unsigned char FailFlag = 0;
    uint8 line_num = 0;
    
    if(test_state == 0)
    {   
        LCD_ClearDisplay();
        
        if(strncmp(MyAntTestResults.CapSenseTop_status, "PASS", 4))
        {
            FailFlag = 1;
            if(line_num < 3)
            {
                LCD_Position(line_num,0);
                LCD_PrintString(MyAntTestResults.CapSenseTop_status); 
                line_num++;
            }           
        }
        
        if(strncmp(MyAntTestResults.CapSenseBottom_status, "PASS", 4))
        {
            FailFlag = 1;
            if(line_num < 3)
            {
                LCD_Position(line_num,0);
                LCD_PrintString(MyAntTestResults.CapSenseBottom_status); 
                line_num++;
            }           
        }
        
        if(strncmp(MyAntTestResults.Current_status, "PASS", 4))
        {
            FailFlag = 1;
            if(line_num < 3)
            {
                LCD_Position(line_num,0);
                LCD_PrintString(MyAntTestResults.Current_status); 
                line_num++;
            }           
        }   

        if(strncmp(MyAntTestResults.TxPower_status, "PASS", 4))
        {
            FailFlag = 1;
            if(line_num < 3)
            {
                LCD_Position(line_num,0);
                LCD_PrintString(MyAntTestResults.TxPower_status); 
                line_num++;
            }           
        }
        
        if(strncmp(MyAntTestResults.PLL_status, "PASS", 4))
        {
            FailFlag = 1;
            if(line_num < 3)
            {
                LCD_Position(line_num,0);
                LCD_PrintString(MyAntTestResults.PLL_status); 
                line_num++;
            }           
        }

        MyAntTestResults.TotalTestTime = 0xFFFF - TestTimer_ReadCounter(); 

        if(FailFlag)
        {
            LED_GRN_OFF;
            LED_RED_ON;
        }
        else
        {
            LED_GRN_ON;
            LED_RED_OFF;
            
            LCD_Position(0,0);
            LCD_PrintString("PASS!! PASS!! PASS!!"); 
            
            LCD_Position(1,0);
            LCD_PrintString("PASS!! PASS!! PASS!!");       
        }
        
        LCD_Position(3,0);
        double seconds = MyAntTestResults.TotalTestTime/1000.0;
        sprintf(stringA, "Test Time: %2.1f sec", seconds);
        LCD_PrintString(stringA);       
        test_state = 1;
    }
    else
    {
        if(ManualModeFlag == 0)
        {
            STATE = RUN;
            test_state = 0;
        }
    }
}

void ShowProcessorTestResults(void)
{
    unsigned char FailFlag = 0;
    
    if(test_state == 0)
    {
        RevertToFactoryDefaults();
        
        uint8 line_num = 0;
        
        LCD_ClearDisplay();
        
        if(strncmp(MyTestResults.Current_status, "PASS", 4))
        {
            FailFlag = 1;
            if(line_num < 3)
            {
                LCD_Position(line_num,0);
                LCD_PrintString(MyTestResults.Current_status); 
                line_num++;
            }           
        }
        
        if(strncmp(MyTestResults.CAN_status, "PASS", 4))
        {
            FailFlag = 1;
            if(line_num < 3)
            {
                LCD_Position(line_num,0);
                LCD_PrintString(MyTestResults.CAN_status); 
                line_num++;
            }
        }

        if(strncmp(MyTestResults.REV_status, "PASS", 4))
        {
            FailFlag = 1;
            if(line_num < 3)
            {
                LCD_Position(line_num,0);
                LCD_PrintString(MyTestResults.REV_status);
                line_num++;
            }
        }  
        
        if(strncmp(MyTestResults.DISP_status, "PASS", 4))
        {
            FailFlag = 1;
            if(line_num < 3)
            {
                LCD_Position(line_num,0);
                LCD_PrintString(MyTestResults.DISP_status);
                line_num++;
            }
        }

        if(MyTestResults.DUT_SingleWireComm)
        {
            if(strncmp(MyTestResults.SingleWire_status, "PASS", 4))
            {
                FailFlag = 1;  
                if(line_num < 3)
                {
                    LCD_Position(line_num,0);
                    LCD_PrintString(MyTestResults.SingleWire_status);
                    line_num++;
                }
            }            
        }
        else
        {
            if(strncmp(MyTestResults.ALARM_status, "PASS", 4))
            {
                FailFlag = 1;
                if(line_num < 3)
                {
                    LCD_Position(line_num,0);
                    LCD_PrintString(MyTestResults.ALARM_status); 
                    line_num++;
                }
            }
        }
        
        if(strncmp(MyTestResults.VOLT_status, "PASS", 4))
        {
            FailFlag = 1;
            if(line_num < 3)
            {
                LCD_Position(line_num,0);
                LCD_PrintString(MyTestResults.VOLT_status); 
                line_num++;
            }
        }

        if(strncmp(MyTestResults.DETECT_status, "PASS", 4))
        {
            FailFlag = 1;
            if(line_num < 3)
            {
                LCD_Position(line_num,0);
                LCD_PrintString(MyTestResults.DETECT_status);
                line_num++;
            }
        }
        
        if(strncmp(MyTestResults.IQ_status, "PASS", 4))
        {
            FailFlag = 1;
            if(line_num < 3)
            {
                LCD_Position(line_num,0);
                LCD_PrintString(MyTestResults.IQ_status); 
                line_num++;
            }
        } 
        
        MyTestResults.TotalTestTime = 0xFFFF - TestTimer_ReadCounter();
        
        if(FailFlag)
        {
            LED_GRN_OFF;
            LED_RED_ON; 
        }
        else
        {
            LED_GRN_ON;
            LED_RED_OFF;
            
            LCD_Position(0,0);
            LCD_PrintString("PASS!! PASS!! PASS!!"); 
            
            LCD_Position(1,0);
            LCD_PrintString("PASS!! PASS!! PASS!!"); 
     
        }
        
        LCD_Position(3,0);
        double seconds = MyTestResults.TotalTestTime/1000.0;
        sprintf(stringA, "Test Time: %2.1f sec", seconds);
        LCD_PrintString(stringA);
      
        test_state = 1;
    }
    else
    {
        if(ManualModeFlag == 0)
        {
            STATE = RUN;
            test_state = 0;
        }
    }
}

unsigned char GetAntennaRev(void)
{
    unsigned char Revision = 0;

    double temp = 0.0;
    
    // Measure Antenna Revision
    AnalogMux_FastSelect(AntRev_Chan);
    ADC_StartConvert();
    while(!ADC_IsEndConversion(ADC_RETURN_STATUS));
    RawCount = ADC_GetResult32();
    if(RawCount > 0)
    {
        temp = RawCount*ADC_RESOLUTION; 
    }
    
    temp = round(temp*10);
    
    Revision = (unsigned char)temp;
    
    return Revision;
}

void CapSenseTest(void)
{
    unsigned int CapValue = 0;
    unsigned int* pCapValue = &CapValue;
    
    if(test_state == 0)
    {
        LCD_ClearDisplay();
        LCD_Position(0,0);
        LCD_PrintString("Cap Sense Test");
     
        sprintf(MyAntTestResults.CapSenseTop_status, "CAP1 Started");
        if(MPR_Init(CAP_SENSE_TOP_I2C_ADDR))
        {
            sprintf(MyAntTestResults.CapSenseTop_status, "PASS"); 
           
            if(MPR_GetCapData(CAP_SENSE_TOP_I2C_ADDR, pCapValue))
            {
                if(CapValue > 50)
                {
                    sprintf(MyAntTestResults.CapSenseTop_status, "FAIL: Top Spring");
                }
            }
        }
        else
        {
            sprintf(MyAntTestResults.CapSenseTop_status, "FAIL: Cap Top");   
        }
        
        LCD_Position(1,0);
        if(!strncmp(MyAntTestResults.CapSenseTop_status, "PASS", 4))
        {  
            LCD_PrintString("Top: PASS");
        }
        else
        {
            LCD_PrintString("Top: FAIL");       
        }
         
        sprintf(MyAntTestResults.CapSenseBottom_status, "CAP2 Started");
        if(MPR_Init(CAP_SENSE_BOT_I2C_ADDR))
        {
            sprintf(MyAntTestResults.CapSenseBottom_status, "PASS"); 
            
            if(MPR_GetCapData(CAP_SENSE_BOT_I2C_ADDR, pCapValue))
            {
                if(CapValue > 50)
                {
                    sprintf(MyAntTestResults.CapSenseTop_status, "FAIL: Bottom Spring");
                }
            }            
        }
        else
        {
            sprintf(MyAntTestResults.CapSenseBottom_status, "FAIL: Cap Bottom");   
        }
        
        LCD_Position(2,0);
        if(!strncmp(MyAntTestResults.CapSenseBottom_status, "PASS", 4))
        {  
            LCD_PrintString("Bottom: PASS");
        }
        else
        {
            LCD_PrintString("Bottom: FAIL");       
        }
        
        CyDelay(1000);
        
        test_state = 1;
        
    }
    else
    {
        if(ManualModeFlag == 0)
        {
            STATE = RUN;
            test_state = 0;
        }        
    }
    
}



/* [] END OF FILE */
